'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-2a6e6244.js');
const store = require('./store-fe3d3434.js');

const bpSdkFilterContainerCss = "";

let BpSdkFilterContainer = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.isHidden = false;
    this.useExternal = false;
    this.handleSubscriptions = () => {
      if (store.canGetStore()) {
        this.storeUnsubscribe && this.storeUnsubscribe();
        this.storeUnsubscribe = store.store.mapStateToProps(this, this.mapStateToProps);
      }
    };
    this.mapStateToProps = (state) => {
      return {
        isHidden: !!(this.filter && this.filter(state)),
      };
    };
  }
  resetState() { }
  onFilterChange() {
    this.handleSubscriptions();
  }
  connectedCallback() {
    this.resetState();
    this.handleSubscriptions();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-filter-container');
    customElements.whenDefined('bp-sdk-external-filter-container').then(() => {
      this.useExternal = true;
    });
    this.onFilterChange();
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return index.h("bp-sdk-external-filter-container", { filter: this.filter, isHidden: this.isHidden });
  }
  renderInternal() {
    return (!this.isHidden && (index.h("div", { class: "bp-sdk-filter-container__container" }, index.h("host", null))));
  }
  static get watchers() { return {
    "filter": ["onFilterChange"]
  }; }
};
BpSdkFilterContainer.style = bpSdkFilterContainerCss;

exports.bp_sdk_filter_container = BpSdkFilterContainer;
