'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-2a6e6244.js');
const index_esm_min = require('./index.esm.min-83391a19.js');

const bpSdkVehicleVinInputContainerCss = "";

let BpSdkVehicleVinInputContainer = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.vinUpdate = index.createEvent(this, "vinUpdate", 7);
    this.code = index_esm_min.fx(8);
    this.useExternal = false;
    this.touched = false;
    this.pristine = true;
    this.errors = [];
    this.onFocusOut = () => {
      this.touched = true;
      this.updateErrors(this.pristine, true, this.value);
    };
  }
  resetState() {
    this.touched = false;
    this.pristine = true;
    this.errors = [];
  }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-vehicle-vin-input-container');
    customElements.whenDefined('bp-sdk-external-vehicle-vin-input-container').then(() => {
      this.useExternal = true;
    });
  }
  loadFocusEvents() {
    if (!this.useExternal) {
      this.el.addEventListener('focusout', this.onFocusOut);
    }
  }
  unloadFocusEvents() {
    this.el.removeEventListener('focusout', this.onFocusOut);
  }
  componentDidLoad() {
    this.loadFocusEvents();
  }
  disconnectedCallback() {
    this.unloadFocusEvents();
  }
  onValueUpdate(evt) {
    var _a;
    if (this.useExternal) {
      return;
    }
    this.pristine = false;
    this.value = ((_a = evt.detail) !== null && _a !== void 0 ? _a : [])[0];
    this.updateErrors(false, this.touched, this.value);
    if (this.errors.length === 0) {
      this.vinUpdate.emit({ vin: this.value, answerId: this.answerId });
    }
  }
  updateErrors(pristine, touched, value) {
    this.errors = index_esm_min.u4(pristine, touched, value) ? ['required'] : [];
  }
  onMakeDirty() {
    this.touched = true;
    this.pristine = false;
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return index.h("bp-sdk-external-vehicle-vin-input-container", null);
  }
  renderInternal() {
    return (index.h("bp-sdk-vehicle-vin-input", { value: this.value, code: this.code, label: "Enter vehicle VIN", touched: this.touched, pristine: this.pristine, errors: this.errors }));
  }
  get el() { return index.getElement(this); }
};
BpSdkVehicleVinInputContainer.style = bpSdkVehicleVinInputContainerCss;

exports.bp_sdk_vehicle_vin_input_container = BpSdkVehicleVinInputContainer;
