import { Component, Prop, h, State, Event } from '@stencil/core';
export class BpSdkAddItemContainer {
  constructor() {
    /**
     * Help text
     */
    this.helpText = '';
    /**
     * Add button text
     */
    this.text = '+';
    /**
     * Can add more state
     */
    this.canAddMore = true;
    this.useExternal = false;
    this.handleClick = () => {
      this.addItem.emit();
    };
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-add-item-container');
    customElements.whenDefined('bp-sdk-external-add-item-container').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return [
      h("slot", null),
      h("bp-sdk-external-add-item-container", { helpText: this.helpText, text: this.text, canAddMore: this.canAddMore, icon: this.icon }),
    ];
  }
  renderInternal() {
    return (h("div", { class: "bp-sdk-add-item__container" },
      h("slot", null),
      this.canAddMore && (h("div", { class: "bp-sdk-add-item__wrapper" },
        h("bp-sdk-icon-container", { name: this.icon }),
        this.helpText && h("h4", { class: "bp-sdk-add-item__help-text" }, this.helpText),
        h("bp-sdk-button", { onClick: this.handleClick, text: this.text })))));
  }
  static get is() { return "bp-sdk-add-item-container"; }
  static get originalStyleUrls() { return {
    "$": ["./bp-sdk-add-item-container.css"]
  }; }
  static get styleUrls() { return {
    "$": ["bp-sdk-add-item-container.css"]
  }; }
  static get properties() { return {
    "helpText": {
      "type": "string",
      "mutable": false,
      "complexType": {
        "original": "string",
        "resolved": "string",
        "references": {}
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": "Help text"
      },
      "attribute": "help-text",
      "reflect": false,
      "defaultValue": "''"
    },
    "text": {
      "type": "string",
      "mutable": false,
      "complexType": {
        "original": "string",
        "resolved": "string",
        "references": {}
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": "Add button text"
      },
      "attribute": "text",
      "reflect": false,
      "defaultValue": "'+'"
    },
    "canAddMore": {
      "type": "boolean",
      "mutable": false,
      "complexType": {
        "original": "boolean",
        "resolved": "boolean",
        "references": {}
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": "Can add more state"
      },
      "attribute": "can-add-more",
      "reflect": false,
      "defaultValue": "true"
    },
    "icon": {
      "type": "string",
      "mutable": false,
      "complexType": {
        "original": "string",
        "resolved": "string",
        "references": {}
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": "Icon name"
      },
      "attribute": "icon",
      "reflect": false
    }
  }; }
  static get states() { return {
    "useExternal": {}
  }; }
  static get events() { return [{
      "method": "addItem",
      "name": "addItem",
      "bubbles": true,
      "cancelable": true,
      "composed": true,
      "docs": {
        "tags": [],
        "text": "Add Item event"
      },
      "complexType": {
        "original": "void",
        "resolved": "void",
        "references": {}
      }
    }]; }
}
