import { Component, h, State, Prop } from '@stencil/core';
export class BpSdkBusinessClassificationSelectorCardBody {
  constructor() {
    this.useExternal = false;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-business-classification-selector-card-body');
    customElements.whenDefined('bp-sdk-external-business-classification-selector-card-body').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return h("bp-sdk-external-business-classification-selector-card-body", { explanation: this.explanation });
  }
  renderInternal() {
    return (h("div", { class: "'bp-sdk-business-classification-selector-card-body__container'" },
      h("div", { class: "bp-sdk-business-classification-selector-card-body__text", innerHTML: this.explanation || '' })));
  }
  static get is() { return "bp-sdk-business-classification-selector-card-body"; }
  static get originalStyleUrls() { return {
    "$": ["./bp-sdk-business-classification-selector-card-body.css"]
  }; }
  static get styleUrls() { return {
    "$": ["bp-sdk-business-classification-selector-card-body.css"]
  }; }
  static get properties() { return {
    "explanation": {
      "type": "string",
      "mutable": false,
      "complexType": {
        "original": "string",
        "resolved": "string",
        "references": {}
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": "Explanation of choice"
      },
      "attribute": "explanation",
      "reflect": false
    }
  }; }
  static get states() { return {
    "useExternal": {}
  }; }
}
