import { Component, h, Prop, State } from '@stencil/core';
import { canGetStore } from '../../utils/store';
import { store } from '@stencil/redux';
import { getApplicationState } from '@boldpenguin/sdk-redux';
export class BpSdkFilterApplicationFormStateContainer {
  constructor() {
    this.useExternal = false;
    this.handleSubscriptions = () => {
      if (canGetStore()) {
        this.storeUnsubscribe && this.storeUnsubscribe();
        this.storeUnsubscribe = store.mapStateToProps(this, this.mapStateToProps);
      }
    };
    this.mapStateToProps = (state) => {
      return {
        state: getApplicationState(state),
      };
    };
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
    this.handleSubscriptions();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-filter-application-form-state-container');
    customElements.whenDefined('bp-sdk-external-filter-application-form-state-container').then(() => {
      this.useExternal = true;
    });
    this.handleSubscriptions();
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return h("bp-sdk-external-filter-application-form-state-container", { targetState: this.targetState, state: this.state });
  }
  renderInternal() {
    return (this.state === this.targetState && (h("div", { class: "bp-sdk-filter-application-form-state-container__container" },
      h("host", null))));
  }
  static get is() { return "bp-sdk-filter-application-form-state-container"; }
  static get originalStyleUrls() { return {
    "$": ["./bp-sdk-filter-application-form-state-container.css"]
  }; }
  static get styleUrls() { return {
    "$": ["bp-sdk-filter-application-form-state-container.css"]
  }; }
  static get properties() { return {
    "targetState": {
      "type": "string",
      "mutable": false,
      "complexType": {
        "original": "ApplicationFormStates | undefined",
        "resolved": "ApplicationFormStates.Completed | ApplicationFormStates.InProgress | ApplicationFormStates.Incomplete | ApplicationFormStates.Quoted",
        "references": {
          "ApplicationFormStates": {
            "location": "import",
            "path": "@boldpenguin/sdk-types"
          }
        }
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": ""
      },
      "attribute": "target-state",
      "reflect": false
    },
    "state": {
      "type": "string",
      "mutable": true,
      "complexType": {
        "original": "ApplicationFormStates | undefined",
        "resolved": "ApplicationFormStates.Completed | ApplicationFormStates.InProgress | ApplicationFormStates.Incomplete | ApplicationFormStates.Quoted",
        "references": {
          "ApplicationFormStates": {
            "location": "import",
            "path": "@boldpenguin/sdk-types"
          }
        }
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": ""
      },
      "attribute": "state",
      "reflect": false
    }
  }; }
  static get states() { return {
    "useExternal": {}
  }; }
}
