import { r as registerInstance, h } from './index-b4e0290f.js';
import { s as store$1, c as canGetStore } from './store-6dda1ad2.js';
import { store, setWebSocketConfig } from '@boldpenguin/sdk-redux';

let BpSdkRoot = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    /**
     * Disable web socket
     */
    this.disableWebSocket = false;
    /**
     * Disable lifecycle events, false by default
     */
    this.enableLifecycleEvents = false;
    /**
     * Disable toolbar
     */
    this.disableToolbar = false;
    this.storeLoaded = false;
  }
  onDisabledWebSocket(disableWebSocket) {
    store.dispatch(setWebSocketConfig({ enableWebsocket: !disableWebSocket }));
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    store$1.setStore(store);
    this.storeLoaded = true;
    this.onDisabledWebSocket(this.disableWebSocket);
  }
  render() {
    if (!canGetStore()) {
      return null;
    }
    return (this.storeLoaded && (h("bp-sdk-setup-container", null, [!!this.enableLifecycleEvents && h("bp-sdk-custom-event-container", null), !this.disableToolbar && h("bp-sdk-interview-toolbar", null)], h("slot", null))));
  }
  static get watchers() { return {
    "disableWebSocket": ["onDisabledWebSocket"]
  }; }
};

export { BpSdkRoot as bp_sdk_root };
