import { ITakeOverComponent } from '@boldpenguin/sdk-types';
export declare class BpSdkTakeOver implements ITakeOverComponent {
  /**
   * Flag to indicate if application form is locked
   */
  isLocked: boolean;
  /**
   * Flag to indicate if application form is cloned
   */
  isCloned: boolean;
  /**
   * Flag to indicate if user has permission to take over application form
   */
  canTakeOver: boolean;
  /**
   * Flag to indicate if user is owner of application form
   */
  isOwner: boolean;
  /**
   * Flag to indicate if there is an application form currently loaded
   */
  isFormLoaded: boolean;
  /**
   * Take over handler function
   */
  takeOverHandler: () => void;
  useExternal: boolean;
  resetState(): void;
  connectedCallback(): void;
  componentWillLoad(): void;
  shouldRender(): boolean;
  render(): any[];
  renderExternal(): any;
  renderInternal(): any;
}
