'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-2a6e6244.js');
const store = require('./store-fe3d3434.js');
const sdkRedux = require('@boldpenguin/sdk-redux');
const debounce = require('./debounce-5ee836a2.js');
const index_esm_min = require('./index.esm.min-83391a19.js');
const isEqual = require('./isEqual-30f1b2bc.js');
const _baseUniq = require('./_baseUniq-5f1f00d2.js');
const index_esm_min$1 = require('./index.esm.min-2804e8af.js');
const _commonjsHelpers = require('./_commonjsHelpers-bcc1208a.js');
const vehicleVin_service = require('./vehicle-vin.service-83d350a4.js');

const bpSdkAddItemContainerCss = "";

let BpSdkAddItemContainer = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.addItem = index.createEvent(this, "addItem", 7);
    /**
     * Help text
     */
    this.helpText = '';
    /**
     * Add button text
     */
    this.text = '+';
    /**
     * Can add more state
     */
    this.canAddMore = true;
    this.useExternal = false;
    this.handleClick = () => {
      this.addItem.emit();
    };
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-add-item-container');
    customElements.whenDefined('bp-sdk-external-add-item-container').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return [
      index.h("slot", null),
      index.h("bp-sdk-external-add-item-container", { helpText: this.helpText, text: this.text, canAddMore: this.canAddMore, icon: this.icon }),
    ];
  }
  renderInternal() {
    return (index.h("div", { class: "bp-sdk-add-item__container" }, index.h("slot", null), this.canAddMore && (index.h("div", { class: "bp-sdk-add-item__wrapper" }, index.h("bp-sdk-icon-container", { name: this.icon }), this.helpText && index.h("h4", { class: "bp-sdk-add-item__help-text" }, this.helpText), index.h("bp-sdk-button", { onClick: this.handleClick, text: this.text })))));
  }
};
BpSdkAddItemContainer.style = bpSdkAddItemContainerCss;

const bpSdkAddQuestionPoolItemContainerCss = "";

let BpSdkAddQuestionPoolItemContainer = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    /**
     * Help text
     */
    this.helpText = '';
    /**
     * Add button text
     */
    this.text = '+';
    this.useExternal = false;
    this.handleSubscriptions = () => {
      if (store.canGetStore()) {
        this.storeUnsubscribe && this.storeUnsubscribe();
        store.store.mapDispatchToProps(this, { addQuestionPool: sdkRedux.addQuestionPool });
        this.storeUnsubscribe = store.store.mapStateToProps(this, this.mapStateToProps);
      }
    };
    this.mapStateToProps = (state) => {
      return {
        applicationId: sdkRedux.getFormId(state),
        config: sdkRedux.getPartnerEngineConfig(state),
        questionSetState: sdkRedux.selectQuestionSetsState(state),
      };
    };
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
    this.handleSubscriptions();
  }
  disconnectedCallback() {
    this.storeUnsubscribe && this.storeUnsubscribe();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-add-question-pool-item-container');
    customElements.whenDefined('bp-sdk-external-add-question-pool-item-container').then(() => {
      this.useExternal = true;
    });
    this.handleSubscriptions();
    this.onQuestionSetIdChange(this.questionSetId);
    this.onQuestionIdChange(this.questionId);
  }
  onQuestionSetIdChange(questionSetId) {
    this.updateQuestionPool(questionSetId, this.questionId, this.questionSetState);
  }
  onQuestionIdChange(questionId) {
    this.updateQuestionPool(this.questionSetId, questionId, this.questionSetState);
  }
  onQuestionSetsChange(questionSetState) {
    this.updateQuestionPool(this.questionSetId, this.questionId, questionSetState);
  }
  updateQuestionPool(questionSetId, questionId, questionSetState) {
    var _a, _b, _c;
    let set = (_a = questionSetState === null || questionSetState === void 0 ? void 0 : questionSetState.list) === null || _a === void 0 ? void 0 : _a.filter((set) => set.question_set_id === questionSetId)[0];
    const f = (questionSetState === null || questionSetState === void 0 ? void 0 : questionSetState.parentQuestionSets.length) > 0;
    if (f) {
      const hasParent = questionSetState.parentQuestionSets.find((qs) => qs.question_set_id === questionSetId);
      if (hasParent) {
        set = hasParent;
      }
    }
    const pools = (_c = (_b = set === null || set === void 0 ? void 0 : set.question_set) === null || _b === void 0 ? void 0 : _b.question_pools) !== null && _c !== void 0 ? _c : [];
    this.questionPool = pools.find((pool) => pool.parent_question_id === questionId);
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-add-question-pool-item-container", { applicationId: this.applicationId, config: this.config, helpText: this.helpText, questionId: this.questionId, questionSetId: this.questionSetId, questionSetState: this.questionSetState, text: this.text }));
  }
  renderInternal() {
    return (index.h("div", { class: "bp-sdk-add-question-pool-item-container__container" }, this.questionPool && (index.h("bp-sdk-question-pool-container", { addText: this.questionPool.add_text, code: this.questionPool.code, description: this.questionPool.description, displayText: this.questionPool.display_text, guid: this.questionPool.id, parentQuestionPoolId: this.questionPool.parent_question_pool_id, parentQuestionPoolReferenceId: this.questionPool.parent_question_pool_reference_id, ownerId: this.questionPool.owner_id, parentQuestionId: this.questionPool.parent_question_id, removeText: this.questionPool.remove_text, tenantId: this.questionPool.tenant_id, config: this.config, applicationId: this.applicationId }))));
  }
  get el() { return index.getElement(this); }
  static get watchers() { return {
    "questionSetId": ["onQuestionSetIdChange"],
    "questionId": ["onQuestionIdChange"],
    "questionSetState": ["onQuestionSetsChange"]
  }; }
};
BpSdkAddQuestionPoolItemContainer.style = bpSdkAddQuestionPoolItemContainerCss;

const bpSdkAutocompleteInputCss = "bp-sdk-autocomplete-input .bp-sdk-autocomplete-container{position:relative;min-width:10rem;max-width:100vw}.bp-sdk-label-content{font-size:26px;color:rgba(100, 100, 100, 0.6)}.bp-sdk-no-selection{user-select:none}.bp-sdk-visually-hidden{display:none}.bp-sdk-align-right{margin-left:auto}.bp-sdk-autocomplete__button-arrow{font-size:20px}.bp-sdk-autocomplete__input{width:100%;height:2rem;padding:0.25rem;margin-bottom:0;display:flex;justify-items:center;align-items:flex-start}.bp-sdk-autocomplete__list{background:white;border:1px solid #aaa;left:0;margin:0;max-height:15rem;min-width:10rem;overflow-y:auto;padding-left:0;position:absolute;width:calc(100% - 2px);z-index:1}.bp-sdk-no-results{position:absolute;left:0;right:-2px;font-size:1rem;background:white;border:1px solid #aaa;color:#707070;padding-left:0.2rem}.bp-sdk-autocomplete__list-item{display:block;position:relative;font-size:16px;padding-left:1rem;padding-right:1rem;cursor:pointer}";

const keyboardNavigation$1 = {
  next: ['ArrowDown'],
  previous: ['ArrowUp'],
  select: ['Enter'],
};
let BpSdkAutocompleteInput = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.valueUpdate = index.createEvent(this, "valueUpdate", 7);
    this.filterUpdate = index.createEvent(this, "filterUpdate", 7);
    this.removeActiveAnswer = index.createEvent(this, "removeActiveAnswer", 7);
    this.updateActiveAnswer = index.createEvent(this, "updateActiveAnswer", 7);
    /***
     * Choices to display
     */
    this.choices = [];
    /**
     * Placeholder to display
     */
    this.placeholder = '';
    /**
     * Is required
     */
    this.required = false;
    /**
     * Show choices
     */
    this.showChoices = false;
    /**
     * Is touched
     */
    this.touched = false;
    /**
     * Is pristine
     */
    this.pristine = true;
    /**
     * Is answer in complete state
     */
    this.isCompleted = false;
    /**
     * When true, the field will be readonly. It will display only the label and value as plain text.
     */
    this.isReadOnly = false;
    /**
     * Disables dropdown
     */
    this.disableDropdown = false;
    /**
     * Allow text to fall through if no selected choices
     */
    this.allowFallthrough = false;
    /**
     * Should show no choices fallback if list is empty
     */
    this.showNoChoicesFallback = true;
    this._choices = [];
    this._showChoices = false;
    this.filterText = '';
    this.choiceText = '';
    this.focusedIndex = 0;
    this.useExternal = false;
    this.isFocused = false;
    this.text = '';
    this.hideChoices = () => {
      this._showChoices = false;
    };
    this.onFocus = () => {
      this.isFocused = true;
    };
    this.onBlur = () => {
      if (!this.disableDropdown) {
        this.el.querySelector('input').value = this.getText(this.choice);
      }
      this.isFocused = false;
    };
    this.debounceFilterChoices = debounce.debounce_1(this.filterChoices, 300);
    this.choiceSelected = (choice) => {
      var _a;
      this._showChoices = false;
      if (choice) {
        this.choice = choice;
        this.value = choice.id;
      }
      else if (this.allowFallthrough) {
        this.value = this.filterText;
      }
      (_a = this.el.querySelector('.bp-sdk-autocomplete__input')) === null || _a === void 0 ? void 0 : _a.focus();
      this.removeActiveAnswer.emit();
    };
    this.onKeydown = (event) => {
      const key = event.key;
      if (event.metaKey || event.altKey) {
        return;
      }
      switch (key) {
        case 'ArrowUp':
        case 'ArrowDown':
        case 'Enter':
          event.preventDefault();
          this.handleKeyEvent(key);
          break;
        case 'Tab':
        case 'Escape':
          this._showChoices = false;
          break;
        case 'Meta':
        case 'Control':
        case 'Alt':
          break;
        default:
          this.debounceFilterChoices();
          break;
      }
    };
    this.onOptionClick = (choice) => (e) => {
      e.preventDefault();
      this.choiceSelected(choice);
    };
  }
  resetState() {
    this._showChoices = false;
    this.focusedIndex = 0;
    this.isFocused = false;
  }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-autocomplete-input');
    customElements.whenDefined('bp-sdk-external-autocomplete-input').then(() => {
      this.useExternal = true;
    });
    this.onChoicesChange(this.choices);
    this.onChoiceIdChange(this.choiceId);
    this.onShowChoicesChange(this.showChoices);
    this.onChoiceChange(this.choice);
    this.onAriaLabelledByChange(this.labelId);
    this.onLabelledByChange(this.labelledBy);
    this.checkForSelectedChoice();
  }
  onAriaLabelledByChange(labelId) {
    this.updateLabelledBy(labelId, this.labelledBy);
  }
  onLabelledByChange(labelledBy) {
    this.updateLabelledBy(this.labelId, labelledBy);
  }
  updateLabelledBy(aria, ids) {
    const prefix = ids ? `${ids} ` : '';
    this._labelledBy = `${prefix}${aria !== null && aria !== void 0 ? aria : ''}` || undefined;
  }
  onChoicesChange(choices) {
    if (JSON.stringify(choices) !== JSON.stringify(this._choices)) {
      this._choices = choices;
    }
    this.onChoiceIdChange(this.choiceId);
  }
  onChoiceIdChange(choiceId) {
    this.choice = this._choices.find((choice) => choice.id === choiceId);
  }
  onShowChoicesChange(newValue) {
    this._showChoices = this.isFocused && newValue;
  }
  getText(choice) {
    return choice ? this.displayChoice(choice) : '';
  }
  onChoiceChange(choice) {
    this.choiceText = this.getText(choice);
  }
  onChoiceTextChange(text) {
    this.text = text;
  }
  onValueChange(newValue, oldValue) {
    this._showChoices = false;
    if (newValue !== this.choiceId && index_esm_min.Fe(newValue, oldValue)) {
      this.valueUpdate.emit([newValue]);
    }
  }
  filterChoices() {
    const input = this.el.querySelector('input');
    this.text = this.filterText = input.value;
    this._showChoices = this.isFocused && !!this.filterText;
  }
  onFilterChange(value) {
    this._showChoices = this.isFocused;
    this.updateActiveAnswer.emit(this.answerId);
    this.filterUpdate.emit({
      id: this.questionId,
      value,
    });
  }
  checkForSelectedChoice() {
    if (this.choiceId) {
      this._choices.map((choice) => {
        if (this.choiceId === choice.id) {
          this.value = choice.id;
          this.choice = choice;
        }
      });
    }
  }
  displayChoice(choice) {
    return choice === null || choice === void 0 ? void 0 : choice.value;
  }
  handleKeyEvent(keyName) {
    const options = this.getKeyEventOptions(keyName);
    const indexToSelect = this.getIndexToSelect(keyName, options);
    this.mapKeyEventToAction(indexToSelect, options);
  }
  getKeyEventOptions(keyName) {
    const goToNext = keyboardNavigation$1.next.includes(keyName);
    const goToPrevious = keyboardNavigation$1.previous.includes(keyName);
    const isOpenOrSelectKey = keyboardNavigation$1.select.includes(keyName);
    return {
      goToNext,
      goToPrevious,
      shouldMoveIndex: this._showChoices && (goToPrevious || goToNext),
      isOpenOrSelectKey,
    };
  }
  getIndexToSelect(keyName, { goToPrevious, shouldMoveIndex, isOpenOrSelectKey }) {
    let indexToSelect;
    if (isOpenOrSelectKey && this._showChoices) {
      indexToSelect = this.focusedIndex;
    }
    else if (keyName === 'Escape') {
      this._showChoices = false;
    }
    else if (shouldMoveIndex && !this._showChoices) {
      indexToSelect = this.focusedIndex == null ? 0 : this.focusedIndex + (goToPrevious ? -1 : 1);
    }
    return indexToSelect;
  }
  mapKeyEventToAction(indexToSelect, { shouldMoveIndex, goToPrevious, goToNext, }) {
    if (typeof indexToSelect === 'number') {
      this.selectOptionByIndex(indexToSelect);
    }
    else if (shouldMoveIndex && this._showChoices) {
      this.focusOption(this.focusedIndex + (goToPrevious ? -1 : 1));
    }
    else if (goToNext || goToPrevious) {
      this.filterText = this.displayChoice(this.choice);
      this.focusOption(0);
    }
  }
  focusOption(index) {
    this._showChoices = this.isFocused;
    this.focusedIndex = this.getSelectableIndex(index);
  }
  selectOptionByIndex(index) {
    const selectableIndex = this.getSelectableIndex(index);
    this.focusedIndex = selectableIndex;
    const choice = this._choices[this.focusedIndex];
    this.choiceSelected(choice);
  }
  getSelectableIndex(index) {
    const lastIndex = this._choices.length - 1;
    const selectableIndex = index <= 0 ? 0 : index > lastIndex ? lastIndex : index;
    return selectableIndex;
  }
  handleOutsideClick() {
    this.hideChoices();
  }
  handleClick(e) {
    if (this.useExternal) {
      return;
    }
    e.stopPropagation();
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-autocomplete-input", { allowFallthrough: this.allowFallthrough, answerId: this.answerId, choiceId: this.choiceId, choices: this._choices, code: this.code, disableDropdown: this.disableDropdown, errorText: this.errorText, errors: this.errors, fieldType: this.fieldType, helpText: this.helpText, answeredBySource: this.answeredBySource, isCompleted: this.isCompleted, isReadOnly: this.isReadOnly, labelId: this.labelId, label: this.label, labelledBy: this.labelledBy, placeholder: this.placeholder, pristine: this.pristine, questionId: this.questionId, required: this.required, showChoices: this.showChoices, showNoChoicesFallback: this.showNoChoicesFallback, touched: this.touched }));
  }
  renderInternal() {
    var _a;
    let input;
    if (this.isReadOnly) {
      input = this.renderReadOnlyElement(this.text);
    }
    else {
      input = [
        index.h("input", { id: `bp-sdk-autocomplete__${this.answerId}`, class: "bp-sdk-autocomplete__input", "aria-controls": `bp-sdk-autocomplete__${this.answerId}-listbox`, "aria-autocomplete": "list", placeholder: this.placeholder, "aria-labelledby": this._labelledBy, type: "text", value: this.text, onBlur: this.onBlur, onFocus: this.onFocus, onKeyDown: this.onKeydown }),
        this.renderOptions(),
      ];
    }
    return (index.h("div", { class: "bp-sdk-autocomplete__container", "aria-expanded": this._showChoices, "aria-owns": `bp-sdk-autocomplete__${this.answerId}-listbox`, "aria-haspopup": "listbox", onBlur: this.hideChoices }, index.h("label", { id: this.labelId, htmlFor: `bp-sdk-autocomplete__${this.answerId}`, class: "bp-sdk-label bp-sdk-autocomplete__label", innerHTML: this.label }), input, this.touched && !this.pristine && ((this.errorText && !this.isCompleted) || !!((_a = this.errors) === null || _a === void 0 ? void 0 : _a.length)) && (index.h("bp-sdk-errors-container", { answerId: this.answerId, questionId: this.questionId, fieldType: this.fieldType, errors: this.errors, errorText: this.errorText }))));
  }
  renderOptions() {
    var _a;
    if (this.disableDropdown) {
      return;
    }
    else if ((_a = this._choices) === null || _a === void 0 ? void 0 : _a.length) {
      return (index.h("ul", { class: index_esm_min.ix('bp-sdk-autocomplete__list', {
          'bp-sdk-visually-hidden': !this._showChoices,
        }), id: `bp-sdk-autocomplete__${this.answerId}-listbox`, role: "listbox", "aria-labelledby": this.labelId, tabindex: "-1" }, this._choices.map((choice, i) => (index.h("li", { onClick: this.onOptionClick(choice), "aria-labelledby": this.labelId, class: index_esm_min.ix(`bp-sdk-autocomplete__list-item bp-sdk-autocomplete__item-${choice.id}`, {
          'bp-sdk-autocomplete__list-item--selected': this.choiceId === choice.id,
        }), role: "option", "aria-selected": (this.focusedIndex == i).toString(), tabindex: "1" }, index.h("span", { class: `bp-sdk-autocomplete__list-item-text bp-sdk-autocomplete__list-item-text-${choice.id}` }, this.displayChoice(choice)))))));
    }
    else if (this.showNoChoicesFallback) {
      return (index.h("div", { class: index_esm_min.ix('bp-sdk-no-results', {
          'bp-sdk-visually-hidden': !this._showChoices,
        }) }, index.h("span", null, "No Results")));
    }
  }
  renderReadOnlyElement(value) {
    return index.h("span", { class: "read-only-value" }, value);
  }
  get el() { return index.getElement(this); }
  static get watchers() { return {
    "labelId": ["onAriaLabelledByChange"],
    "labelledBy": ["onLabelledByChange"],
    "choices": ["onChoicesChange"],
    "choiceId": ["onChoiceIdChange"],
    "showChoices": ["onShowChoicesChange"],
    "choice": ["onChoiceChange"],
    "choiceText": ["onChoiceTextChange"],
    "value": ["onValueChange"],
    "filterText": ["onFilterChange"]
  }; }
};
BpSdkAutocompleteInput.style = bpSdkAutocompleteInputCss;

/** Used to compose bitmasks for value comparisons. */
var COMPARE_PARTIAL_FLAG$1 = 1,
    COMPARE_UNORDERED_FLAG$1 = 2;

/**
 * The base implementation of `_.isMatch` without support for iteratee shorthands.
 *
 * @private
 * @param {Object} object The object to inspect.
 * @param {Object} source The object of property values to match.
 * @param {Array} matchData The property names, values, and compare flags to match.
 * @param {Function} [customizer] The function to customize comparisons.
 * @returns {boolean} Returns `true` if `object` is a match, else `false`.
 */
function baseIsMatch(object, source, matchData, customizer) {
  var index = matchData.length,
      length = index,
      noCustomizer = !customizer;

  if (object == null) {
    return !length;
  }
  object = Object(object);
  while (index--) {
    var data = matchData[index];
    if ((noCustomizer && data[2])
          ? data[1] !== object[data[0]]
          : !(data[0] in object)
        ) {
      return false;
    }
  }
  while (++index < length) {
    data = matchData[index];
    var key = data[0],
        objValue = object[key],
        srcValue = data[1];

    if (noCustomizer && data[2]) {
      if (objValue === undefined && !(key in object)) {
        return false;
      }
    } else {
      var stack = new isEqual._Stack;
      if (customizer) {
        var result = customizer(objValue, srcValue, key, object, source, stack);
      }
      if (!(result === undefined
            ? isEqual._baseIsEqual(srcValue, objValue, COMPARE_PARTIAL_FLAG$1 | COMPARE_UNORDERED_FLAG$1, customizer, stack)
            : result
          )) {
        return false;
      }
    }
  }
  return true;
}

var _baseIsMatch = baseIsMatch;

/**
 * Checks if `value` is suitable for strict equality comparisons, i.e. `===`.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` if suitable for strict
 *  equality comparisons, else `false`.
 */
function isStrictComparable(value) {
  return value === value && !isEqual.isObject_1(value);
}

var _isStrictComparable = isStrictComparable;

/**
 * Gets the property names, values, and compare flags of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the match data of `object`.
 */
function getMatchData(object) {
  var result = isEqual.keys_1(object),
      length = result.length;

  while (length--) {
    var key = result[length],
        value = object[key];

    result[length] = [key, value, _isStrictComparable(value)];
  }
  return result;
}

var _getMatchData = getMatchData;

/**
 * A specialized version of `matchesProperty` for source values suitable
 * for strict equality comparisons, i.e. `===`.
 *
 * @private
 * @param {string} key The key of the property to get.
 * @param {*} srcValue The value to match.
 * @returns {Function} Returns the new spec function.
 */
function matchesStrictComparable(key, srcValue) {
  return function(object) {
    if (object == null) {
      return false;
    }
    return object[key] === srcValue &&
      (srcValue !== undefined || (key in Object(object)));
  };
}

var _matchesStrictComparable = matchesStrictComparable;

/**
 * The base implementation of `_.matches` which doesn't clone `source`.
 *
 * @private
 * @param {Object} source The object of property values to match.
 * @returns {Function} Returns the new spec function.
 */
function baseMatches(source) {
  var matchData = _getMatchData(source);
  if (matchData.length == 1 && matchData[0][2]) {
    return _matchesStrictComparable(matchData[0][0], matchData[0][1]);
  }
  return function(object) {
    return object === source || _baseIsMatch(object, source, matchData);
  };
}

var _baseMatches = baseMatches;

/** Used to match property names within property paths. */
var reIsDeepProp = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/,
    reIsPlainProp = /^\w*$/;

/**
 * Checks if `value` is a property name and not a property path.
 *
 * @private
 * @param {*} value The value to check.
 * @param {Object} [object] The object to query keys on.
 * @returns {boolean} Returns `true` if `value` is a property name, else `false`.
 */
function isKey(value, object) {
  if (isEqual.isArray_1(value)) {
    return false;
  }
  var type = typeof value;
  if (type == 'number' || type == 'symbol' || type == 'boolean' ||
      value == null || debounce.isSymbol_1(value)) {
    return true;
  }
  return reIsPlainProp.test(value) || !reIsDeepProp.test(value) ||
    (object != null && value in Object(object));
}

var _isKey = isKey;

/** Error message constants. */
var FUNC_ERROR_TEXT = 'Expected a function';

/**
 * Creates a function that memoizes the result of `func`. If `resolver` is
 * provided, it determines the cache key for storing the result based on the
 * arguments provided to the memoized function. By default, the first argument
 * provided to the memoized function is used as the map cache key. The `func`
 * is invoked with the `this` binding of the memoized function.
 *
 * **Note:** The cache is exposed as the `cache` property on the memoized
 * function. Its creation may be customized by replacing the `_.memoize.Cache`
 * constructor with one whose instances implement the
 * [`Map`](http://ecma-international.org/ecma-262/7.0/#sec-properties-of-the-map-prototype-object)
 * method interface of `clear`, `delete`, `get`, `has`, and `set`.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Function
 * @param {Function} func The function to have its output memoized.
 * @param {Function} [resolver] The function to resolve the cache key.
 * @returns {Function} Returns the new memoized function.
 * @example
 *
 * var object = { 'a': 1, 'b': 2 };
 * var other = { 'c': 3, 'd': 4 };
 *
 * var values = _.memoize(_.values);
 * values(object);
 * // => [1, 2]
 *
 * values(other);
 * // => [3, 4]
 *
 * object.a = 2;
 * values(object);
 * // => [1, 2]
 *
 * // Modify the result cache.
 * values.cache.set(object, ['a', 'b']);
 * values(object);
 * // => ['a', 'b']
 *
 * // Replace `_.memoize.Cache`.
 * _.memoize.Cache = WeakMap;
 */
function memoize(func, resolver) {
  if (typeof func != 'function' || (resolver != null && typeof resolver != 'function')) {
    throw new TypeError(FUNC_ERROR_TEXT);
  }
  var memoized = function() {
    var args = arguments,
        key = resolver ? resolver.apply(this, args) : args[0],
        cache = memoized.cache;

    if (cache.has(key)) {
      return cache.get(key);
    }
    var result = func.apply(this, args);
    memoized.cache = cache.set(key, result) || cache;
    return result;
  };
  memoized.cache = new (memoize.Cache || isEqual._MapCache);
  return memoized;
}

// Expose `MapCache`.
memoize.Cache = isEqual._MapCache;

var memoize_1 = memoize;

/** Used as the maximum memoize cache size. */
var MAX_MEMOIZE_SIZE = 500;

/**
 * A specialized version of `_.memoize` which clears the memoized function's
 * cache when it exceeds `MAX_MEMOIZE_SIZE`.
 *
 * @private
 * @param {Function} func The function to have its output memoized.
 * @returns {Function} Returns the new memoized function.
 */
function memoizeCapped(func) {
  var result = memoize_1(func, function(key) {
    if (cache.size === MAX_MEMOIZE_SIZE) {
      cache.clear();
    }
    return key;
  });

  var cache = result.cache;
  return result;
}

var _memoizeCapped = memoizeCapped;

/** Used to match property names within property paths. */
var rePropName = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g;

/** Used to match backslashes in property paths. */
var reEscapeChar = /\\(\\)?/g;

/**
 * Converts `string` to a property path array.
 *
 * @private
 * @param {string} string The string to convert.
 * @returns {Array} Returns the property path array.
 */
var stringToPath = _memoizeCapped(function(string) {
  var result = [];
  if (string.charCodeAt(0) === 46 /* . */) {
    result.push('');
  }
  string.replace(rePropName, function(match, number, quote, subString) {
    result.push(quote ? subString.replace(reEscapeChar, '$1') : (number || match));
  });
  return result;
});

var _stringToPath = stringToPath;

/** Used as references for various `Number` constants. */
var INFINITY$1 = 1 / 0;

/** Used to convert symbols to primitives and strings. */
var symbolProto = isEqual._Symbol ? isEqual._Symbol.prototype : undefined,
    symbolToString = symbolProto ? symbolProto.toString : undefined;

/**
 * The base implementation of `_.toString` which doesn't convert nullish
 * values to empty strings.
 *
 * @private
 * @param {*} value The value to process.
 * @returns {string} Returns the string.
 */
function baseToString(value) {
  // Exit early for strings to avoid a performance hit in some environments.
  if (typeof value == 'string') {
    return value;
  }
  if (isEqual.isArray_1(value)) {
    // Recursively convert values (susceptible to call stack limits).
    return _baseUniq._arrayMap(value, baseToString) + '';
  }
  if (debounce.isSymbol_1(value)) {
    return symbolToString ? symbolToString.call(value) : '';
  }
  var result = (value + '');
  return (result == '0' && (1 / value) == -INFINITY$1) ? '-0' : result;
}

var _baseToString = baseToString;

/**
 * Converts `value` to a string. An empty string is returned for `null`
 * and `undefined` values. The sign of `-0` is preserved.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to convert.
 * @returns {string} Returns the converted string.
 * @example
 *
 * _.toString(null);
 * // => ''
 *
 * _.toString(-0);
 * // => '-0'
 *
 * _.toString([1, 2, 3]);
 * // => '1,2,3'
 */
function toString(value) {
  return value == null ? '' : _baseToString(value);
}

var toString_1 = toString;

/**
 * Casts `value` to a path array if it's not one.
 *
 * @private
 * @param {*} value The value to inspect.
 * @param {Object} [object] The object to query keys on.
 * @returns {Array} Returns the cast property path array.
 */
function castPath(value, object) {
  if (isEqual.isArray_1(value)) {
    return value;
  }
  return _isKey(value, object) ? [value] : _stringToPath(toString_1(value));
}

var _castPath = castPath;

/** Used as references for various `Number` constants. */
var INFINITY = 1 / 0;

/**
 * Converts `value` to a string key if it's not a string or symbol.
 *
 * @private
 * @param {*} value The value to inspect.
 * @returns {string|symbol} Returns the key.
 */
function toKey(value) {
  if (typeof value == 'string' || debounce.isSymbol_1(value)) {
    return value;
  }
  var result = (value + '');
  return (result == '0' && (1 / value) == -INFINITY) ? '-0' : result;
}

var _toKey = toKey;

/**
 * The base implementation of `_.get` without support for default values.
 *
 * @private
 * @param {Object} object The object to query.
 * @param {Array|string} path The path of the property to get.
 * @returns {*} Returns the resolved value.
 */
function baseGet(object, path) {
  path = _castPath(path, object);

  var index = 0,
      length = path.length;

  while (object != null && index < length) {
    object = object[_toKey(path[index++])];
  }
  return (index && index == length) ? object : undefined;
}

var _baseGet = baseGet;

/**
 * Gets the value at `path` of `object`. If the resolved value is
 * `undefined`, the `defaultValue` is returned in its place.
 *
 * @static
 * @memberOf _
 * @since 3.7.0
 * @category Object
 * @param {Object} object The object to query.
 * @param {Array|string} path The path of the property to get.
 * @param {*} [defaultValue] The value returned for `undefined` resolved values.
 * @returns {*} Returns the resolved value.
 * @example
 *
 * var object = { 'a': [{ 'b': { 'c': 3 } }] };
 *
 * _.get(object, 'a[0].b.c');
 * // => 3
 *
 * _.get(object, ['a', '0', 'b', 'c']);
 * // => 3
 *
 * _.get(object, 'a.b.c', 'default');
 * // => 'default'
 */
function get(object, path, defaultValue) {
  var result = object == null ? undefined : _baseGet(object, path);
  return result === undefined ? defaultValue : result;
}

var get_1 = get;

/**
 * The base implementation of `_.hasIn` without support for deep paths.
 *
 * @private
 * @param {Object} [object] The object to query.
 * @param {Array|string} key The key to check.
 * @returns {boolean} Returns `true` if `key` exists, else `false`.
 */
function baseHasIn(object, key) {
  return object != null && key in Object(object);
}

var _baseHasIn = baseHasIn;

/**
 * Checks if `path` exists on `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @param {Array|string} path The path to check.
 * @param {Function} hasFunc The function to check properties.
 * @returns {boolean} Returns `true` if `path` exists, else `false`.
 */
function hasPath(object, path, hasFunc) {
  path = _castPath(path, object);

  var index = -1,
      length = path.length,
      result = false;

  while (++index < length) {
    var key = _toKey(path[index]);
    if (!(result = object != null && hasFunc(object, key))) {
      break;
    }
    object = object[key];
  }
  if (result || ++index != length) {
    return result;
  }
  length = object == null ? 0 : object.length;
  return !!length && isEqual.isLength_1(length) && isEqual._isIndex(key, length) &&
    (isEqual.isArray_1(object) || isEqual.isArguments_1(object));
}

var _hasPath = hasPath;

/**
 * Checks if `path` is a direct or inherited property of `object`.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Object
 * @param {Object} object The object to query.
 * @param {Array|string} path The path to check.
 * @returns {boolean} Returns `true` if `path` exists, else `false`.
 * @example
 *
 * var object = _.create({ 'a': _.create({ 'b': 2 }) });
 *
 * _.hasIn(object, 'a');
 * // => true
 *
 * _.hasIn(object, 'a.b');
 * // => true
 *
 * _.hasIn(object, ['a', 'b']);
 * // => true
 *
 * _.hasIn(object, 'b');
 * // => false
 */
function hasIn(object, path) {
  return object != null && _hasPath(object, path, _baseHasIn);
}

var hasIn_1 = hasIn;

/** Used to compose bitmasks for value comparisons. */
var COMPARE_PARTIAL_FLAG = 1,
    COMPARE_UNORDERED_FLAG = 2;

/**
 * The base implementation of `_.matchesProperty` which doesn't clone `srcValue`.
 *
 * @private
 * @param {string} path The path of the property to get.
 * @param {*} srcValue The value to match.
 * @returns {Function} Returns the new spec function.
 */
function baseMatchesProperty(path, srcValue) {
  if (_isKey(path) && _isStrictComparable(srcValue)) {
    return _matchesStrictComparable(_toKey(path), srcValue);
  }
  return function(object) {
    var objValue = get_1(object, path);
    return (objValue === undefined && objValue === srcValue)
      ? hasIn_1(object, path)
      : isEqual._baseIsEqual(srcValue, objValue, COMPARE_PARTIAL_FLAG | COMPARE_UNORDERED_FLAG);
  };
}

var _baseMatchesProperty = baseMatchesProperty;

/**
 * The base implementation of `_.property` without support for deep paths.
 *
 * @private
 * @param {string} key The key of the property to get.
 * @returns {Function} Returns the new accessor function.
 */
function baseProperty(key) {
  return function(object) {
    return object == null ? undefined : object[key];
  };
}

var _baseProperty = baseProperty;

/**
 * A specialized version of `baseProperty` which supports deep paths.
 *
 * @private
 * @param {Array|string} path The path of the property to get.
 * @returns {Function} Returns the new accessor function.
 */
function basePropertyDeep(path) {
  return function(object) {
    return _baseGet(object, path);
  };
}

var _basePropertyDeep = basePropertyDeep;

/**
 * Creates a function that returns the value at `path` of a given object.
 *
 * @static
 * @memberOf _
 * @since 2.4.0
 * @category Util
 * @param {Array|string} path The path of the property to get.
 * @returns {Function} Returns the new accessor function.
 * @example
 *
 * var objects = [
 *   { 'a': { 'b': 2 } },
 *   { 'a': { 'b': 1 } }
 * ];
 *
 * _.map(objects, _.property('a.b'));
 * // => [2, 1]
 *
 * _.map(_.sortBy(objects, _.property(['a', 'b'])), 'a.b');
 * // => [1, 2]
 */
function property(path) {
  return _isKey(path) ? _baseProperty(_toKey(path)) : _basePropertyDeep(path);
}

var property_1 = property;

/**
 * The base implementation of `_.iteratee`.
 *
 * @private
 * @param {*} [value=_.identity] The value to convert to an iteratee.
 * @returns {Function} Returns the iteratee.
 */
function baseIteratee(value) {
  // Don't store the `typeof` result in a variable to avoid a JIT bug in Safari 9.
  // See https://bugs.webkit.org/show_bug.cgi?id=156034 for more details.
  if (typeof value == 'function') {
    return value;
  }
  if (value == null) {
    return _baseUniq.identity_1;
  }
  if (typeof value == 'object') {
    return isEqual.isArray_1(value)
      ? _baseMatchesProperty(value[0], value[1])
      : _baseMatches(value);
  }
  return property_1(value);
}

var _baseIteratee = baseIteratee;

/**
 * This method is like `_.uniq` except that it accepts `iteratee` which is
 * invoked for each element in `array` to generate the criterion by which
 * uniqueness is computed. The order of result values is determined by the
 * order they occur in the array. The iteratee is invoked with one argument:
 * (value).
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Array
 * @param {Array} array The array to inspect.
 * @param {Function} [iteratee=_.identity] The iteratee invoked per element.
 * @returns {Array} Returns the new duplicate free array.
 * @example
 *
 * _.uniqBy([2.1, 1.2, 2.3], Math.floor);
 * // => [2.1, 1.2]
 *
 * // The `_.property` iteratee shorthand.
 * _.uniqBy([{ 'x': 1 }, { 'x': 2 }, { 'x': 1 }], 'x');
 * // => [{ 'x': 1 }, { 'x': 2 }]
 */
function uniqBy(array, iteratee) {
  return (array && array.length) ? _baseUniq._baseUniq(array, _baseIteratee(iteratee)) : [];
}

var uniqBy_1 = uniqBy;

const bpSdkAutocompleteNaicsContainerCss = "";

let BpSdkAutocompleteNaicsContainer = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    /**
     * Placeholder to display
     */
    this.placeholder = '';
    /**
     * Is required value
     */
    this.required = false;
    /***
     * Choices to display
     */
    this.choices = [];
    /**
     * Is touched
     */
    this.touched = false;
    /**
     * Is pristine
     */
    this.pristine = true;
    /**
     * Is answer in complete state
     */
    this.isCompleted = false;
    /**
     * When true, the field will be readonly. It will display only the label and value as plain text.
     */
    this.isReadOnly = false;
    /**
     * Choices injected from redux
     */
    this.remoteChoices = [];
    this.choiceMap = {};
    this.useExternal = false;
    this.handleSubscriptions = () => {
      if (store.canGetStore()) {
        this.storeUnsubscribe && this.storeUnsubscribe();
        store.store.mapDispatchToProps(this, { searchChoices: sdkRedux.searchChoices });
        this.storeUnsubscribe = store.store.mapStateToProps(this, this.mapStateToProps);
      }
    };
    this.mapStateToProps = (state) => {
      return {
        remoteChoices: sdkRedux.getSelectedChoices(state, this.questionId),
        config: sdkRedux.getPartnerEngineConfig(state),
      };
    };
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
    this.handleSubscriptions();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-autocomplete-naics-container');
    customElements.whenDefined('bp-sdk-external-autocomplete-naics-container').then(() => {
      this.useExternal = true;
    });
    this.onQuestionIdChange();
    this.onChoicesChange(this.choices || []);
  }
  disconnectedCallback() {
    this.storeUnsubscribe && this.storeUnsubscribe();
  }
  onQuestionIdChange() {
    this.handleSubscriptions();
  }
  onChoicesChange(choices) {
    this.choiceMap = choices.reduce((acc, choice) => (Object.assign(Object.assign({}, acc), { [choice.id]: [choice] })), {});
  }
  onChoicesUpdate(choices) {
    this.updateComposedChoices(choices, this.choiceMap);
  }
  onChoiceMapUpdate(choiceMap) {
    this.updateComposedChoices(this.remoteChoices, choiceMap);
  }
  updateComposedChoices(searchChoices, choiceMap) {
    var _a;
    const answerChoices = (_a = (choiceMap && choiceMap[this.choiceId])) !== null && _a !== void 0 ? _a : [];
    this.composedChoices = uniqBy_1([...searchChoices, ...answerChoices], (item) => item.id);
  }
  onFilterUpdate({ detail }) {
    if (this.useExternal) {
      return;
    }
    const params = {
      questionId: this.questionId,
      filter: detail.value,
      timestamp: Date.now(),
      config: this.config,
    };
    this.searchChoices(params);
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-autocomplete-naics-container", { "answer-id": this.answerId, choice_id: this.choiceId, choices: this.choices, code: this.code, config: this.config, errors: this.errors, error_text: this.errorText, field_type: this.fieldType, helpText: this.helpText, answeredBySource: this.answeredBySource, is_completed: this.isCompleted, isReadOnly: this.isReadOnly, "label-id": this.labelId, label: this.label, "labelled-by": this.labelledBy, placeholder: this.placeholder, pristine: this.pristine, question_id: this.questionId, remoteChoices: this.remoteChoices, required: this.required, touched: this.touched }));
  }
  renderInternal() {
    return (index.h("div", { class: "bp-sdk-autocomplete-naics-container__container" }, index.h("bp-sdk-autocomplete-input", { answeredBySource: this.answeredBySource, answerId: this.answerId, choiceId: this.choiceId, choices: this.composedChoices, code: this.code, errors: this.errors, errorText: this.errorText, helpText: this.helpText, fieldType: this.fieldType, isCompleted: this.isCompleted, isReadOnly: this.isReadOnly, label: this.label, labelId: this.labelId, labelledBy: this.labelledBy, placeholder: this.placeholder, pristine: this.pristine, questionId: this.questionId, required: this.required, touched: this.touched })));
  }
  get el() { return index.getElement(this); }
  static get watchers() { return {
    "questionId": ["onQuestionIdChange"],
    "choices": ["onChoicesChange"],
    "remoteChoices": ["onChoicesUpdate"],
    "choiceMap": ["onChoiceMapUpdate"]
  }; }
};
BpSdkAutocompleteNaicsContainer.style = bpSdkAutocompleteNaicsContainerCss;

const bpSdkBusinessClassificationSelectorCss = "";

let BpSdkBusinessClassificationSelector = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    /***
     * Choices to display
     */
    this.choices = [];
    /**
     * Selected answer choice, wrapped in an array
     */
    this.selectedChoices = [];
    /**
     * Placeholder to display
     */
    this.placeholder = '';
    /**
     * Is required
     */
    this.required = false;
    /**
     * Show choices
     */
    this.showChoices = false;
    /**
     * Is touched
     */
    this.touched = false;
    /**
     * Is pristine
     */
    this.pristine = true;
    /**
     * Is answer in complete state
     */
    this.isCompleted = false;
    /**
     * When true, the field will be readonly. It will display only the label and value as plain text.
     */
    this.isReadOnly = false;
    this.useExternal = false;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-business-classification-selector');
    customElements.whenDefined('bp-sdk-external-business-classification-selector').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-business-classification-selector", { answerId: this.answerId, choiceId: this.choiceId, choices: this.choices, code: this.code, errors: this.errors, errorText: this.errorText, fieldType: this.fieldType, helpText: this.helpText, answeredBySource: this.answeredBySource, isCompleted: this.isCompleted, isRefilteringEnabled: this.isRefilteringEnabled, isReadOnly: this.isReadOnly, label: this.label, labelId: this.labelId, labelledBy: this.labelledBy, placeholder: this.placeholder, pristine: this.pristine, questionId: this.questionId, required: this.required, selectedChoices: this.selectedChoices, showChoices: this.showChoices, showConfidence: this.showConfidence, showNaicsCode: this.showNaicsCode, touched: this.touched }));
  }
  renderInternal() {
    var _a;
    return (index.h("div", { class: "bp-sdk-business-classification-selector__container" }, index.h("bp-sdk-autocomplete-input", { answerId: this.answerId, choiceId: this.choiceId, choices: this.selectedChoices, disableDropdown: true, errors: this.errors, errorText: this.errorText, answeredBySource: this.answeredBySource, fieldType: this.fieldType, isCompleted: this.isCompleted, isReadOnly: this.isReadOnly, label: this.label, labelId: this.labelId, labelledBy: this.labelledBy, placeholder: this.placeholder, pristine: this.pristine, questionId: this.questionId, required: this.required, touched: this.touched }), this.isRefilteringEnabled && !this.isReadOnly && (index.h("bp-sdk-business-classification-selector-nudge-container", { questionId: this.questionId })), this.showChoices && !!((_a = this.choices) === null || _a === void 0 ? void 0 : _a.length) && !this.isReadOnly && (index.h("bp-sdk-business-classification-selector-list-container", { choices: this.choices, choiceId: this.choiceId, showNaicsCode: this.showNaicsCode, showConfidence: this.showConfidence }))));
  }
};
BpSdkBusinessClassificationSelector.style = bpSdkBusinessClassificationSelectorCss;

const bpSdkBusinessClassificationSelectorCardBodyCss = "";

let BpSdkBusinessClassificationSelectorCardBody = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.useExternal = false;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-business-classification-selector-card-body');
    customElements.whenDefined('bp-sdk-external-business-classification-selector-card-body').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return index.h("bp-sdk-external-business-classification-selector-card-body", { explanation: this.explanation });
  }
  renderInternal() {
    return (index.h("div", { class: "'bp-sdk-business-classification-selector-card-body__container'" }, index.h("div", { class: "bp-sdk-business-classification-selector-card-body__text", innerHTML: this.explanation || '' })));
  }
};
BpSdkBusinessClassificationSelectorCardBody.style = bpSdkBusinessClassificationSelectorCardBodyCss;

const bpSdkBusinessClassificationSelectorCardContentCss = "";

let BpSdkBusinessClassificationSelectorCardContent = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    /**
     * Should show explanation
     */
    this.showExplanation = true;
    this.useExternal = false;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-business-classification-selector-card-content');
    customElements.whenDefined('bp-sdk-external-business-classification-selector-card-content').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-business-classification-selector-card-content", { alias: this.alias, value: this.value, highlights: this.highlights, confidence: this.confidence, explanation: this.explanation, showExplanation: this.showExplanation, showConfidence: this.showConfidence, showNaicsCode: this.showNaicsCode, showDetailedRelevanceChip: this.showDetailedRelevanceChip, isSelected: this.isSelected, isBestMatch: this.isBestMatch }));
  }
  renderInternal() {
    return (index.h("div", { class: "bp-sdk-business-classification-selector-card-content__container" }, index.h("bp-sdk-business-classification-selector-card-header", { alias: this.alias, confidence: this.confidence, showConfidence: this.showConfidence, showNaicsCode: this.showNaicsCode, value: this.value, highlights: this.highlights }), index.h("bp-sdk-business-classification-selector-card-body", { explanation: this.explanation }), this.showDetailedRelevanceChip && index.h("bp-sdk-business-classification-selector-relevance-chip", { confidence: this.confidence })));
  }
};
BpSdkBusinessClassificationSelectorCardContent.style = bpSdkBusinessClassificationSelectorCardContentCss;

const bpSdkBusinessClassificationSelectorCardHeaderCss = "";

let BpSdkBusinessClassificationSelectorCardHeader = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    /**
     * List of highlight filters
     */
    this.highlightFilters = ['synonyms', 'value'];
    this.useExternal = false;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-business-classification-selector-card-header');
    customElements.whenDefined('bp-sdk-external-business-classification-selector-card-header').then(() => {
      this.useExternal = true;
    });
    this.onHightLightsChange(this.highlights);
    this.onHighlightFilterChanges(this.highlightFilters);
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  onHightLightsChange(highlights) {
    this.updateHighlight(this.highlightFilters, highlights);
  }
  onHighlightFilterChanges(filters) {
    this.updateHighlight(filters, this.highlights);
  }
  updateHighlight(filters, highlights = []) {
    const valueHighlight = Array.isArray(highlights) && (highlights === null || highlights === void 0 ? void 0 : highlights.find(({ field }) => filters.includes(field)));
    this.highlight = !!valueHighlight ? valueHighlight.text : this.value;
  }
  renderExternal() {
    return (index.h("bp-sdk-external-business-classification-selector-card-header", { alias: this.alias, confidence: this.confidence, showConfidence: this.showConfidence, showNaicsCode: this.showNaicsCode, value: this.value, highlights: this.highlights, highlightFilters: this.highlightFilters }));
  }
  renderInternal() {
    return (index.h("div", { class: "bp-sdk-business-classification-selector-card-header__container" }, index.h("span", { class: "bp-sdk-business-classification-selector-card-header__text" }, this.highlight && (index.h("span", { class: "bp-sdk-business-classification-selector-card-header__highlight", innerHTML: this.highlight })), this.showNaicsCode && index.h("span", { class: "bp-sdk-business-classification-selector-card-header__alias" }, " - ", this.alias)), this.showConfidence && index.h("bp-sdk-class-selector-relevance-chip", { confidence: this.confidence })));
  }
  static get watchers() { return {
    "highlights": ["onHightLightsChange"],
    "highlightFilters": ["onHighlightFilterChanges"]
  }; }
};
BpSdkBusinessClassificationSelectorCardHeader.style = bpSdkBusinessClassificationSelectorCardHeaderCss;

/** `Object#toString` result references. */
var mapTag = '[object Map]',
    setTag = '[object Set]';

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/**
 * Checks if `value` is an empty object, collection, map, or set.
 *
 * Objects are considered empty if they have no own enumerable string keyed
 * properties.
 *
 * Array-like values such as `arguments` objects, arrays, buffers, strings, or
 * jQuery-like collections are considered empty if they have a `length` of `0`.
 * Similarly, maps and sets are considered empty if they have a `size` of `0`.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is empty, else `false`.
 * @example
 *
 * _.isEmpty(null);
 * // => true
 *
 * _.isEmpty(true);
 * // => true
 *
 * _.isEmpty(1);
 * // => true
 *
 * _.isEmpty([1, 2, 3]);
 * // => false
 *
 * _.isEmpty({ 'a': 1 });
 * // => false
 */
function isEmpty(value) {
  if (value == null) {
    return true;
  }
  if (isEqual.isArrayLike_1(value) &&
      (isEqual.isArray_1(value) || typeof value == 'string' || typeof value.splice == 'function' ||
        isEqual.isBuffer_1(value) || isEqual.isTypedArray_1(value) || isEqual.isArguments_1(value))) {
    return !value.length;
  }
  var tag = isEqual._getTag(value);
  if (tag == mapTag || tag == setTag) {
    return !value.size;
  }
  if (isEqual._isPrototype(value)) {
    return !isEqual._baseKeys(value).length;
  }
  for (var key in value) {
    if (hasOwnProperty.call(value, key)) {
      return false;
    }
  }
  return true;
}

var isEmpty_1 = isEmpty;

const bpSdkBusinessClassificationSelectorContainerCss = "";

let BpSdkBusinessClassificationSelectorContainer = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    /**
     * Question code
     */
    this.code = '';
    /**
     * Placeholder to display
     */
    this.placeholder = '';
    /**
     * Is required value
     */
    this.required = false;
    /**
     * Is touched
     */
    this.touched = false;
    /**
     * Is pristine
     */
    this.pristine = true;
    /**
     * Is answer in complete state
     */
    this.isCompleted = false;
    /**
     * When true, the field will be readonly. It will display only the label and value as plain text.
     */
    this.isReadOnly = false;
    /**
     * Choices from answer
     */
    this.choices = [];
    /**
     * Choices injected from redux
     */
    this.remoteChoices = [];
    /**
     * Is refiltered enabled injected from redux
     */
    this.isRefilteringEnabled = false;
    this.choiceMap = {};
    this._selectedChoices = [];
    this._searchChoices = [];
    this._currentSearchValue = '';
    this.useExternal = false;
    this.showChoices = false;
    this._refilterAnswers = {};
    this.handleSubscriptions = () => {
      if (store.canGetStore()) {
        this.storeUnsubscribe && this.storeUnsubscribe();
        store.store.mapDispatchToProps(this, { searchChoices: sdkRedux.searchChoices, removeActiveAnswerId: sdkRedux.removeActiveAnswerId, searchChoicesWithNudges: sdkRedux.searchChoicesWithNudges });
        this.storeUnsubscribe = store.store.mapStateToProps(this, this.mapStateToProps);
      }
    };
    this.mapStateToProps = (state) => {
      return {
        showNaicsCode: state.viewState.features.list.includes('bcs_show_naics_code'),
        showConfidence: state.viewState.features.list.includes('bcs_show_naics_level'),
        remoteChoices: sdkRedux.getSelectedChoices(state, this.questionId),
        config: sdkRedux.getPartnerEngineConfig(state),
        isRefilteringEnabled: sdkRedux.isFeatureEnabled(state, 'bcs_refilter'),
      };
    };
  }
  resetState() {
    this.showChoices = false;
    this._currentSearchValue = '';
  }
  connectedCallback() {
    this.resetState();
    this.handleSubscriptions();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-business-classification-selector-container');
    customElements.whenDefined('bp-sdk-external-business-classification-selector-container').then(() => {
      this.useExternal = true;
    });
    this.onQuestionIdChange();
    this.onChoicesChange(this.choices || []);
  }
  disconnectedCallback() {
    this.storeUnsubscribe && this.storeUnsubscribe();
  }
  onQuestionIdChange() {
    this.handleSubscriptions();
  }
  doSearchChoices() {
    if (this.useExternal) {
      return;
    }
    const params = {
      config: this.config,
      filter: this._currentSearchValue,
      questionId: this.questionId,
      timestamp: Date.now(),
      refilter: null,
    };
    if (this.isRefilteringEnabled) {
      if (!isEmpty_1(this._refilterAnswers)) {
        params.refilter = JSON.stringify(this._refilterAnswers);
      }
      this.searchChoicesWithNudges(params);
    }
    else {
      this.searchChoices(params);
    }
  }
  onFilterUpdate({ detail }) {
    if (this.useExternal) {
      return;
    }
    this.showChoices = true;
    this._currentSearchValue = detail.value;
    this._refilterAnswers = {};
    this.doSearchChoices();
  }
  onRefilterAnswer({ detail }) {
    // Add nudge answer to local state, it gets used in doSearchChoices
    this._refilterAnswers[detail.key] = detail.answer ? 'Y' : 'N';
    this.doSearchChoices();
  }
  onValueUpdate() {
    if (this.useExternal) {
      return;
    }
    this.showChoices = false;
    this.removeActiveAnswerId();
  }
  onChoicesChange(choices) {
    this.choiceMap = choices.reduce((acc, choice) => (Object.assign(Object.assign({}, acc), { [choice.id]: [choice] })), {});
  }
  onChoicesUpdate(choices) {
    this.updateComposedChoices(choices, this.choiceMap);
  }
  onChoiceMapUpdate(choiceMap) {
    this.updateComposedChoices(this.remoteChoices, choiceMap);
  }
  updateComposedChoices(searchChoices, choiceMap) {
    this._selectedChoices = choiceMap && choiceMap[this.choiceId] ? choiceMap[this.choiceId] : [];
    this._searchChoices = searchChoices;
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-business-classification-selector-container", { answerId: this.answerId, choiceId: this.choiceId, choices: this.choices, code: this.code, config: this.config, errors: this.errors, errorText: this.errorText, fieldType: this.fieldType, helpText: this.helpText, answeredBySource: this.answeredBySource, isCompleted: this.isCompleted, isReadOnly: this.isReadOnly, labelId: this.labelId, label: this.label, labelledBy: this.labelledBy, placeholder: this.placeholder, pristine: this.pristine, questionId: this.questionId, remoteChoices: this.remoteChoices, required: this.required, touched: this.touched, showConfidence: this.showConfidence, showNaicsCode: this.showNaicsCode, selectedChoices: this._selectedChoices, isRefilteringEnabled: this.isRefilteringEnabled }));
  }
  renderInternal() {
    return [
      index.h("bp-sdk-business-classification-selector", { answerId: this.answerId, choiceId: this.choiceId, choices: this._searchChoices, code: this.code, errors: this.errors, errorText: this.errorText, fieldType: this.fieldType, helpText: this.helpText, answeredBySource: this.answeredBySource, isCompleted: this.isCompleted, isReadOnly: this.isReadOnly, label: this.label, labelId: this.labelId, labelledBy: this.labelledBy, placeholder: this.placeholder, pristine: this.pristine, questionId: this.questionId, required: this.required, touched: this.touched, showChoices: this.showChoices, showConfidence: this.showConfidence, showNaicsCode: this.showNaicsCode, selectedChoices: this._selectedChoices, isRefilteringEnabled: this.isRefilteringEnabled }),
    ];
  }
  get el() { return index.getElement(this); }
  static get watchers() { return {
    "questionId": ["onQuestionIdChange"],
    "choices": ["onChoicesChange"],
    "remoteChoices": ["onChoicesUpdate"],
    "choiceMap": ["onChoiceMapUpdate"]
  }; }
};
BpSdkBusinessClassificationSelectorContainer.style = bpSdkBusinessClassificationSelectorContainerCss;

const bpSdkBusinessClassificationSelectorListCss = "";

let BpSdkBusinessClassificationSelectorList = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    /***
     * Choices to display
     */
    this.choices = [];
    this.useExternal = false;
    this.groupedChoices = [];
    this.calculateGroupedChoices = (choices = []) => {
      var _a, _b;
      const topChoices = [...choices]
        .sort((a, b) => (b.score || 0) - (a.score || 0))
        .slice(0, ((_a = this.groupedChoicesConfig) === null || _a === void 0 ? void 0 : _a.maxResults) || 7);
      this.groupedChoices = index_esm_min.r3(topChoices);
      this.highestChoiceScore = ((_b = this.groupedChoices[0]) === null || _b === void 0 ? void 0 : _b.score) || 1000;
    };
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-business-classification-selector-list');
    customElements.whenDefined('bp-sdk-external-business-classification-selector-list').then(() => {
      this.useExternal = true;
    });
    this.calculateGroupedChoices(this.choices);
  }
  onChoicesChange(choices) {
    this.calculateGroupedChoices(choices);
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-business-classification-selector-list", { choices: this.choices, choiceId: this.choiceId, showConfidence: this.showConfidence, showNaicsCode: this.showNaicsCode, groupedChoicesConfig: this.groupedChoicesConfig }));
  }
  renderInternal() {
    return (index.h("div", { class: "bp-sdk-business-classification-selector-list__container" }, this.groupedChoices.map((choiceGroup) => {
      var _a, _b;
      return (index.h("bp-sdk-business-classification-selector-naics-group", { showNaicsCode: this.showNaicsCode, showConfidence: this.showConfidence, naicsCode: choiceGroup.alias, naicsExplanation: ((_a = choiceGroup.choices[0]) === null || _a === void 0 ? void 0 : _a.explanation) || '', naicsDescription: ((_b = choiceGroup.choices[0]) === null || _b === void 0 ? void 0 : _b.national_industry_description) || '', choices: choiceGroup.choices, choiceId: this.choiceId, highestChoiceScore: this.highestChoiceScore }));
    })));
  }
  static get watchers() { return {
    "choices": ["onChoicesChange"]
  }; }
};
BpSdkBusinessClassificationSelectorList.style = bpSdkBusinessClassificationSelectorListCss;

const bpSdkBusinessClassificationSelectorListContainerCss = "";

let BpSdkBusinessClassificationSelectorListContainer = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    /***
     * Choices to display
     */
    this.choices = [];
    /**
     * Grouped choices config
     */
    this.groupedChoicesConfig = { maxResults: 7 };
    this.useExternal = false;
    this.handleSubscriptions = () => {
      if (store.canGetStore()) {
        this.storeUnsubscribe && this.storeUnsubscribe();
        this.storeUnsubscribe = store.store.mapStateToProps(this, this.mapStateToProps);
      }
    };
    this.mapStateToProps = (state) => {
      return {
        groupedChoicesConfig: { maxResults: sdkRedux.getConfigOptions(state).bcsChoiceLimit },
      };
    };
  }
  resetState() {
    this.groupedChoicesConfig = { maxResults: 7 };
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-business-classification-selector-list-container');
    customElements.whenDefined('bp-sdk-external-business-classification-selector-list-container').then(() => {
      this.useExternal = true;
    });
  }
  connectedCallback() {
    this.resetState();
    this.handleSubscriptions();
  }
  disconnectedCallback() {
    this.storeUnsubscribe && this.storeUnsubscribe();
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-business-classification-selector-list-container", { choices: this.choices, choiceId: this.choiceId, showConfidence: this.showConfidence, showNaicsCode: this.showNaicsCode, groupedChoicesConfig: this.groupedChoicesConfig }));
  }
  renderInternal() {
    return (index.h("bp-sdk-business-classification-selector-list", { choices: this.choices, choiceId: this.choiceId, showConfidence: this.showConfidence, showNaicsCode: this.showNaicsCode, groupedChoicesConfig: this.groupedChoicesConfig }));
  }
  get el() { return index.getElement(this); }
};
BpSdkBusinessClassificationSelectorListContainer.style = bpSdkBusinessClassificationSelectorListContainerCss;

const bpSdkBusinessClassificationSelectorListItemCss = "";

let BpSdkBusinessClassificationSelectorListItem = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.valueUpdate = index.createEvent(this, "valueUpdate", 7);
    /**
     * Is choice selected
     */
    this.isSelected = false;
    /**
     * Should show explanation
     */
    this.showExplanation = true;
    this.useExternal = false;
    this.isExpanded = false;
    this.onSelection = (e) => {
      e.preventDefault();
      if (!this.locked) {
        this.valueUpdate.emit([this.choiceId]);
      }
    };
    this.onKeyPress = (e) => {
      if (e.key === 'Enter' || e.key === ' ') {
        this.onSelection(e);
      }
    };
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-business-classification-selector-list-item');
    customElements.whenDefined('bp-sdk-external-business-classification-selector-list-item').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-business-classification-selector-list-item", { alias: this.alias, isSelected: this.isSelected, showExplanation: this.showExplanation, confidence: this.confidence, choiceId: this.choiceId, showConfidence: this.showConfidence, value: this.value, highlights: this.highlights, showDetailedRelevanceChip: this.showDetailedRelevanceChip, isBestMatch: this.isBestMatch, locked: this.locked }));
  }
  renderInternal() {
    return (index.h("div", { class: "bp-sdk-business-classification-selector-list-item__container" }, index.h("bp-sdk-business-classification-selector-card-content", { alias: this.alias, confidence: this.confidence, onClick: this.onSelection, showConfidence: this.showConfidence, showDetailedRelevanceChip: this.showDetailedRelevanceChip, value: this.value, highlights: this.highlights, isSelected: this.isSelected, isBestMatch: this.isBestMatch, tabIndex: 0, role: "button", onKeyPress: this.onKeyPress })));
  }
};
BpSdkBusinessClassificationSelectorListItem.style = bpSdkBusinessClassificationSelectorListItemCss;

const bpSdkBusinessClassificationSelectorListItemContainerCss = "";

let BpSdkBusinessClassificationSelectorListItemContainer = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    /**
     * Is choice selected
     */
    this.isSelected = false;
    /**
     * Should show explanation
     */
    this.showExplanation = true;
    /**
     * Decision to show detailed relevance chip injected by redux
     */
    this.showDetailedRelevanceChip = false;
    this.useExternal = false;
    this.isLocked = false;
    this.handleSubscriptions = () => {
      if (store.canGetStore()) {
        this.storeUnsubscribe && this.storeUnsubscribe();
        this.storeUnsubscribe = store.store.mapStateToProps(this, this.mapStateToProps);
      }
    };
    this.mapStateToProps = (state) => {
      return {
        showDetailedRelevanceChip: sdkRedux.areDetailedRelevanceChipsEnabled(state),
        enableUserApplicationGuard: !!state.config.options.enableUserApplicationGuard,
        locked: state.application.form.locked,
        isOwner: sdkRedux.doesUserOwnApplicationForm(state),
        hasPermissionToEdit: sdkRedux.userHasPermission(state, {
          permission: index_esm_min$1.v.ApplicationForms,
          action: index_esm_min$1.h.Update,
        }),
      };
    };
  }
  onEnableUserApplicationGuard(enableUserApplicationGuard) {
    this.updateIsLocked(this.locked, this.isOwner, this.hasPermissionToEdit, enableUserApplicationGuard);
  }
  onHasPermissionToEdit(hasPermission) {
    this.updateIsLocked(this.locked, this.isOwner, hasPermission, this.enableUserApplicationGuard);
  }
  onIsOwner(isOwner) {
    this.updateIsLocked(this.locked, isOwner, this.hasPermissionToEdit, this.enableUserApplicationGuard);
  }
  onLocked(locked) {
    this.updateIsLocked(locked, this.isOwner, this.hasPermissionToEdit, this.enableUserApplicationGuard);
  }
  updateIsLocked(locked, isOwner, hasPermission, enableUserApplicationGuard) {
    this.isLocked = locked || (enableUserApplicationGuard && (!isOwner || !hasPermission));
  }
  resetState() {
    this.showDetailedRelevanceChip = false;
  }
  connectedCallback() {
    this.resetState();
    this.handleSubscriptions();
  }
  disconnectedCallback() {
    this.storeUnsubscribe && this.storeUnsubscribe();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-business-classification-selector-list-item-container');
    customElements.whenDefined('bp-sdk-external-business-classification-selector-list-item-container').then(() => {
      this.useExternal = true;
    });
    this.handleSubscriptions();
    this.updateIsLocked(this.locked, this.isOwner, this.hasPermissionToEdit, this.enableUserApplicationGuard);
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-business-classification-selector-list-item-container", { alias: this.alias, choiceId: this.choiceId, confidence: this.confidence, isSelected: this.isSelected, showConfidence: this.showConfidence, showExplanation: this.showExplanation, value: this.value, highlights: this.highlights, showDetailedRelevanceChip: this.showDetailedRelevanceChip, isBestMatch: this.isBestMatch, locked: this.locked, isOwner: this.isOwner, hasPermissionToEdit: this.hasPermissionToEdit, enableUserApplicationGuard: this.enableUserApplicationGuard }));
  }
  renderInternal() {
    return (index.h("bp-sdk-business-classification-selector-list-item", { alias: this.alias, choiceId: this.choiceId, confidence: this.confidence, isSelected: this.isSelected, showConfidence: this.showConfidence, showExplanation: this.showExplanation, value: this.value, highlights: this.highlights, showDetailedRelevanceChip: this.showDetailedRelevanceChip, locked: this.isLocked, isBestMatch: this.isBestMatch }));
  }
  static get watchers() { return {
    "enableUserApplicationGuard": ["onEnableUserApplicationGuard"],
    "hasPermissionToEdit": ["onHasPermissionToEdit"],
    "isOwner": ["onIsOwner"],
    "locked": ["onLocked"]
  }; }
};
BpSdkBusinessClassificationSelectorListItemContainer.style = bpSdkBusinessClassificationSelectorListItemContainerCss;

const bpSdkBusinessClassificationSelectorNaicsGroupCss = "";

let BpSdkBusinessClassificationSelectorNaicsGroup = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    /***
     * Choices to display
     */
    this.choices = [];
    /**
     * NAICS code for this group
     */
    this.naicsCode = '';
    /**
     * NAICS explanation for this group
     */
    this.naicsExplanation = '';
    /**
     * NAICS industry description for this group
     */
    this.naicsDescription = '';
    this.useExternal = false;
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-business-classification-selector-naics-group');
    customElements.whenDefined('bp-sdk-external-business-classification-selector-naics-group').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-business-classification-selector-naics-group", { choices: this.choices, showConfidence: this.showNaicsCode, showNaicsCode: this.showNaicsCode, naicsCode: this.naicsCode, naicsDescription: this.naicsDescription, naicsExplanation: this.naicsExplanation, highestChoiceScore: this.highestChoiceScore, choiceId: this.choiceId }));
  }
  renderInternal() {
    var _a;
    return (index.h("div", { class: "bp-sdk-business-classification-selector-naics-group__container" }, index.h("bp-sdk-business-classification-selector-naics-group-header", { naicsCode: this.showNaicsCode ? this.naicsCode : undefined, naicsDescription: this.naicsDescription, naicsExplanation: this.naicsExplanation }), (_a = this.choices) === null || _a === void 0 ? void 0 :
      _a.map((choice) => (index.h("bp-sdk-business-classification-selector-list-item-container", { alias: choice.alias, choiceId: choice.id, confidence: choice.confidence, isSelected: choice.id === this.choiceId, showConfidence: this.showConfidence, showExplanation: choice.showExplanation, value: choice.value, highlights: choice.highlights, isBestMatch: choice.score === this.highestChoiceScore })))));
  }
};
BpSdkBusinessClassificationSelectorNaicsGroup.style = bpSdkBusinessClassificationSelectorNaicsGroupCss;

const bpSdkBusinessClassificationSelectorNaicsGroupHeaderCss = ".bp-sdk-business-classification-selector-naics-group-header__heading--popover{display:none}";

let BpSdkBusinessClassificationSelectorNaicsGroupHeader = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    /**
     * NAICS description for this group
     */
    this.naicsDescription = '';
    /**
     * NAICS explanation for this group
     * This is hidden from displaying by default via CSS. The intention is to show it in a hover or popover
     */
    this.naicsExplanation = '';
    this.useExternal = false;
  }
  resetState() { }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-business-classification-selector-naics-group-header');
    customElements.whenDefined('bp-sdk-external-business-classification-selector-naics-group-header').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-business-classification-selector-naics-group-header", { naicsCode: this.naicsCode, naicsExplanation: this.naicsExplanation, naicsDescription: this.naicsDescription }));
  }
  renderInternal() {
    return (index.h("div", { class: "bp-sdk-business-classification-selector-naics-group-header__container" }, index.h("h2", { class: "bp-sdk-business-classification-selector-naics-group-header__heading" }, this.naicsDescription, this.naicsCode && (index.h("span", { class: "bp-sdk-business-classification-selector-naics-group-header__heading--code" }, " - ", this.naicsCode)), this.naicsExplanation && (index.h("span", { class: "bp-sdk-business-classification-selector-naics-group-header__heading--popover" }, this.naicsExplanation)))));
  }
};
BpSdkBusinessClassificationSelectorNaicsGroupHeader.style = bpSdkBusinessClassificationSelectorNaicsGroupHeaderCss;

const bpSdkBusinessClassificationSelectorNudgeCss = "";

let BpSdkBusinessClassificationSelectorNudge = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.useExternal = false;
    this.onYesClick = (evt) => {
      var _a;
      this.handleYesClick((_a = this.refilter) === null || _a === void 0 ? void 0 : _a.key, evt);
    };
    this.onNoClick = (evt) => {
      var _a;
      this.handleNoClick((_a = this.refilter) === null || _a === void 0 ? void 0 : _a.key, evt);
    };
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-business-classification-selector-nudge');
    customElements.whenDefined('bp-sdk-external-business-classification-selector-nudge').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-business-classification-selector-nudge", { refilter: this.refilter, handleYesClick: this.handleYesClick, handleNoClick: this.handleNoClick }));
  }
  renderInternal() {
    var _a;
    return (index.h("div", { class: "bp-sdk-business-classification-selector-nudge__container" }, index.h("span", { class: "bp-sdk-business-classification-selector-nudge__question" }, (_a = this.refilter) === null || _a === void 0 ? void 0 : _a.text), index.h("button", { class: "bp-sdk-business-classification-selector-nudge__btn bp-sdk-business-classification-selector-nudge__btn--yes", onClick: this.onYesClick }, "Yes"), index.h("button", { class: "bp-sdk-business-classification-selector-nudge__btn bp-sdk-business-classification-selector-nudge__btn--no", onClick: this.onNoClick }, "No")));
  }
};
BpSdkBusinessClassificationSelectorNudge.style = bpSdkBusinessClassificationSelectorNudgeCss;

const bpSdkBusinessClassificationSelectorNudgeContainerCss = "";

let BpSdkBusinessClassificationSelectorNudgeContainer = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.nudgeAnswer = index.createEvent(this, "nudgeAnswer", 7);
    /**
     * Nudges available in the Redux store
     */
    this.nudges = [];
    this.useExternal = false;
    /**
     * Are nudges hidden from UI?
     */
    this.isHidden = true;
    this.handleSubscriptions = () => {
      if (store.canGetStore()) {
        this.storeUnsubscribe && this.storeUnsubscribe();
        this.storeUnsubscribe = store.store.mapStateToProps(this, this.mapStateToProps);
      }
    };
    this.mapStateToProps = (state) => {
      return {
        nudges: sdkRedux.getUnansweredRefiltersByQuestionId(state, this.questionId),
      };
    };
    this.handleYesClick = (key, evt) => {
      if (evt && !this.useExternal) {
        evt.stopPropagation();
      }
      this.nudgeAnswer.emit({
        key,
        answer: true,
      });
    };
    this.handleNoClick = (key, evt) => {
      if (evt && !this.useExternal) {
        evt.stopPropagation();
      }
      this.nudgeAnswer.emit({
        key,
        answer: false,
      });
    };
  }
  resetState() {
    this.isHidden = true;
  }
  connectedCallback() {
    this.resetState();
    this.handleSubscriptions();
  }
  disconnectedCallback() {
    this.storeUnsubscribe && this.storeUnsubscribe();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-business-classification-selector-nudge-container');
    customElements.whenDefined('bp-sdk-external-business-classification-selector-nudge-container').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-business-classification-selector-nudge-container", { isHidden: this.isHidden, nudges: this.nudges, questionId: this.questionId }));
  }
  renderInternal() {
    return (index.h("div", { class: "bp-sdk-business-classification-selector-nudge-container__container" }, this.nudges.map((refilter) => (index.h("bp-sdk-business-classification-selector-nudge", { refilter: refilter, handleYesClick: this.handleYesClick, handleNoClick: this.handleNoClick })))));
  }
};
BpSdkBusinessClassificationSelectorNudgeContainer.style = bpSdkBusinessClassificationSelectorNudgeContainerCss;

const bpSdkBusinessClassificationSelectorRelevanceChipCss = "";

let BpSdkBusinessClassificationSelectorRelevanceChip = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.useExternal = false;
    this.relevance = 'high';
  }
  onConfidenceChange(confidence) {
    let relevance = 'High';
    if (confidence === 1) {
      relevance = 'Medium';
    }
    else if (confidence <= 0) {
      relevance = 'Low';
    }
    this.relevance = relevance;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-business-classification-selector-relevance-chip');
    customElements.whenDefined('bp-sdk-external-business-classification-selector-relevance-chip').then(() => {
      this.useExternal = true;
    });
    this.onConfidenceChange(this.confidence);
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return index.h("bp-sdk-external-business-classification-selector-relevance-chip", { confidence: this.confidence });
  }
  renderInternal() {
    return (index.h("span", { class: "bp-sdk-business-classification-selector-relevance-chip__container" }, index.h("span", { class: "bp-sdk-business-classification-selector-relevance-chip__wrapper" }, index.h("span", { class: "bp-sdk-business-classification-selector-relevance-chip__content" }, this.relevance, " Relevance"))));
  }
  static get watchers() { return {
    "confidence": ["onConfidenceChange"]
  }; }
};
BpSdkBusinessClassificationSelectorRelevanceChip.style = bpSdkBusinessClassificationSelectorRelevanceChipCss;

const bpSdkCheckboxInputCss = ".bp-sdk-checkbox__label:not(.read-only),.bp-sdk-checkbox__input{cursor:pointer}";

let BpSdkCheckboxInput = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.valueUpdate = index.createEvent(this, "valueUpdate", 7);
    /**
     * Is touched
     */
    this.touched = false;
    /**
     * is pristine
     */
    this.pristine = true;
    /**
     * Is answer in complete state
     */
    this.isCompleted = false;
    /**
     * When true, the field will be readonly. It will display only the label and value as plain text.
     */
    this.isReadOnly = false;
    this.useExternal = false;
    this.onChange = (ev) => {
      const checked = ev.target.checked;
      this.valueUpdate.emit(checked);
    };
  }
  onCodeChange(code) {
    this.updateId(code, this.answerId);
  }
  onAnswerIdChange(answerId) {
    this.updateId(this.code, answerId);
  }
  updateId(code, answerId) {
    this.id = `bp-sdk-checkbox-${code}-${answerId}-input`;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-checkbox-input');
    customElements.whenDefined('bp-sdk-external-checkbox-input').then(() => {
      this.useExternal = true;
    });
    this.onCodeChange(this.code);
    this.onAnswerIdChange(this.answerId);
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-checkbox-input", { answeredBySource: this.answeredBySource, answerId: this.answerId, code: this.code, errorText: this.errorText, errors: this.errors, fieldType: this.fieldType, helpText: this.helpText, isCompleted: this.isCompleted, isReadOnly: this.isReadOnly, label: this.label, labelledBy: this.labelledBy, pristine: this.pristine, questionId: this.questionId, required: this.required, touched: this.touched, value: this.value }));
  }
  renderInternal() {
    var _a;
    return (index.h("div", { class: "bp-sdk-checkbox__container" }, index.h("div", { class: "bp-sdk-checkbox__wrapper" }, !this.isReadOnly && (index.h("input", { id: this.id, class: "bp-sdk-checkbox__input", type: "checkbox", "aria-labelledby": this.labelledBy, name: this.code, checked: !!this.value, onChange: this.onChange })), index.h("label", { htmlFor: this.id, class: {
        'bp-sdk-checkbox__label': true,
        'read-only': this.isReadOnly,
      } }, this.label), this.isReadOnly && this.renderReadOnlyElement(this.value ? 'Yes' : 'No')), this.touched && !this.pristine && ((this.errorText && !this.isCompleted) || !!((_a = this.errors) === null || _a === void 0 ? void 0 : _a.length)) && (index.h("bp-sdk-errors-container", { answerId: this.answerId, questionId: this.questionId, fieldType: this.fieldType, errors: this.errors, errorText: this.errorText }))));
  }
  renderReadOnlyElement(value) {
    return index.h("span", { class: "read-only-value" }, value);
  }
  static get watchers() { return {
    "code": ["onCodeChange"],
    "answerId": ["onAnswerIdChange"]
  }; }
};
BpSdkCheckboxInput.style = bpSdkCheckboxInputCss;

const bpSdkDateInputCss = "";

let BpSdkDateInput = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.valueUpdate = index.createEvent(this, "valueUpdate", 7);
    /**
     * Placeholder to display
     */
    this.placeholder = 'Pick a date';
    /**
     * Is touched
     */
    this.touched = false;
    /**
     * Is pristine
     */
    this.pristine = true;
    /**
     * Is answer in complete state
     */
    this.isCompleted = false;
    /**
     * When true, the field will be readonly. It will display only the label and value as plain text.
     */
    this.isReadOnly = false;
    /**
     * Error messages
     */
    this.errors = [];
    /**
     * Is sensitive
     */
    this.isSensitive = false;
    this.useExternal = false;
  }
  resetState() {
    this._value = undefined;
  }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-date-input');
    customElements.whenDefined('bp-sdk-external-date-input').then(() => {
      this.useExternal = true;
    });
    this.onValueChange(this.value);
    this.onAriaLabelledByChange(this.labelId);
    this.onLabelledByChange(this.labelledBy);
  }
  componentDidLoad() {
    const el = this.getDatePicker();
    if (el === null || el === void 0 ? void 0 : el._setTheme) {
      el._setTheme('calendar');
    }
  }
  getDatePicker() {
    return this.el.querySelector('.bp-sdk-date__picker');
  }
  onAriaLabelledByChange(labelId) {
    this.updateLabelledBy(labelId, this.labelledBy);
  }
  onLabelledByChange(labelledBy) {
    this.updateLabelledBy(this.labelId, labelledBy);
  }
  updateLabelledBy(aria, ids) {
    const prefix = ids ? `${ids} ` : '';
    this._labelledBy = `${prefix}${aria !== null && aria !== void 0 ? aria : ''}` || undefined;
  }
  onValueChange(newValue) {
    if (newValue != null) {
      this._value = index_esm_min.px(new Date(newValue));
    }
  }
  onChange(event) {
    if (this.useExternal) {
      return;
    }
    const value = new Date(event.target.value);
    try {
      const date = index_esm_min.px(value);
      this._value = date;
      if (this.value != this._value) {
        this.valueUpdate.emit(value.toISOString());
      }
    }
    catch (ex) {
      // don't use bad iso8601 dates
      // TODO: error logging
    }
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-date-input", { answerId: this.answerId, code: this.code, errors: this.errors, errorText: this.errorText, fieldType: this.fieldType, helpText: this.helpText, answeredBySource: this.answeredBySource, isCompleted: this.isCompleted, isReadOnly: this.isReadOnly, isSensitive: this.isSensitive, labelId: this.labelId, label: this.label, labelledBy: this.labelledBy, maxDate: this.maxDate, minDate: this.minDate, pattern: this.pattern, placeholder: this.placeholder, pristine: this.pristine, questionId: this.questionId, required: this.required, text: this.text, touched: this.touched, value: this.value }));
  }
  renderInternal() {
    var _a;
    const input = this.isReadOnly ? this.renderReadOnlyElement(this.value) : this.renderInput();
    return (index.h("div", { class: "bp-sdk-date__container" }, index.h("label", { id: this.labelId, htmlFor: `bp-sdk-date__${this.labelId}__input`, class: "bp-sdk-label bp-sdk-date__label", innerHTML: this.label }), input, this.touched && !this.pristine && ((this.errorText && !this.isCompleted) || !!((_a = this.errors) === null || _a === void 0 ? void 0 : _a.length)) && (index.h("bp-sdk-errors-container", { answerId: this.answerId, questionId: this.questionId, fieldType: this.fieldType, minDate: this.minDate, maxDate: this.maxDate, pattern: this.pattern, errors: this.errors, errorText: this.errorText }))));
  }
  renderInput() {
    return (index.h("input", { id: `bp-sdk-date__${this.labelId}__input`, class: "bp-sdk-date__input", "aria-labelledby": this._labelledBy, type: "date", placeholder: this.placeholder, size: 10, min: this.minDate, max: this.maxDate, value: this._value }));
  }
  renderReadOnlyElement(value) {
    return (index.h("span", { class: "read-only-value" }, value));
  }
  get el() { return index.getElement(this); }
  static get watchers() { return {
    "labelId": ["onAriaLabelledByChange"],
    "labelledBy": ["onLabelledByChange"],
    "value": ["onValueChange"]
  }; }
};
BpSdkDateInput.style = bpSdkDateInputCss;

const bpSdkDateInputContainerCss = "";

let BpSdkDateInputContainer = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.valueUpdate = index.createEvent(this, "valueUpdate", 7);
    /**
     * Placeholder to display
     */
    this.placeholder = 'Pick a date';
    /**
     * Is touched
     */
    this.touched = false;
    /**
     * Is pristine
     */
    this.pristine = true;
    /**
     * Is answer in complete state
     */
    this.isCompleted = false;
    /**
     * When true, the field will be readonly. It will display only the label and value as plain text.
     */
    this.isReadOnly = false;
    /**
     * Error messages
     */
    this.errors = [];
    /**
     * Is sensitive
     */
    this.isSensitive = false;
    this.useExternal = false;
  }
  resetState() {
    this._value = undefined;
  }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-date-input-container');
    customElements.whenDefined('bp-sdk-external-date-input-container').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-date-input-container", { answerId: this.answerId, code: this.code, errors: this.errors, errorText: this.errorText, fieldType: this.fieldType, helpText: this.helpText, answeredBySource: this.answeredBySource, isCompleted: this.isCompleted, isReadOnly: this.isReadOnly, isSensitive: this.isSensitive, labelId: this.labelId, label: this.label, labelledBy: this.labelledBy, maxDate: this.maxDate, minDate: this.minDate, pattern: this.pattern, placeholder: this.placeholder, pristine: this.pristine, questionId: this.questionId, required: this.required, text: this.text, touched: this.touched, value: this.value }));
  }
  renderInternal() {
    return (index.h("bp-sdk-date-input", { answerId: this.answerId, code: this.code, errors: this.errors, errorText: this.errorText, fieldType: this.fieldType, helpText: this.helpText, answeredBySource: this.answeredBySource, isCompleted: this.isCompleted, isReadOnly: this.isReadOnly, isSensitive: this.isSensitive, label: this.label, labelId: this.labelId, labelledBy: this.labelledBy, maxDate: this.maxDate, minDate: this.minDate, pattern: this.pattern, placeholder: this.placeholder, pristine: this.pristine, questionId: this.questionId, required: this.required, text: this.text, touched: this.touched, value: this.value }));
  }
  get el() { return index.getElement(this); }
};
BpSdkDateInputContainer.style = bpSdkDateInputContainerCss;

const bpSdkDeleteButtonCss = "";

let BpSdkDeleteButton = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.useExternal = false;
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-delete-button');
    customElements.whenDefined('bp-sdk-external-delete-button').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return index.h("bp-sdk-external-delete-button", null);
  }
  renderInternal() {
    return (index.h("button", { class: "bp-sdk-delete-button" }, index.h("bp-sdk-icon-container", { name: "trashcan" }, index.h("slot", null, "Delete"))));
  }
};
BpSdkDeleteButton.style = bpSdkDeleteButtonCss;

const bpSdkDeleteQuestionPoolItemCss = "";

let BpSdkDeleteQuestionPoolItem = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.useExternal = false;
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-delete-question-pool-item');
    customElements.whenDefined('bp-sdk-external-delete-question-pool-item').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return index.h("bp-sdk-external-delete-question-pool-item", { text: this.text, handleRemoveItem: this.handleRemoveItem });
  }
  renderInternal() {
    return (index.h("div", { class: "bp-sdk-delete-question-pool-item__container" }, index.h("bp-sdk-delete-button", { onClick: this.handleRemoveItem }, this.text)));
  }
};
BpSdkDeleteQuestionPoolItem.style = bpSdkDeleteQuestionPoolItemCss;

const bpSdkDeleteQuestionPoolItemContainerCss = "";

let BpSdkDeleteQuestionPoolItemContainer = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    /**
     * Display text
     */
    this.text = '';
    this.questionSets = [];
    this.useExternal = false;
    this.handleSubscriptions = () => {
      if (store.canGetStore()) {
        this.storeUnsubscribe && this.storeUnsubscribe();
        store.store.mapDispatchToProps(this, { removeQuestionPool: sdkRedux.removeQuestionPool });
        this.storeUnsubscribe = store.store.mapStateToProps(this, this.mapStateToProps);
      }
    };
    this.mapStateToProps = (state) => {
      return {
        applicationId: sdkRedux.getFormId(state),
        config: sdkRedux.getPartnerEngineConfig(state),
        questionSets: sdkRedux.getQuestionSets(state),
      };
    };
    this.handleRemoveItem = () => {
      this.removeQuestionPool({
        answer_pool_id: this.questionPool.id,
        application_id: this.applicationId,
        config: this.config,
      });
    };
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
    this.handleSubscriptions();
  }
  disconnectedCallback() {
    this.storeUnsubscribe && this.storeUnsubscribe();
  }
  onQuestionSetIdChange(questionSetId) {
    this.updateQuestionPool(questionSetId, this.questionId, this.questionSets);
  }
  onQuestionIdChange(questionId) {
    this.updateQuestionPool(this.questionSetId, questionId, this.questionSets);
  }
  onQuestionSetsChange(questionSets) {
    this.updateQuestionPool(this.questionSetId, this.questionId, questionSets);
  }
  updateQuestionPool(questionSetId, questionId, questionSets) {
    var _a, _b;
    const set = questionSets === null || questionSets === void 0 ? void 0 : questionSets.filter((set) => set.question_set_id === questionSetId)[0];
    const pools = (_b = (_a = set === null || set === void 0 ? void 0 : set.question_set) === null || _a === void 0 ? void 0 : _a.question_pools) !== null && _b !== void 0 ? _b : [];
    this.questionPool = pools.find((pool) => pool.parent_question_id === questionId);
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-delete-question-pool-item-container');
    customElements.whenDefined('bp-sdk-external-delete-question-pool-item-container').then(() => {
      this.useExternal = true;
    });
    this.handleSubscriptions();
    this.onQuestionSetIdChange(this.questionSetId);
    this.onQuestionIdChange(this.questionId);
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-delete-question-pool-item-container", { applicationId: this.applicationId, config: this.config, questionId: this.questionId, questionSetId: this.questionSetId, questionSets: this.questionSets, text: this.text }));
  }
  renderInternal() {
    return (index.h("div", { class: "bp-sdk-delete-question-pool-item-container__container" }, this.questionPool && index.h("bp-sdk-delete-question-pool-item", { text: this.text, handleRemoveItem: this.handleRemoveItem })));
  }
  get el() { return index.getElement(this); }
  static get watchers() { return {
    "questionSetId": ["onQuestionSetIdChange"],
    "questionId": ["onQuestionIdChange"],
    "questionSets": ["onQuestionSetsChange"]
  }; }
};
BpSdkDeleteQuestionPoolItemContainer.style = bpSdkDeleteQuestionPoolItemContainerCss;

const bpSdkDialogCss = ".bp-sdk-dialog__container{z-index:100}.bp-sdk-dialog__header{display:flex;flex-direction:row;justify-content:flex-end}";

let BpSdkDialog = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    /**
     * Is required
     */
    this.isRequired = true;
    this.useExternal = false;
    this.isOpen = true;
    this.onClick = () => {
      this.isOpen = false;
    };
  }
  resetState() {
    this.isOpen = true;
  }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-dialog');
    customElements.whenDefined('bp-sdk-external-dialog').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-dialog", { answerId: this.answerId, code: this.code, questionId: this.questionId, isRequired: this.isRequired }, index.h("slot", null)));
  }
  renderInternal() {
    return (index.h("dialog", { open: this.isOpen, class: `bp-sdk-dialog__container bp-sdk-dialog__container-${this.answerId} bp-sdk-dialog__container-${this.code}` }, index.h("div", { class: "bp-sdk-dialog__header bp-sdk-row" }, !this.isRequired && index.h("bp-sdk-dialog-close-button", { onClick: this.onClick })), index.h("slot", null)));
  }
};
BpSdkDialog.style = bpSdkDialogCss;

const bpSdkDialogCloseButtonCss = "";

let BpSdkDialogCloseButton = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.useExternal = false;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-dialog-close-button');
    customElements.whenDefined('bp-sdk-external-dialog-close-button').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return index.h("bp-sdk-external-dialog-close-button", null);
  }
  renderInternal() {
    return (index.h("bp-sdk-button", null, index.h("bp-sdk-icon-container", { name: "times" })));
  }
};
BpSdkDialogCloseButton.style = bpSdkDialogCloseButtonCss;

const bpSdkDriverInputContainerCss = "";

let BpSdkDriverInputContainer = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.fakeValueUpdate = index.createEvent(this, "fakeValueUpdate", 7);
    /**
     * Field type
     */
    this.fieldType = 'text';
    /**
     * Placeholder to display
     */
    this.placeholder = '';
    /**
     * Is question required
     */
    this.required = false;
    /**
     * minimum length of input
     */
    this.min = -1;
    /**
     * maximum length of input
     */
    this.max = -1;
    /**
     * Error messages
     */
    this.errors = [];
    /**
     * is touched
     */
    this.touched = false;
    /**
     * is pristine
     */
    this.pristine = true;
    /**
     * Is answer in complete state
     */
    this.isCompleted = false;
    /**
     * When true, the field will be readonly. It will display only the label and value as plain text.
     */
    this.isReadOnly = false;
    /**
     * Is enabled
     */
    this.isEnabled = true;
    this.useExternal = false;
    this.mapStateToProps = (state) => {
      return {
        driverLicenseStateAnswer: sdkRedux.findActiveAnswersByGroup(state, {
          poolId: this.questionPoolId,
          groupId: this.questionGroupId,
        }).find((answer) => answer.question.reference_type === index_esm_min$1.u.DriversLicenseState),
      };
    };
  }
  resetState() {
    this.licenseError = undefined;
  }
  connectedCallback() {
    this.resetState();
    this.handleSubscriptions();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-driver-input-container');
    customElements.whenDefined('bp-sdk-external-driver-input-container').then(() => {
      this.useExternal = true;
    });
    this.handleSubscriptions();
  }
  handleSubscriptions() {
    if (store.canGetStore()) {
      this.storeUnsubscribe && this.storeUnsubscribe();
      this.storeUnsubscribe = store.store.mapStateToProps(this, this.mapStateToProps);
    }
  }
  disconnectedCallback() {
    this.storeUnsubscribe && this.storeUnsubscribe();
  }
  onSaveAnswer(e) {
    var _a, _b;
    if (this.useExternal) {
      return;
    }
    const state = (_b = (_a = this.driverLicenseStateAnswer) === null || _a === void 0 ? void 0 : _a.question.choices.find((choice) => choice.id === this.driverLicenseStateAnswer.choice_id)) === null || _b === void 0 ? void 0 : _b.alias;
    const detail = e.detail;
    this.licenseError =
      !state || !detail || index_esm_min.hf(detail, state) ? undefined : BpSdkDriverInputContainer.ERROR_MESSAGE;
    if (this.licenseError) {
      e.stopPropagation();
      this.fakeValueUpdate.emit();
    }
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-driver-input-container", { answerId: this.answerId, code: this.code, driverLicenseStateAnswer: this.driverLicenseStateAnswer, errors: this.errors, errorText: this.errorText, fieldType: this.fieldType, helpText: this.helpText, isCompleted: this.isCompleted, isEnabled: this.isEnabled, isReadOnly: this.isReadOnly, label: this.label, labelId: this.labelId, labelledBy: this.labelledBy, max: this.max, min: this.min, pattern: this.pattern, placeholder: this.placeholder, pristine: this.pristine, questionGroupId: this.questionGroupId, questionId: this.questionId, questionPoolId: this.questionPoolId, referenceType: this.referenceType, required: this.required, text: this.text, touched: this.touched }));
  }
  renderInternal() {
    var _a;
    return (index.h("bp-sdk-text-input-container", { answerId: this.answerId, code: this.code, errors: this.errors, errorText: (_a = this.licenseError) !== null && _a !== void 0 ? _a : this.errorText, fieldType: this.fieldType, helpText: this.helpText,
      // TODO: remove this if isCompleted is updated for this validation condition
      isCompleted: !this.licenseError && this.isCompleted, isReadOnly: this.isReadOnly, label: this.label, labelId: this.labelId, labelledBy: this.labelledBy, max: this.max, min: this.min, pattern: this.pattern, placeholder: this.placeholder, pristine: this.pristine, questionId: this.questionId, referenceType: this.referenceType, required: this.required, text: this.text, touched: this.touched }));
  }
  static get watchers() { return {
    "questionGroupId": ["handleSubscriptions"],
    "questionPoolId": ["handleSubscriptions"]
  }; }
};
BpSdkDriverInputContainer.ERROR_MESSAGE = `Driver's license is invalid for state`;
BpSdkDriverInputContainer.style = bpSdkDriverInputContainerCss;

/**
 * based on https://github.com/SebastianM/angular-google-maps/blob/master/packages/core/services/maps-api-loader/lazy-maps-api-loader.ts
 * license: MIT
 */
var GoogleMapsScriptProtocol;
(function (GoogleMapsScriptProtocol) {
  GoogleMapsScriptProtocol[GoogleMapsScriptProtocol["HTTP"] = 1] = "HTTP";
  GoogleMapsScriptProtocol[GoogleMapsScriptProtocol["HTTPS"] = 2] = "HTTPS";
  GoogleMapsScriptProtocol[GoogleMapsScriptProtocol["AUTO"] = 3] = "AUTO";
})(GoogleMapsScriptProtocol || (GoogleMapsScriptProtocol = {}));
const win = window;
class LazyMapsAPILoader {
  constructor() {
    this._SCRIPT_ID = 'bpSdkGoogleMapsApiScript';
    this.callbackName = `bpSdkLazyMapsAPILoader`;
  }
  load() {
    if (window['google'] && win['google'].maps) {
      // Google maps already loaded on the page.
      return Promise.resolve();
    }
    if (this._scriptLoadingPromise) {
      return this._scriptLoadingPromise;
    }
    // this can happen in HMR situations or Stackblitz.io editors.
    const scriptOnPage = document.getElementById(this._SCRIPT_ID);
    if (scriptOnPage) {
      this._assignScriptLoadingPromise(scriptOnPage);
      return this._scriptLoadingPromise;
    }
    const script = document.createElement('script');
    script.type = 'text/javascript';
    script.async = true;
    script.defer = true;
    script.id = this._SCRIPT_ID;
    script.src = this._getScriptSrc(this.callbackName);
    this._assignScriptLoadingPromise(script);
    document.body.appendChild(script);
    return this._scriptLoadingPromise;
  }
  _assignScriptLoadingPromise(scriptElem) {
    this._scriptLoadingPromise = new Promise((resolve, reject) => {
      window[this.callbackName] = () => {
        resolve();
      };
      scriptElem.onerror = (error) => {
        reject(error);
      };
    });
  }
  _getScriptSrc(callbackName) {
    var _a;
    let protocolType = (_a = this.protocol) !== null && _a !== void 0 ? _a : GoogleMapsScriptProtocol.HTTPS;
    let protocol;
    switch (protocolType) {
      case GoogleMapsScriptProtocol.AUTO:
        protocol = '';
        break;
      case GoogleMapsScriptProtocol.HTTP:
        protocol = 'http:';
        break;
      case GoogleMapsScriptProtocol.HTTPS:
        protocol = 'https:';
        break;
    }
    const hostAndPath = this.hostAndPath || 'maps.googleapis.com/maps/api/js';
    const queryParams = {
      v: this.apiVersion || 'quarterly',
      callback: callbackName,
      key: this.apiKey,
      client: this.clientId,
      channel: this.channel,
      libraries: this.libraries,
      region: this.region,
      language: this.language || (this.localeId !== 'en-US' ? this.localeId : null)
    };
    const params = Object.keys(queryParams)
      .filter((k) => queryParams[k] != null)
      .filter((k) => {
      // remove empty arrays
      return (!Array.isArray(queryParams[k]) ||
        (Array.isArray(queryParams[k]) && queryParams[k].length > 0));
    })
      .map((k) => {
      // join arrays as comma seperated strings
      let i = queryParams[k];
      if (Array.isArray(i)) {
        return { key: k, value: i.join(',') };
      }
      return { key: k, value: queryParams[k] };
    })
      .map((entry) => {
      return `${entry.key}=${entry.value}`;
    })
      .join('&');
    return `${protocol}//${hostAndPath}?${params}`;
  }
}

const bpSdkGooglePlacesAutocompleteCss = ".bp-sdk-hidden{position:fixed;top:-100vh}";

let BpSdkGooglePlacesAutocomplete = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.valueUpdate = index.createEvent(this, "valueUpdate", 7);
    this.placesUpdate = index.createEvent(this, "placesUpdate", 7);
    /**
     * placeholder text
     */
    this.placeholder = '';
    /**
     * Error messages
     */
    this.errors = [];
    /**
     * is touched
     */
    this.touched = false;
    /**
     * is pristine
     */
    this.pristine = true;
    /**
     * Is answer in complete state
     */
    this.isCompleted = false;
    /**
     * When true, the field will be readonly. It will display only the label and value as plain text.
     */
    this.isReadOnly = false;
    /**
     * minimum length of input
     */
    this.min = -1;
    /**
     * maximum length of input
     */
    this.max = -1;
    this.isLoaded = false;
    this.useExternal = false;
    this.handlePlaceChanged = () => this.onPlaceChanged();
    this.onChange = (e) => {
      this.valueUpdate.emit(e.target.value);
    };
  }
  setupAutocomplete() {
    this.autocomplete = new google.maps.places.Autocomplete(this.el.querySelector('.bp-sdk-google-places-autocomplete__input'), {
      componentRestrictions: { country: 'us' },
      fields: ['address_component'],
    });
    this.placeChangedEvent = this.autocomplete.addListener('place_changed', this.handlePlaceChanged);
  }
  resetState() {
    this.value = undefined;
  }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-google-places-autocomplete');
    customElements.whenDefined('bp-sdk-external-google-places-autocomplete').then(() => {
      this.useExternal = true;
    });
    this.onAriaLabelledByChange(this.labelId);
    this.onLabelledByChange(this.labelledBy);
  }
  getAutocompletePacContainer(autocomplete) {
    // https://stackoverflow.com/questions/21024090/google-places-autocomplete-how-to-clean-up-pac-container
    const place = autocomplete.gm_accessors_.place;
    const placeKey = Object.keys(place).find((value) => ((typeof (place[value]) === 'object') && Object.prototype.hasOwnProperty.call(place[value], 'gm_accessors_')));
    const input = place[placeKey].gm_accessors_.input[placeKey];
    const inputKey = Object.keys(input).find((value) => ((input[value].classList && input[value].classList.contains('pac-container'))));
    return input[inputKey];
  }
  disconnectedCallback() {
    if (this.placeChangedEvent) {
      window.google.maps.event.removeListener(this.placeChangedEvent);
    }
    if (this.autocomplete) {
      const pacContainer = this.getAutocompletePacContainer(this.autocomplete);
      if (pacContainer && pacContainer.remove) {
        pacContainer.remove();
      }
      this.autocomplete.unbindAll();
    }
  }
  componentDidLoad() {
    this.isLoaded = true;
  }
  onAriaLabelledByChange(labelId) {
    this.updateLabelledBy(labelId, this.labelledBy);
  }
  onLabelledByChange(labelledBy) {
    this.updateLabelledBy(this.labelId, labelledBy);
  }
  updateLabelledBy(aria, ids) {
    const prefix = ids ? `${ids} ` : '';
    this._labelledBy = `${prefix}${aria !== null && aria !== void 0 ? aria : ''}` || undefined;
  }
  onIsLoadedChange(isLoaded) {
    if (isLoaded) {
      this.onGoogleApiKeyChange(this.googleApiKey);
    }
  }
  async onGoogleApiKeyChange(token) {
    if (token && this.isLoaded) {
      const loader = new LazyMapsAPILoader();
      loader.apiKey = this.googleApiKey;
      loader.libraries = ['places'];
      await loader.load();
      if (!this.isReadOnly) {
        this.setupAutocomplete();
      }
    }
  }
  onPlaceChanged() {
    if (this.useExternal) {
      return;
    }
    const place = this.autocomplete.getPlace();
    if (JSON.stringify(this.value) !== JSON.stringify(place)) {
      this.value = place;
      if (place.name) {
        this.valueUpdate.emit(place.name);
      }
      this.placesUpdate.emit(this.value);
    }
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-google-places-autocomplete", { answeredBySource: this.answeredBySource, answerId: this.answerId, autoComplete: this.autoComplete, code: this.code, errorText: this.errorText, errors: this.errors, fieldType: this.fieldType, filter: this.filter, googleApiKey: this.googleApiKey, helpText: this.helpText, isCompleted: this.isCompleted, isReadOnly: this.isReadOnly, labelId: this.labelId, label: this.label, labelledBy: this.labelledBy, max: this.max, min: this.min, pristine: this.pristine, placeholder: this.placeholder, questionId: this.questionId, required: this.required, touched: this.touched }));
  }
  renderLabel() {
    return (index.h("label", { id: this.labelId, htmlFor: `bp-sdk-google-places-autocomplete__${this.labelId}__input`, class: "bp-sdk-label bp-sdk-google-places-autocomplete__label", innerHTML: this.label }));
  }
  renderHiddenInput() {
    var _a, _b;
    return (index.h("input", { "aria-hidden": true, autocomplete: this.autoComplete, tabindex: "-1", class: "bp-sdk-hidden", maxLength: (_a = this.max) !== null && _a !== void 0 ? _a : -1, minLength: (_b = this.min) !== null && _b !== void 0 ? _b : -1, name: this.code, onChange: this.onChange, onInput: this.onChange, onPaste: this.onChange, placeholder: this.placeholder || '', type: "text", value: this.filter }));
  }
  renderVisibleInput() {
    var _a, _b;
    return (index.h("input", { "aria-describedby": index_esm_min.ax(index_esm_min.dx(this.errors)) || undefined, "aria-label": this.placeholder && !this.label ? this.placeholder : null, "aria-labelledby": this._labelledBy, class: "bp-sdk-google-places-autocomplete__input", id: `bp-sdk-google-places-autocomplete__${this.labelId}__input`, maxLength: (_a = this.max) !== null && _a !== void 0 ? _a : -1, minLength: (_b = this.min) !== null && _b !== void 0 ? _b : -1, name: this.code, onChange: this.onChange, onInput: this.onChange, onPaste: this.onChange, placeholder: this.placeholder || '', required: this.required, type: "text", value: this.filter }));
  }
  renderInput() {
    return [this.renderHiddenInput(), this.renderVisibleInput()];
  }
  renderInternal() {
    var _a;
    const input = this.isReadOnly ? this.renderReadOnlyElement(this.filter) : this.renderInput();
    return (index.h("div", { class: "bp-sdk-google-places-autocomplete__container" }, this.renderLabel(), input, this.touched && !this.pristine && ((this.errorText && !this.isCompleted) || !!((_a = this.errors) === null || _a === void 0 ? void 0 : _a.length)) && (index.h("bp-sdk-errors-container", { answerId: this.answerId, questionId: this.questionId, fieldType: this.fieldType, min: this.min, max: this.max, errors: this.errors, errorText: this.errorText }))));
  }
  renderReadOnlyElement(value) {
    return index.h("span", { class: "read-only-value" }, value);
  }
  get el() { return index.getElement(this); }
  static get watchers() { return {
    "labelId": ["onAriaLabelledByChange"],
    "labelledBy": ["onLabelledByChange"],
    "isLoaded": ["onIsLoadedChange"],
    "googleApiKey": ["onGoogleApiKeyChange"]
  }; }
};
BpSdkGooglePlacesAutocomplete.style = bpSdkGooglePlacesAutocompleteCss;

const bpSdkGooglePlacesAutocompleteContainerCss = "";

let BpSdkGooglePlacesAutocompleteContainer = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    /**
     * placeholder
     */
    this.placeholder = '';
    /**
     * Error messages
     */
    this.errors = [];
    /**
     * is touched
     */
    this.touched = false;
    /**
     * is pristine
     */
    this.pristine = true;
    /**
     * Is answer in complete state
     */
    this.isCompleted = false;
    /**
     * When true, the field will be readonly. It will display only the label and value as plain text.
     */
    this.isReadOnly = false;
    /**
     * minimum length of input
     */
    this.min = -1;
    /**
     * maximum length of input
     */
    this.max = -1;
    this.useExternal = false;
    this.handleSubscriptions = () => {
      if (store.canGetStore()) {
        this.storeUnsubscribe && this.storeUnsubscribe();
        store.store.mapDispatchToProps(this, { removeActiveAnswerId: sdkRedux.removeActiveAnswerId });
        this.storeUnsubscribe = store.store.mapStateToProps(this, this.mapStateToProps);
      }
    };
    this.mapStateToProps = (state) => {
      return {
        googleApiToken: state.config.googleApiToken,
        isAutocompleteEnabled: sdkRedux.isAutocompleteEnabled(state),
      };
    };
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
    this.handleSubscriptions();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-google-places-autocomplete-container');
    customElements.whenDefined('bp-sdk-external-google-places-autocomplete-container').then(() => {
      this.useExternal = true;
    });
    this.handleSubscriptions();
    this.updateAutocomplete({
      referenceType: this.referenceType,
      code: this.code,
      fieldType: this.fieldType,
      isAutocompleteEnabled: this.isAutocompleteEnabled,
    });
  }
  onPlacesUpdate() {
    if (!this.useExternal) {
      this.removeActiveAnswerId();
    }
  }
  onReferenceTypeChange(referenceType) {
    this.updateAutocomplete({
      referenceType,
      code: this.code,
      fieldType: this.fieldType,
      isAutocompleteEnabled: this.isAutocompleteEnabled,
    });
  }
  onCodeChange(code) {
    this.updateAutocomplete({
      referenceType: this.referenceType,
      code,
      fieldType: this.fieldType,
      isAutocompleteEnabled: this.isAutocompleteEnabled,
    });
  }
  onFieldTypeChange(fieldType) {
    this.updateAutocomplete({
      referenceType: this.referenceType,
      code: this.code,
      fieldType,
      isAutocompleteEnabled: this.isAutocompleteEnabled,
    });
  }
  onIsAutocompleteEnabledChange(isAutocompleteEnabled) {
    this.updateAutocomplete({
      referenceType: this.referenceType,
      code: this.code,
      fieldType: this.fieldType,
      isAutocompleteEnabled,
    });
  }
  updateAutocomplete({ code, fieldType, referenceType, isAutocompleteEnabled, }) {
    this.autoComplete = isAutocompleteEnabled ? index_esm_min.o4({ referenceType, code, fieldType }) : undefined;
  }
  disconnectedCallback() {
    this.storeUnsubscribe && this.storeUnsubscribe();
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-google-places-autocomplete-container", { answeredBySource: this.answeredBySource, answerId: this.answerId, code: this.code, errors: this.errors, errorText: this.errorText, fieldType: this.fieldType, helpText: this.helpText, isCompleted: this.isCompleted, isReadOnly: this.isReadOnly, filter: this.filter, googleApiToken: this.googleApiToken, labelId: this.labelId, label: this.label, labelledBy: this.labelledBy, max: this.max, min: this.min, placeholder: this.placeholder, pristine: this.pristine, questionId: this.questionId, referenceType: this.referenceType, required: this.required, touched: this.touched }));
  }
  renderInternal() {
    return (index.h("bp-sdk-google-places-autocomplete", { answeredBySource: this.answeredBySource, answerId: this.answerId, autoComplete: this.autoComplete, code: this.code, errors: this.errors, errorText: this.errorText, fieldType: this.fieldType, filter: this.filter, googleApiKey: this.googleApiToken, helpText: this.helpText, isCompleted: this.isCompleted, isReadOnly: this.isReadOnly, label: this.label, labelId: this.labelId, labelledBy: this.labelledBy, max: this.max, min: this.min, placeholder: this.placeholder, questionId: this.questionId, required: this.required, pristine: this.pristine, touched: this.touched }));
  }
  get el() { return index.getElement(this); }
  static get watchers() { return {
    "referenceType": ["onReferenceTypeChange"],
    "code": ["onCodeChange"],
    "fieldType": ["onFieldTypeChange"],
    "isAutocompleteEnabled": ["onIsAutocompleteEnabledChange"]
  }; }
};
BpSdkGooglePlacesAutocompleteContainer.style = bpSdkGooglePlacesAutocompleteContainerCss;

const bpSdkIconContainerCss = "";

let BpSdkIconContainer = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    /**
     * Additional css classes
     */
    this.cssClasses = '';
    this.useExternal = false;
    this.iconDefined = false;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-icon-container');
    customElements.whenDefined('bp-sdk-external-icon-container').then(() => {
      this.useExternal = true;
    });
    this.iconDefined = !!customElements.get('bp-sdk-icon');
    customElements.whenDefined('bp-sdk-external-icon').then(() => {
      this.iconDefined = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return index.h("bp-sdk-external-icon-container", { name: this.name, cssClasses: this.cssClasses });
  }
  renderInternal() {
    return (index.h("div", { class: "bp-sdk-icon__container" }, this.iconDefined && index.h("bp-sdk-icon", { name: this.name, cssClasses: this.cssClasses }), !this.iconDefined && index.h("span", { class: "bp-sdk-icon__container--fallback" }, this.name)));
  }
};
BpSdkIconContainer.style = bpSdkIconContainerCss;

const bpSdkIncrementInputCss = "";

let BpSdkIncrementInput = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    /**
     * Field type
     */
    this.fieldType = 'text';
    /**
     * Placeholder to display
     */
    this.placeholder = '';
    /**
     * Is question required
     */
    this.required = false;
    /**
     * minimum length of input
     */
    this.min = -1;
    /**
     * maximum length of input
     */
    this.max = -1;
    /**
     * Error messages
     */
    this.errors = [];
    /**
     * is touched
     */
    this.touched = false;
    /**
     * is pristine
     */
    this.pristine = true;
    /**
     * Is answer in complete state
     */
    this.isCompleted = false;
    /**
     * When true, the field will be readonly. It will display only the label and value as plain text.
     */
    this.isReadOnly = false;
    /**
     * Is enabled
     */
    this.isEnabled = true;
    this.useExternal = false;
  }
  resetState() { }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-increment-input');
    customElements.whenDefined('bp-sdk-external-increment-input').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-increment-input", { answerId: this.answerId, code: this.code, errorText: this.errorText, errors: this.errors, fieldType: this.fieldType, helpText: this.helpText, answeredBySource: this.answeredBySource, isCompleted: this.isCompleted, isEnabled: this.isEnabled, isReadOnly: this.isReadOnly, labelId: this.labelId, label: this.label, labelledBy: this.labelledBy, max: this.max, min: this.min, pattern: this.pattern, placeholder: this.placeholder, pristine: this.pristine, questionId: this.questionId, referenceType: this.referenceType, required: this.required, text: this.text, touched: this.touched }));
  }
  renderInternal() {
    return (index.h("bp-sdk-text-input-container", { answerId: this.answerId, code: this.code, errorText: this.errorText, errors: this.errors, fieldType: this.fieldType, helpText: this.helpText, answeredBySource: this.answeredBySource, isCompleted: this.isCompleted, isEnabled: this.isEnabled, isReadOnly: this.isReadOnly, labelId: this.labelId, label: this.label, labelledBy: this.labelledBy, max: this.max, min: this.min, pattern: this.pattern, placeholder: this.placeholder, pristine: this.pristine, questionId: this.questionId, referenceType: this.referenceType, required: this.required, text: this.text, touched: this.touched }));
  }
};
BpSdkIncrementInput.style = bpSdkIncrementInputCss;

const bpSdkLabelCss = "";

let BpSdkLabel = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.useExternal = false;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-label');
    customElements.whenDefined('bp-sdk-external-label').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return index.h("bp-sdk-external-label", { label: this.label, helpText: this.helpText });
  }
  renderInternal() {
    return [
      index.h("bp-sdk-label-before", { label: this.label, helpText: this.helpText }),
      index.h("div", { class: "bp-sdk-label__container" }, index.h("div", { class: "bp-sdk-label__content", innerHTML: this.label })),
      index.h("bp-sdk-label-after", { label: this.label, helpText: this.helpText }),
    ];
  }
};
BpSdkLabel.style = bpSdkLabelCss;

var inputmask = _commonjsHelpers.createCommonjsModule(function (module, exports) {
/*!
 * dist/inputmask
 * https://github.com/RobinHerbots/Inputmask
 * Copyright (c) 2010 - 2021 Robin Herbots
 * Licensed under the MIT license
 * Version: 5.0.6
 */
!function(e, t) {
    module.exports = t();
}(_commonjsHelpers.commonjsGlobal, (function() {
    return function() {
        var e = {
            4528: function(e) {
                e.exports = JSON.parse('{"BACKSPACE":8,"BACKSPACE_SAFARI":127,"DELETE":46,"DOWN":40,"END":35,"ENTER":13,"ESCAPE":27,"HOME":36,"INSERT":45,"LEFT":37,"PAGE_DOWN":34,"PAGE_UP":33,"RIGHT":39,"SPACE":32,"TAB":9,"UP":38,"X":88,"Z":90,"CONTROL":17,"PAUSE/BREAK":19,"WINDOWS_LEFT":91,"WINDOWS_RIGHT":92,"KEY_229":229}');
            },
            8741: function(e, t) {
                Object.defineProperty(t, "__esModule", {
                    value: !0
                }), t.default = void 0;
                var a = !("undefined" == typeof window || !window.document || !window.document.createElement);
                t.default = a;
            },
            3976: function(e, t, a) {
                Object.defineProperty(t, "__esModule", {
                    value: !0
                }), t.default = void 0;
                var i, n = (i = a(4528)) && i.__esModule ? i : {
                    default: i
                };
                var r = {
                    _maxTestPos: 500,
                    placeholder: "_",
                    optionalmarker: [ "[", "]" ],
                    quantifiermarker: [ "{", "}" ],
                    groupmarker: [ "(", ")" ],
                    alternatormarker: "|",
                    escapeChar: "\\",
                    mask: null,
                    regex: null,
                    oncomplete: function() {},
                    onincomplete: function() {},
                    oncleared: function() {},
                    repeat: 0,
                    greedy: !1,
                    autoUnmask: !1,
                    removeMaskOnSubmit: !1,
                    clearMaskOnLostFocus: !0,
                    insertMode: !0,
                    insertModeVisual: !0,
                    clearIncomplete: !1,
                    alias: null,
                    onKeyDown: function() {},
                    onBeforeMask: null,
                    onBeforePaste: function(e, t) {
                        return "function" == typeof t.onBeforeMask ? t.onBeforeMask.call(this, e, t) : e;
                    },
                    onBeforeWrite: null,
                    onUnMask: null,
                    showMaskOnFocus: !0,
                    showMaskOnHover: !0,
                    onKeyValidation: function() {},
                    skipOptionalPartCharacter: " ",
                    numericInput: !1,
                    rightAlign: !1,
                    undoOnEscape: !0,
                    radixPoint: "",
                    _radixDance: !1,
                    groupSeparator: "",
                    keepStatic: null,
                    positionCaretOnTab: !0,
                    tabThrough: !1,
                    supportsInputType: [ "text", "tel", "url", "password", "search" ],
                    ignorables: [ n.default.BACKSPACE, n.default.TAB, n.default["PAUSE/BREAK"], n.default.ESCAPE, n.default.PAGE_UP, n.default.PAGE_DOWN, n.default.END, n.default.HOME, n.default.LEFT, n.default.UP, n.default.RIGHT, n.default.DOWN, n.default.INSERT, n.default.DELETE, 93, 112, 113, 114, 115, 116, 117, 118, 119, 120, 121, 122, 123, 0, 229 ],
                    isComplete: null,
                    preValidation: null,
                    postValidation: null,
                    staticDefinitionSymbol: void 0,
                    jitMasking: !1,
                    nullable: !0,
                    inputEventOnly: !1,
                    noValuePatching: !1,
                    positionCaretOnClick: "lvp",
                    casing: null,
                    inputmode: "text",
                    importDataAttributes: !0,
                    shiftPositions: !0,
                    usePrototypeDefinitions: !0,
                    validationEventTimeOut: 3e3
                };
                t.default = r;
            },
            7392: function(e, t) {
                Object.defineProperty(t, "__esModule", {
                    value: !0
                }), t.default = void 0;
                t.default = {
                    9: {
                        validator: "[0-9\uff10-\uff19]",
                        definitionSymbol: "*"
                    },
                    a: {
                        validator: "[A-Za-z\u0410-\u044f\u0401\u0451\xc0-\xff\xb5]",
                        definitionSymbol: "*"
                    },
                    "*": {
                        validator: "[0-9\uff10-\uff19A-Za-z\u0410-\u044f\u0401\u0451\xc0-\xff\xb5]"
                    }
                };
            },
            253: function(e, t) {
                Object.defineProperty(t, "__esModule", {
                    value: !0
                }), t.default = function(e, t, a) {
                    if (void 0 === a) return e.__data ? e.__data[t] : null;
                    e.__data = e.__data || {}, e.__data[t] = a;
                };
            },
            3776: function(e, t, a) {
                Object.defineProperty(t, "__esModule", {
                    value: !0
                }), t.on = function(e, t) {
                    function a(e, a) {
                        n.addEventListener ? n.addEventListener(e, t, !1) : n.attachEvent && n.attachEvent("on" + e, t), 
                        i[e] = i[e] || {}, i[e][a] = i[e][a] || [], i[e][a].push(t);
                    }
                    if (u(this[0])) for (var i = this[0].eventRegistry, n = this[0], r = e.split(" "), o = 0; o < r.length; o++) {
                        var s = r[o].split("."), l = s[0], c = s[1] || "global";
                        a(l, c);
                    }
                    return this;
                }, t.off = function(e, t) {
                    var a, i;
                    function n(e, t, n) {
                        if (e in a == !0) if (i.removeEventListener ? i.removeEventListener(e, n, !1) : i.detachEvent && i.detachEvent("on" + e, n), 
                        "global" === t) for (var r in a[e]) a[e][r].splice(a[e][r].indexOf(n), 1); else a[e][t].splice(a[e][t].indexOf(n), 1);
                    }
                    function r(e, i) {
                        var n, r, o = [];
                        if (e.length > 0) if (void 0 === t) for (n = 0, r = a[e][i].length; n < r; n++) o.push({
                            ev: e,
                            namespace: i && i.length > 0 ? i : "global",
                            handler: a[e][i][n]
                        }); else o.push({
                            ev: e,
                            namespace: i && i.length > 0 ? i : "global",
                            handler: t
                        }); else if (i.length > 0) for (var s in a) for (var l in a[s]) if (l === i) if (void 0 === t) for (n = 0, 
                        r = a[s][l].length; n < r; n++) o.push({
                            ev: s,
                            namespace: l,
                            handler: a[s][l][n]
                        }); else o.push({
                            ev: s,
                            namespace: l,
                            handler: t
                        });
                        return o;
                    }
                    if (u(this[0]) && e) {
                        a = this[0].eventRegistry, i = this[0];
                        for (var o = e.split(" "), s = 0; s < o.length; s++) for (var l = o[s].split("."), c = r(l[0], l[1]), f = 0, d = c.length; f < d; f++) n(c[f].ev, c[f].namespace, c[f].handler);
                    }
                    return this;
                }, t.trigger = function(e) {
                    if (u(this[0])) for (var t = this[0].eventRegistry, a = this[0], i = "string" == typeof e ? e.split(" ") : [ e.type ], r = 0; r < i.length; r++) {
                        var s = i[r].split("."), l = s[0], c = s[1] || "global";
                        if (void 0 !== document && "global" === c) {
                            var f, d, p = {
                                bubbles: !0,
                                cancelable: !0,
                                detail: arguments[1]
                            };
                            if (document.createEvent) {
                                try {
                                    switch (l) {
                                      case "input":
                                        p.inputType = "insertText", f = new InputEvent(l, p);
                                        break;

                                      default:
                                        f = new CustomEvent(l, p);
                                    }
                                } catch (e) {
                                    (f = document.createEvent("CustomEvent")).initCustomEvent(l, p.bubbles, p.cancelable, p.detail);
                                }
                                e.type && (0, n.default)(f, e), a.dispatchEvent(f);
                            } else (f = document.createEventObject()).eventType = l, f.detail = arguments[1], 
                            e.type && (0, n.default)(f, e), a.fireEvent("on" + f.eventType, f);
                        } else if (void 0 !== t[l]) if (arguments[0] = arguments[0].type ? arguments[0] : o.default.Event(arguments[0]), 
                        arguments[0].detail = arguments.slice(1), "global" === c) for (var h in t[l]) for (d = 0; d < t[l][h].length; d++) t[l][h][d].apply(a, arguments); else for (d = 0; d < t[l][c].length; d++) t[l][c][d].apply(a, arguments);
                    }
                    return this;
                }, t.Event = void 0;
                var i, n = l(a(600)), r = l(a(9380)), o = l(a(4963)), s = l(a(8741));
                function l(e) {
                    return e && e.__esModule ? e : {
                        default: e
                    };
                }
                function u(e) {
                    return e instanceof Element;
                }
                t.Event = i, "function" == typeof r.default.CustomEvent ? t.Event = i = r.default.CustomEvent : s.default && (t.Event = i = function(e, t) {
                    t = t || {
                        bubbles: !1,
                        cancelable: !1,
                        detail: void 0
                    };
                    var a = document.createEvent("CustomEvent");
                    return a.initCustomEvent(e, t.bubbles, t.cancelable, t.detail), a;
                }, i.prototype = r.default.Event.prototype);
            },
            600: function(e, t) {
                function a(e) {
                    return (a = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function(e) {
                        return typeof e;
                    } : function(e) {
                        return e && "function" == typeof Symbol && e.constructor === Symbol && e !== Symbol.prototype ? "symbol" : typeof e;
                    })(e);
                }
                Object.defineProperty(t, "__esModule", {
                    value: !0
                }), t.default = function e() {
                    var t, i, n, r, o, s, l = arguments[0] || {}, u = 1, c = arguments.length, f = !1;
                    "boolean" == typeof l && (f = l, l = arguments[u] || {}, u++);
                    "object" !== a(l) && "function" != typeof l && (l = {});
                    for (;u < c; u++) if (null != (t = arguments[u])) for (i in t) n = l[i], r = t[i], 
                    l !== r && (f && r && ("[object Object]" === Object.prototype.toString.call(r) || (o = Array.isArray(r))) ? (o ? (o = !1, 
                    s = n && Array.isArray(n) ? n : []) : s = n && "[object Object]" === Object.prototype.toString.call(n) ? n : {}, 
                    l[i] = e(f, s, r)) : void 0 !== r && (l[i] = r));
                    return l;
                };
            },
            4963: function(e, t, a) {
                Object.defineProperty(t, "__esModule", {
                    value: !0
                }), t.default = void 0;
                var i = s(a(600)), n = s(a(9380)), r = s(a(253)), o = a(3776);
                function s(e) {
                    return e && e.__esModule ? e : {
                        default: e
                    };
                }
                var l = n.default.document;
                function u(e) {
                    return e instanceof u ? e : this instanceof u ? void (null != e && e !== n.default && (this[0] = e.nodeName ? e : void 0 !== e[0] && e[0].nodeName ? e[0] : l.querySelector(e), 
                    void 0 !== this[0] && null !== this[0] && (this[0].eventRegistry = this[0].eventRegistry || {}))) : new u(e);
                }
                u.prototype = {
                    on: o.on,
                    off: o.off,
                    trigger: o.trigger
                }, u.extend = i.default, u.data = r.default, u.Event = o.Event;
                var c = u;
                t.default = c;
            },
            9845: function(e, t, a) {
                Object.defineProperty(t, "__esModule", {
                    value: !0
                }), t.iphone = t.iemobile = t.mobile = t.ie = t.ua = void 0;
                var i, n = (i = a(9380)) && i.__esModule ? i : {
                    default: i
                };
                var r = n.default.navigator && n.default.navigator.userAgent || "", o = r.indexOf("MSIE ") > 0 || r.indexOf("Trident/") > 0, s = "ontouchstart" in n.default, l = /iemobile/i.test(r), u = /iphone/i.test(r) && !l;
                t.iphone = u, t.iemobile = l, t.mobile = s, t.ie = o, t.ua = r;
            },
            7184: function(e, t) {
                Object.defineProperty(t, "__esModule", {
                    value: !0
                }), t.default = function(e) {
                    return e.replace(a, "\\$1");
                };
                var a = new RegExp("(\\" + [ "/", ".", "*", "+", "?", "|", "(", ")", "[", "]", "{", "}", "\\", "$", "^" ].join("|\\") + ")", "gim");
            },
            6030: function(e, t, a) {
                Object.defineProperty(t, "__esModule", {
                    value: !0
                }), t.EventHandlers = void 0;
                var i, n = a(8711), r = (i = a(4528)) && i.__esModule ? i : {
                    default: i
                }, o = a(9845), s = a(7215), l = a(7760), u = a(4713);
                var c = {
                    keydownEvent: function(e) {
                        var t = this.inputmask, a = t.opts, i = t.dependencyLib, c = t.maskset, f = this, d = i(f), p = e.keyCode, h = n.caret.call(t, f), v = a.onKeyDown.call(this, e, n.getBuffer.call(t), h, a);
                        if (void 0 !== v) return v;
                        if (p === r.default.BACKSPACE || p === r.default.DELETE || o.iphone && p === r.default.BACKSPACE_SAFARI || e.ctrlKey && p === r.default.X && !("oncut" in f)) e.preventDefault(), 
                        s.handleRemove.call(t, f, p, h), (0, l.writeBuffer)(f, n.getBuffer.call(t, !0), c.p, e, f.inputmask._valueGet() !== n.getBuffer.call(t).join("")); else if (p === r.default.END || p === r.default.PAGE_DOWN) {
                            e.preventDefault();
                            var m = n.seekNext.call(t, n.getLastValidPosition.call(t));
                            n.caret.call(t, f, e.shiftKey ? h.begin : m, m, !0);
                        } else p === r.default.HOME && !e.shiftKey || p === r.default.PAGE_UP ? (e.preventDefault(), 
                        n.caret.call(t, f, 0, e.shiftKey ? h.begin : 0, !0)) : a.undoOnEscape && p === r.default.ESCAPE && !0 !== e.altKey ? ((0, l.checkVal)(f, !0, !1, t.undoValue.split("")), d.trigger("click")) : !0 === a.tabThrough && p === r.default.TAB ? !0 === e.shiftKey ? (h.end = n.seekPrevious.call(t, h.end, !0), 
                        !0 === u.getTest.call(t, h.end - 1).match.static && h.end--, h.begin = n.seekPrevious.call(t, h.end, !0), 
                        h.begin >= 0 && h.end > 0 && (e.preventDefault(), n.caret.call(t, f, h.begin, h.end))) : (h.begin = n.seekNext.call(t, h.begin, !0), 
                        h.end = n.seekNext.call(t, h.begin, !0), h.end < c.maskLength && h.end--, h.begin <= c.maskLength && (e.preventDefault(), 
                        n.caret.call(t, f, h.begin, h.end))) : e.shiftKey || a.insertModeVisual && !1 === a.insertMode && (p === r.default.RIGHT ? setTimeout((function() {
                            var e = n.caret.call(t, f);
                            n.caret.call(t, f, e.begin);
                        }), 0) : p === r.default.LEFT && setTimeout((function() {
                            var e = n.translatePosition.call(t, f.inputmask.caretPos.begin);
                            n.translatePosition.call(t, f.inputmask.caretPos.end);
                            t.isRTL ? n.caret.call(t, f, e + (e === c.maskLength ? 0 : 1)) : n.caret.call(t, f, e - (0 === e ? 0 : 1));
                        }), 0));
                        t.ignorable = a.ignorables.includes(p);
                    },
                    keypressEvent: function(e, t, a, i, o) {
                        var u = this.inputmask || this, c = u.opts, f = u.dependencyLib, d = u.maskset, p = u.el, h = f(p), v = e.which || e.charCode || e.keyCode;
                        if (!(!0 === t || e.ctrlKey && e.altKey) && (e.ctrlKey || e.metaKey || u.ignorable)) return v === r.default.ENTER && u.undoValue !== u._valueGet(!0) && (u.undoValue = u._valueGet(!0), 
                        setTimeout((function() {
                            h.trigger("change");
                        }), 0)), u.skipInputEvent = !0, !0;
                        if (v) {
                            44 !== v && 46 !== v || 3 !== e.location || "" === c.radixPoint || (v = c.radixPoint.charCodeAt(0));
                            var m, g = t ? {
                                begin: o,
                                end: o
                            } : n.caret.call(u, p), k = String.fromCharCode(v);
                            d.writeOutBuffer = !0;
                            var y = s.isValid.call(u, g, k, i, void 0, void 0, void 0, t);
                            if (!1 !== y && (n.resetMaskSet.call(u, !0), m = void 0 !== y.caret ? y.caret : n.seekNext.call(u, y.pos.begin ? y.pos.begin : y.pos), 
                            d.p = m), m = c.numericInput && void 0 === y.caret ? n.seekPrevious.call(u, m) : m, 
                            !1 !== a && (setTimeout((function() {
                                c.onKeyValidation.call(p, v, y);
                            }), 0), d.writeOutBuffer && !1 !== y)) {
                                var b = n.getBuffer.call(u);
                                (0, l.writeBuffer)(p, b, m, e, !0 !== t);
                            }
                            if (e.preventDefault(), t) return !1 !== y && (y.forwardPosition = m), y;
                        }
                    },
                    keyupEvent: function(e) {
                        var t = this.inputmask;
                        !t.isComposing || e.keyCode !== r.default.KEY_229 && e.keyCode !== r.default.ENTER || t.$el.trigger("input");
                    },
                    pasteEvent: function(e) {
                        var t, a = this.inputmask, i = a.opts, r = a._valueGet(!0), o = n.caret.call(a, this);
                        a.isRTL && (t = o.end, o.end = o.begin, o.begin = t);
                        var s = r.substr(0, o.begin), u = r.substr(o.end, r.length);
                        if (s == (a.isRTL ? n.getBufferTemplate.call(a).slice().reverse() : n.getBufferTemplate.call(a)).slice(0, o.begin).join("") && (s = ""), 
                        u == (a.isRTL ? n.getBufferTemplate.call(a).slice().reverse() : n.getBufferTemplate.call(a)).slice(o.end).join("") && (u = ""), 
                        window.clipboardData && window.clipboardData.getData) r = s + window.clipboardData.getData("Text") + u; else {
                            if (!e.clipboardData || !e.clipboardData.getData) return !0;
                            r = s + e.clipboardData.getData("text/plain") + u;
                        }
                        var c = r;
                        if ("function" == typeof i.onBeforePaste) {
                            if (!1 === (c = i.onBeforePaste.call(a, r, i))) return e.preventDefault();
                            c || (c = r);
                        }
                        return (0, l.checkVal)(this, !0, !1, c.toString().split(""), e), e.preventDefault();
                    },
                    inputFallBackEvent: function(e) {
                        var t = this.inputmask, a = t.opts, i = t.dependencyLib;
                        var s = this, f = s.inputmask._valueGet(!0), d = (t.isRTL ? n.getBuffer.call(t).slice().reverse() : n.getBuffer.call(t)).join(""), p = n.caret.call(t, s, void 0, void 0, !0);
                        if (d !== f) {
                            var h = function(e, i, r) {
                                for (var o, s, l, c = e.substr(0, r.begin).split(""), f = e.substr(r.begin).split(""), d = i.substr(0, r.begin).split(""), p = i.substr(r.begin).split(""), h = c.length >= d.length ? c.length : d.length, v = f.length >= p.length ? f.length : p.length, m = "", g = [], k = "~"; c.length < h; ) c.push(k);
                                for (;d.length < h; ) d.push(k);
                                for (;f.length < v; ) f.unshift(k);
                                for (;p.length < v; ) p.unshift(k);
                                var y = c.concat(f), b = d.concat(p);
                                for (s = 0, o = y.length; s < o; s++) switch (l = u.getPlaceholder.call(t, n.translatePosition.call(t, s)), 
                                m) {
                                  case "insertText":
                                    b[s - 1] === y[s] && r.begin == y.length - 1 && g.push(y[s]), s = o;
                                    break;

                                  case "insertReplacementText":
                                  case "deleteContentBackward":
                                    y[s] === k ? r.end++ : s = o;
                                    break;

                                  default:
                                    y[s] !== b[s] && (y[s + 1] !== k && y[s + 1] !== l && void 0 !== y[s + 1] || (b[s] !== l || b[s + 1] !== k) && b[s] !== k ? b[s + 1] === k && b[s] === y[s + 1] ? (m = "insertText", 
                                    g.push(y[s]), r.begin--, r.end--) : y[s] !== l && y[s] !== k && (y[s + 1] === k || b[s] !== y[s] && b[s + 1] === y[s + 1]) ? (m = "insertReplacementText", 
                                    g.push(y[s]), r.begin--) : y[s] === k ? (m = "deleteContentBackward", (n.isMask.call(t, n.translatePosition.call(t, s), !0) || b[s] === a.radixPoint) && r.end++) : s = o : (m = "insertText", 
                                    g.push(y[s]), r.begin--, r.end--));
                                }
                                return {
                                    action: m,
                                    data: g,
                                    caret: r
                                };
                            }(f = function(e, a, i) {
                                if (o.iemobile) {
                                    var r = a.replace(n.getBuffer.call(t).join(""), "");
                                    if (1 === r.length) {
                                        var s = a.split("");
                                        s.splice(i.begin, 0, r), a = s.join("");
                                    }
                                }
                                return a;
                            }(0, f, p), d, p);
                            switch ((s.inputmask.shadowRoot || s.ownerDocument).activeElement !== s && s.focus(), 
                            (0, l.writeBuffer)(s, n.getBuffer.call(t)), n.caret.call(t, s, p.begin, p.end, !0), 
                            h.action) {
                              case "insertText":
                              case "insertReplacementText":
                                h.data.forEach((function(e, a) {
                                    var n = new i.Event("keypress");
                                    n.which = e.charCodeAt(0), t.ignorable = !1, c.keypressEvent.call(s, n);
                                })), setTimeout((function() {
                                    t.$el.trigger("keyup");
                                }), 0);
                                break;

                              case "deleteContentBackward":
                                var v = new i.Event("keydown");
                                v.keyCode = r.default.BACKSPACE, c.keydownEvent.call(s, v);
                                break;

                              default:
                                (0, l.applyInputValue)(s, f);
                            }
                            e.preventDefault();
                        }
                    },
                    compositionendEvent: function(e) {
                        var t = this.inputmask;
                        t.isComposing = !1, t.$el.trigger("input");
                    },
                    setValueEvent: function(e) {
                        var t = this.inputmask, a = this, i = e && e.detail ? e.detail[0] : arguments[1];
                        void 0 === i && (i = a.inputmask._valueGet(!0)), (0, l.applyInputValue)(a, i), (e.detail && void 0 !== e.detail[1] || void 0 !== arguments[2]) && n.caret.call(t, a, e.detail ? e.detail[1] : arguments[2]);
                    },
                    focusEvent: function(e) {
                        var t = this.inputmask, a = t.opts, i = this, r = i.inputmask._valueGet();
                        a.showMaskOnFocus && r !== n.getBuffer.call(t).join("") && (0, l.writeBuffer)(i, n.getBuffer.call(t), n.seekNext.call(t, n.getLastValidPosition.call(t))), 
                        !0 !== a.positionCaretOnTab || !1 !== t.mouseEnter || s.isComplete.call(t, n.getBuffer.call(t)) && -1 !== n.getLastValidPosition.call(t) || c.clickEvent.apply(i, [ e, !0 ]), 
                        t.undoValue = t._valueGet(!0);
                    },
                    invalidEvent: function(e) {
                        this.inputmask.validationEvent = !0;
                    },
                    mouseleaveEvent: function() {
                        var e = this.inputmask, t = e.opts, a = this;
                        e.mouseEnter = !1, t.clearMaskOnLostFocus && (a.inputmask.shadowRoot || a.ownerDocument).activeElement !== a && (0, l.HandleNativePlaceholder)(a, e.originalPlaceholder);
                    },
                    clickEvent: function(e, t) {
                        var a = this.inputmask, i = this;
                        if ((i.inputmask.shadowRoot || i.ownerDocument).activeElement === i) {
                            var r = n.determineNewCaretPosition.call(a, n.caret.call(a, i), t);
                            void 0 !== r && n.caret.call(a, i, r);
                        }
                    },
                    cutEvent: function(e) {
                        var t = this.inputmask, a = t.maskset, i = this, o = n.caret.call(t, i), u = window.clipboardData || e.clipboardData, c = t.isRTL ? n.getBuffer.call(t).slice(o.end, o.begin) : n.getBuffer.call(t).slice(o.begin, o.end);
                        u.setData("text", t.isRTL ? c.reverse().join("") : c.join("")), document.execCommand && document.execCommand("copy"), 
                        s.handleRemove.call(t, i, r.default.DELETE, o), (0, l.writeBuffer)(i, n.getBuffer.call(t), a.p, e, t.undoValue !== t._valueGet(!0));
                    },
                    blurEvent: function(e) {
                        var t = this.inputmask, a = t.opts, i = (0, t.dependencyLib)(this), r = this;
                        if (r.inputmask) {
                            (0, l.HandleNativePlaceholder)(r, t.originalPlaceholder);
                            var o = r.inputmask._valueGet(), u = n.getBuffer.call(t).slice();
                            "" !== o && (a.clearMaskOnLostFocus && (-1 === n.getLastValidPosition.call(t) && o === n.getBufferTemplate.call(t).join("") ? u = [] : l.clearOptionalTail.call(t, u)), 
                            !1 === s.isComplete.call(t, u) && (setTimeout((function() {
                                i.trigger("incomplete");
                            }), 0), a.clearIncomplete && (n.resetMaskSet.call(t), u = a.clearMaskOnLostFocus ? [] : n.getBufferTemplate.call(t).slice())), 
                            (0, l.writeBuffer)(r, u, void 0, e)), t.undoValue !== t._valueGet(!0) && (t.undoValue = t._valueGet(!0), 
                            i.trigger("change"));
                        }
                    },
                    mouseenterEvent: function() {
                        var e = this.inputmask, t = e.opts, a = this;
                        if (e.mouseEnter = !0, (a.inputmask.shadowRoot || a.ownerDocument).activeElement !== a) {
                            var i = (e.isRTL ? n.getBufferTemplate.call(e).slice().reverse() : n.getBufferTemplate.call(e)).join("");
                            e.placeholder !== i && a.placeholder !== e.originalPlaceholder && (e.originalPlaceholder = a.placeholder), 
                            t.showMaskOnHover && (0, l.HandleNativePlaceholder)(a, i);
                        }
                    },
                    submitEvent: function() {
                        var e = this.inputmask, t = e.opts;
                        e.undoValue !== e._valueGet(!0) && e.$el.trigger("change"), t.clearMaskOnLostFocus && -1 === n.getLastValidPosition.call(e) && e._valueGet && e._valueGet() === n.getBufferTemplate.call(e).join("") && e._valueSet(""), 
                        t.clearIncomplete && !1 === s.isComplete.call(e, n.getBuffer.call(e)) && e._valueSet(""), 
                        t.removeMaskOnSubmit && (e._valueSet(e.unmaskedvalue(), !0), setTimeout((function() {
                            (0, l.writeBuffer)(e.el, n.getBuffer.call(e));
                        }), 0));
                    },
                    resetEvent: function() {
                        var e = this.inputmask;
                        e.refreshValue = !0, setTimeout((function() {
                            (0, l.applyInputValue)(e.el, e._valueGet(!0));
                        }), 0);
                    }
                };
                t.EventHandlers = c;
            },
            9716: function(e, t, a) {
                Object.defineProperty(t, "__esModule", {
                    value: !0
                }), t.EventRuler = void 0;
                var i = s(a(2394)), n = s(a(4528)), r = a(8711), o = a(7760);
                function s(e) {
                    return e && e.__esModule ? e : {
                        default: e
                    };
                }
                var l = {
                    on: function(e, t, a) {
                        var s = e.inputmask.dependencyLib, l = function(t) {
                            t.originalEvent && (t = t.originalEvent || t, arguments[0] = t);
                            var l, u = this, c = u.inputmask, f = c ? c.opts : void 0;
                            if (void 0 === c && "FORM" !== this.nodeName) {
                                var d = s.data(u, "_inputmask_opts");
                                s(u).off(), d && new i.default(d).mask(u);
                            } else {
                                if ([ "submit", "reset", "setvalue" ].includes(t.type) || "FORM" === this.nodeName || !(u.disabled || u.readOnly && !("keydown" === t.type && t.ctrlKey && 67 === t.keyCode || !1 === f.tabThrough && t.keyCode === n.default.TAB))) {
                                    switch (t.type) {
                                      case "input":
                                        if (!0 === c.skipInputEvent || t.inputType && "insertCompositionText" === t.inputType) return c.skipInputEvent = !1, 
                                        t.preventDefault();
                                        break;

                                      case "keydown":
                                        c.skipKeyPressEvent = !1, c.skipInputEvent = c.isComposing = t.keyCode === n.default.KEY_229;
                                        break;

                                      case "keyup":
                                      case "compositionend":
                                        c.isComposing && (c.skipInputEvent = !1);
                                        break;

                                      case "keypress":
                                        if (!0 === c.skipKeyPressEvent) return t.preventDefault();
                                        c.skipKeyPressEvent = !0;
                                        break;

                                      case "click":
                                      case "focus":
                                        return c.validationEvent ? (c.validationEvent = !1, e.blur(), (0, o.HandleNativePlaceholder)(e, (c.isRTL ? r.getBufferTemplate.call(c).slice().reverse() : r.getBufferTemplate.call(c)).join("")), 
                                        setTimeout((function() {
                                            e.focus();
                                        }), f.validationEventTimeOut), !1) : (l = arguments, setTimeout((function() {
                                            e.inputmask && a.apply(u, l);
                                        }), 0), !1);
                                    }
                                    var p = a.apply(u, arguments);
                                    return !1 === p && (t.preventDefault(), t.stopPropagation()), p;
                                }
                                t.preventDefault();
                            }
                        };
                        [ "submit", "reset" ].includes(t) ? (l = l.bind(e), null !== e.form && s(e.form).on(t, l)) : s(e).on(t, l), 
                        e.inputmask.events[t] = e.inputmask.events[t] || [], e.inputmask.events[t].push(l);
                    },
                    off: function(e, t) {
                        if (e.inputmask && e.inputmask.events) {
                            var a = e.inputmask.dependencyLib, i = e.inputmask.events;
                            for (var n in t && ((i = [])[t] = e.inputmask.events[t]), i) {
                                for (var r = i[n]; r.length > 0; ) {
                                    var o = r.pop();
                                    [ "submit", "reset" ].includes(n) ? null !== e.form && a(e.form).off(n, o) : a(e).off(n, o);
                                }
                                delete e.inputmask.events[n];
                            }
                        }
                    }
                };
                t.EventRuler = l;
            },
            219: function(e, t, a) {
                var i = l(a(2394)), n = l(a(4528)), r = l(a(7184)), o = a(8711);
                function s(e) {
                    return (s = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function(e) {
                        return typeof e;
                    } : function(e) {
                        return e && "function" == typeof Symbol && e.constructor === Symbol && e !== Symbol.prototype ? "symbol" : typeof e;
                    })(e);
                }
                function l(e) {
                    return e && e.__esModule ? e : {
                        default: e
                    };
                }
                var u = i.default.dependencyLib, c = (new Date).getFullYear(), f = {
                    d: [ "[1-9]|[12][0-9]|3[01]", Date.prototype.setDate, "day", Date.prototype.getDate ],
                    dd: [ "0[1-9]|[12][0-9]|3[01]", Date.prototype.setDate, "day", function() {
                        return y(Date.prototype.getDate.call(this), 2);
                    } ],
                    ddd: [ "" ],
                    dddd: [ "" ],
                    m: [ "[1-9]|1[012]", Date.prototype.setMonth, "month", function() {
                        return Date.prototype.getMonth.call(this) + 1;
                    } ],
                    mm: [ "0[1-9]|1[012]", Date.prototype.setMonth, "month", function() {
                        return y(Date.prototype.getMonth.call(this) + 1, 2);
                    } ],
                    mmm: [ "" ],
                    mmmm: [ "" ],
                    yy: [ "[0-9]{2}", Date.prototype.setFullYear, "year", function() {
                        return y(Date.prototype.getFullYear.call(this), 2);
                    } ],
                    yyyy: [ "[0-9]{4}", Date.prototype.setFullYear, "year", function() {
                        return y(Date.prototype.getFullYear.call(this), 4);
                    } ],
                    h: [ "[1-9]|1[0-2]", Date.prototype.setHours, "hours", Date.prototype.getHours ],
                    hh: [ "0[1-9]|1[0-2]", Date.prototype.setHours, "hours", function() {
                        return y(Date.prototype.getHours.call(this), 2);
                    } ],
                    hx: [ function(e) {
                        return "[0-9]{".concat(e, "}");
                    }, Date.prototype.setHours, "hours", function(e) {
                        return Date.prototype.getHours;
                    } ],
                    H: [ "1?[0-9]|2[0-3]", Date.prototype.setHours, "hours", Date.prototype.getHours ],
                    HH: [ "0[0-9]|1[0-9]|2[0-3]", Date.prototype.setHours, "hours", function() {
                        return y(Date.prototype.getHours.call(this), 2);
                    } ],
                    Hx: [ function(e) {
                        return "[0-9]{".concat(e, "}");
                    }, Date.prototype.setHours, "hours", function(e) {
                        return function() {
                            return y(Date.prototype.getHours.call(this), e);
                        };
                    } ],
                    M: [ "[1-5]?[0-9]", Date.prototype.setMinutes, "minutes", Date.prototype.getMinutes ],
                    MM: [ "0[0-9]|1[0-9]|2[0-9]|3[0-9]|4[0-9]|5[0-9]", Date.prototype.setMinutes, "minutes", function() {
                        return y(Date.prototype.getMinutes.call(this), 2);
                    } ],
                    s: [ "[1-5]?[0-9]", Date.prototype.setSeconds, "seconds", Date.prototype.getSeconds ],
                    ss: [ "0[0-9]|1[0-9]|2[0-9]|3[0-9]|4[0-9]|5[0-9]", Date.prototype.setSeconds, "seconds", function() {
                        return y(Date.prototype.getSeconds.call(this), 2);
                    } ],
                    l: [ "[0-9]{3}", Date.prototype.setMilliseconds, "milliseconds", function() {
                        return y(Date.prototype.getMilliseconds.call(this), 3);
                    } ],
                    L: [ "[0-9]{2}", Date.prototype.setMilliseconds, "milliseconds", function() {
                        return y(Date.prototype.getMilliseconds.call(this), 2);
                    } ],
                    t: [ "[ap]", p, "ampm", h, 1 ],
                    tt: [ "[ap]m", p, "ampm", h, 2 ],
                    T: [ "[AP]", p, "ampm", h, 1 ],
                    TT: [ "[AP]M", p, "ampm", h, 2 ],
                    Z: [ "" ],
                    o: [ "" ],
                    S: [ "" ]
                }, d = {
                    isoDate: "yyyy-mm-dd",
                    isoTime: "HH:MM:ss",
                    isoDateTime: "yyyy-mm-dd'T'HH:MM:ss",
                    isoUtcDateTime: "UTC:yyyy-mm-dd'T'HH:MM:ss'Z'"
                };
                function p(e) {
                    e.toLowerCase().includes("p") && this.setHours(this.getHours() + 12);
                }
                function h() {}
                function v(e) {
                    var t = new RegExp("\\d+$").exec(e[0]);
                    if (t && void 0 !== t[0]) {
                        var a = f[e[0][0] + "x"].slice("");
                        return a[0] = a[0](t[0]), a[3] = a[3](t[0]), a;
                    }
                    if (f[e[0]]) return f[e[0]];
                }
                function m(e) {
                    if (!e.tokenizer) {
                        var t = [], a = [];
                        for (var i in f) if (/\.*x$/.test(i)) {
                            var n = i[0] + "\\d+";
                            -1 === a.indexOf(n) && a.push(n);
                        } else -1 === t.indexOf(i[0]) && t.push(i[0]);
                        e.tokenizer = "(" + (a.length > 0 ? a.join("|") + "|" : "") + t.join("+|") + ")+?|.", 
                        e.tokenizer = new RegExp(e.tokenizer, "g");
                    }
                    return e.tokenizer;
                }
                function g(e, t, a) {
                    if (void 0 === e.rawday || !isFinite(e.rawday) && new Date(e.date.getFullYear(), isFinite(e.rawmonth) ? e.month : e.date.getMonth() + 1, 0).getDate() >= e.day || "29" == e.day && !Number.isFinite(e.rawyear) || new Date(e.date.getFullYear(), isFinite(e.rawmonth) ? e.month : e.date.getMonth() + 1, 0).getDate() >= e.day) return t;
                    if ("29" == e.day) {
                        var i = P(t.pos, a);
                        if ("yyyy" === i.targetMatch[0] && t.pos - i.targetMatchIndex == 2) return t.remove = t.pos + 1, 
                        t;
                    } else if ("02" == e.month && "30" == e.day && void 0 !== t.c) return e.day = "03", 
                    e.date.setDate(3), e.date.setMonth(1), t.insert = [ {
                        pos: t.pos,
                        c: "0"
                    }, {
                        pos: t.pos + 1,
                        c: t.c
                    } ], t.caret = o.seekNext.call(this, t.pos + 1), t;
                    return !1;
                }
                function k(e, t, a, i) {
                    var n, o, s = "";
                    for (m(a).lastIndex = 0; n = m(a).exec(e); ) {
                        if (void 0 === t) if (o = v(n)) s += "(" + o[0] + ")"; else switch (n[0]) {
                          case "[":
                            s += "(";
                            break;

                          case "]":
                            s += ")?";
                            break;

                          default:
                            s += (0, r.default)(n[0]);
                        } else if (o = v(n)) if (!0 !== i && o[3]) s += o[3].call(t.date); else o[2] ? s += t["raw" + o[2]] : s += n[0]; else s += n[0];
                    }
                    return s;
                }
                function y(e, t, a) {
                    for (e = String(e), t = t || 2; e.length < t; ) e = a ? e + "0" : "0" + e;
                    return e;
                }
                function b(e, t, a) {
                    var i, n, r, o = {
                        date: new Date(1, 0, 1)
                    }, l = e;
                    function u(e, t, a) {
                        if (e[i] = "ampm" === i ? t : t.replace(/[^0-9]/g, "0"), e["raw" + i] = t, void 0 !== r) {
                            var n = e[i];
                            ("day" === i && 29 === parseInt(n) || "month" === i && 2 === parseInt(n)) && (29 !== parseInt(e.day) || 2 !== parseInt(e.month) || "" !== e.year && void 0 !== e.year || e.date.setFullYear(2012, 1, 29)), 
                            "day" === i && 0 === parseInt(n) && (n = 1), "month" === i && (n = parseInt(n)) > 0 && (n -= 1), 
                            "year" === i && n.length < 4 && (n = y(n, 4, !0)), "" === n || isNaN(n) || r.call(e.date, n), 
                            "ampm" === i && r.call(e.date, n);
                        }
                    }
                    if ("string" == typeof l) {
                        for (m(a).lastIndex = 0; n = m(a).exec(t); ) {
                            var c = new RegExp("\\d+$").exec(n[0]), d = c ? n[0][0] + "x" : n[0], p = void 0;
                            if (c) {
                                var h = m(a).lastIndex, v = P(n.index, a);
                                m(a).lastIndex = h, p = l.slice(0, l.indexOf(v.nextMatch[0]));
                            } else p = l.slice(0, d.length);
                            Object.prototype.hasOwnProperty.call(f, d) && (i = f[d][2], r = f[d][1], u(o, p)), 
                            l = l.slice(p.length);
                        }
                        return o;
                    }
                    if (l && "object" === s(l) && Object.prototype.hasOwnProperty.call(l, "date")) return l;
                }
                function x(e, t) {
                    return k(t.inputFormat, {
                        date: e
                    }, t);
                }
                function P(e, t) {
                    var a, i, n = 0, r = 0;
                    for (m(t).lastIndex = 0; i = m(t).exec(t.inputFormat); ) {
                        var o = new RegExp("\\d+$").exec(i[0]);
                        if ((n += r = o ? parseInt(o[0]) : i[0].length) >= e) {
                            a = i, i = m(t).exec(t.inputFormat);
                            break;
                        }
                    }
                    return {
                        targetMatchIndex: n - r,
                        nextMatch: i,
                        targetMatch: a
                    };
                }
                i.default.extendAliases({
                    datetime: {
                        mask: function(e) {
                            return e.numericInput = !1, f.S = e.i18n.ordinalSuffix.join("|"), e.inputFormat = d[e.inputFormat] || e.inputFormat, 
                            e.displayFormat = d[e.displayFormat] || e.displayFormat || e.inputFormat, e.outputFormat = d[e.outputFormat] || e.outputFormat || e.inputFormat, 
                            e.placeholder = "" !== e.placeholder ? e.placeholder : e.inputFormat.replace(/[[\]]/, ""), 
                            e.regex = k(e.inputFormat, void 0, e), e.min = b(e.min, e.inputFormat, e), e.max = b(e.max, e.inputFormat, e), 
                            null;
                        },
                        placeholder: "",
                        inputFormat: "isoDateTime",
                        displayFormat: void 0,
                        outputFormat: void 0,
                        min: null,
                        max: null,
                        skipOptionalPartCharacter: "",
                        i18n: {
                            dayNames: [ "Mon", "Tue", "Wed", "Thu", "Fri", "Sat", "Sun", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday", "Sunday" ],
                            monthNames: [ "Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec", "January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December" ],
                            ordinalSuffix: [ "st", "nd", "rd", "th" ]
                        },
                        preValidation: function(e, t, a, i, n, r, o, s) {
                            if (s) return !0;
                            if (isNaN(a) && e[t] !== a) {
                                var l = P(t, n);
                                if (l.nextMatch && l.nextMatch[0] === a && l.targetMatch[0].length > 1) {
                                    var u = f[l.targetMatch[0]][0];
                                    if (new RegExp(u).test("0" + e[t - 1])) return e[t] = e[t - 1], e[t - 1] = "0", 
                                    {
                                        fuzzy: !0,
                                        buffer: e,
                                        refreshFromBuffer: {
                                            start: t - 1,
                                            end: t + 1
                                        },
                                        pos: t + 1
                                    };
                                }
                            }
                            return !0;
                        },
                        postValidation: function(e, t, a, i, n, r, o, s) {
                            var l, u;
                            if (o) return !0;
                            if (!1 === i && (((l = P(t + 1, n)).targetMatch && l.targetMatchIndex === t && l.targetMatch[0].length > 1 && void 0 !== f[l.targetMatch[0]] || (l = P(t + 2, n)).targetMatch && l.targetMatchIndex === t + 1 && l.targetMatch[0].length > 1 && void 0 !== f[l.targetMatch[0]]) && (u = f[l.targetMatch[0]][0]), 
                            void 0 !== u && (void 0 !== r.validPositions[t + 1] && new RegExp(u).test(a + "0") ? (e[t] = a, 
                            e[t + 1] = "0", i = {
                                pos: t + 2,
                                caret: t
                            }) : new RegExp(u).test("0" + a) && (e[t] = "0", e[t + 1] = a, i = {
                                pos: t + 2
                            })), !1 === i)) return i;
                            if (i.fuzzy && (e = i.buffer, t = i.pos), (l = P(t, n)).targetMatch && l.targetMatch[0] && void 0 !== f[l.targetMatch[0]]) {
                                u = f[l.targetMatch[0]][0];
                                var d = e.slice(l.targetMatchIndex, l.targetMatchIndex + l.targetMatch[0].length);
                                !1 === new RegExp(u).test(d.join("")) && 2 === l.targetMatch[0].length && r.validPositions[l.targetMatchIndex] && r.validPositions[l.targetMatchIndex + 1] && (r.validPositions[l.targetMatchIndex + 1].input = "0");
                            }
                            var p = i, h = b(e.join(""), n.inputFormat, n);
                            return p && h.date.getTime() == h.date.getTime() && (n.prefillYear && (p = function(e, t, a) {
                                if (e.year !== e.rawyear) {
                                    var i = c.toString(), n = e.rawyear.replace(/[^0-9]/g, ""), r = i.slice(0, n.length), o = i.slice(n.length);
                                    if (2 === n.length && n === r) {
                                        var s = new Date(c, e.month - 1, e.day);
                                        e.day == s.getDate() && (!a.max || a.max.date.getTime() >= s.getTime()) && (e.date.setFullYear(c), 
                                        e.year = i, t.insert = [ {
                                            pos: t.pos + 1,
                                            c: o[0]
                                        }, {
                                            pos: t.pos + 2,
                                            c: o[1]
                                        } ]);
                                    }
                                }
                                return t;
                            }(h, p, n)), p = function(e, t, a, i, n) {
                                if (!t) return t;
                                if (a.min) {
                                    if (e.rawyear) {
                                        var r, o = e.rawyear.replace(/[^0-9]/g, ""), s = a.min.year.substr(0, o.length);
                                        if (o < s) {
                                            var l = P(t.pos, a);
                                            if (o = e.rawyear.substr(0, t.pos - l.targetMatchIndex + 1).replace(/[^0-9]/g, "0"), 
                                            (s = a.min.year.substr(0, o.length)) <= o) return t.remove = l.targetMatchIndex + o.length, 
                                            t;
                                            if (o = "yyyy" === l.targetMatch[0] ? e.rawyear.substr(1, 1) : e.rawyear.substr(0, 1), 
                                            s = a.min.year.substr(2, 1), r = a.max ? a.max.year.substr(2, 1) : o, 1 === o.length && s <= o && o <= r && !0 !== n) return "yyyy" === l.targetMatch[0] ? (t.insert = [ {
                                                pos: t.pos + 1,
                                                c: o,
                                                strict: !0
                                            } ], t.caret = t.pos + 2, i.validPositions[t.pos].input = a.min.year[1]) : (t.insert = [ {
                                                pos: t.pos + 1,
                                                c: a.min.year[1],
                                                strict: !0
                                            }, {
                                                pos: t.pos + 2,
                                                c: o,
                                                strict: !0
                                            } ], t.caret = t.pos + 3, i.validPositions[t.pos].input = a.min.year[0]), t;
                                            t = !1;
                                        }
                                    }
                                    for (var u in e) -1 === u.indexOf("raw") && e["raw".concat(u)] && (e["raw".concat(u)]);
                                    t && e.year && e.year === e.rawyear && a.min.date.getTime() == a.min.date.getTime() && (t = a.min.date.getTime() <= e.date.getTime());
                                }
                                return t && a.max && a.max.date.getTime() == a.max.date.getTime() && (t = a.max.date.getTime() >= e.date.getTime()), 
                                t;
                            }(h, p = g.call(this, h, p, n), n, r, s)), void 0 !== t && p && i.pos !== t ? {
                                buffer: k(n.inputFormat, h, n).split(""),
                                refreshFromBuffer: {
                                    start: t,
                                    end: i.pos
                                },
                                pos: i.caret || i.pos
                            } : p;
                        },
                        onKeyDown: function(e, t, a, i) {
                            e.ctrlKey && e.keyCode === n.default.RIGHT && (this.inputmask._valueSet(x(new Date, i)), 
                            u(this).trigger("setvalue"));
                        },
                        onUnMask: function(e, t, a) {
                            return t ? k(a.outputFormat, b(e, a.inputFormat, a), a, !0) : t;
                        },
                        casing: function(e, t, a, i) {
                            return 0 == t.nativeDef.indexOf("[ap]") ? e.toLowerCase() : 0 == t.nativeDef.indexOf("[AP]") ? e.toUpperCase() : e;
                        },
                        onBeforeMask: function(e, t) {
                            return "[object Date]" === Object.prototype.toString.call(e) && (e = x(e, t)), e;
                        },
                        insertMode: !1,
                        shiftPositions: !1,
                        keepStatic: !1,
                        inputmode: "numeric",
                        prefillYear: !0
                    }
                });
            },
            3851: function(e, t, a) {
                var i, n = (i = a(2394)) && i.__esModule ? i : {
                    default: i
                }, r = a(8711), o = a(4713);
                n.default.extendDefinitions({
                    A: {
                        validator: "[A-Za-z\u0410-\u044f\u0401\u0451\xc0-\xff\xb5]",
                        casing: "upper"
                    },
                    "&": {
                        validator: "[0-9A-Za-z\u0410-\u044f\u0401\u0451\xc0-\xff\xb5]",
                        casing: "upper"
                    },
                    "#": {
                        validator: "[0-9A-Fa-f]",
                        casing: "upper"
                    }
                });
                var s = new RegExp("25[0-5]|2[0-4][0-9]|[01][0-9][0-9]");
                function l(e, t, a, i, n) {
                    return a - 1 > -1 && "." !== t.buffer[a - 1] ? (e = t.buffer[a - 1] + e, e = a - 2 > -1 && "." !== t.buffer[a - 2] ? t.buffer[a - 2] + e : "0" + e) : e = "00" + e, 
                    s.test(e);
                }
                n.default.extendAliases({
                    cssunit: {
                        regex: "[+-]?[0-9]+\\.?([0-9]+)?(px|em|rem|ex|%|in|cm|mm|pt|pc)"
                    },
                    url: {
                        regex: "(https?|ftp)://.*",
                        autoUnmask: !1,
                        keepStatic: !1,
                        tabThrough: !0
                    },
                    ip: {
                        mask: "i[i[i]].j[j[j]].k[k[k]].l[l[l]]",
                        definitions: {
                            i: {
                                validator: l
                            },
                            j: {
                                validator: l
                            },
                            k: {
                                validator: l
                            },
                            l: {
                                validator: l
                            }
                        },
                        onUnMask: function(e, t, a) {
                            return e;
                        },
                        inputmode: "numeric"
                    },
                    email: {
                        mask: "*{1,64}[.*{1,64}][.*{1,64}][.*{1,63}]@-{1,63}.-{1,63}[.-{1,63}][.-{1,63}]",
                        greedy: !1,
                        casing: "lower",
                        onBeforePaste: function(e, t) {
                            return (e = e.toLowerCase()).replace("mailto:", "");
                        },
                        definitions: {
                            "*": {
                                validator: "[0-9\uff11-\uff19A-Za-z\u0410-\u044f\u0401\u0451\xc0-\xff\xb5!#$%&'*+/=?^_`{|}~-]"
                            },
                            "-": {
                                validator: "[0-9A-Za-z-]"
                            }
                        },
                        onUnMask: function(e, t, a) {
                            return e;
                        },
                        inputmode: "email"
                    },
                    mac: {
                        mask: "##:##:##:##:##:##"
                    },
                    vin: {
                        mask: "V{13}9{4}",
                        definitions: {
                            V: {
                                validator: "[A-HJ-NPR-Za-hj-npr-z\\d]",
                                casing: "upper"
                            }
                        },
                        clearIncomplete: !0,
                        autoUnmask: !0
                    },
                    ssn: {
                        mask: "999-99-9999",
                        postValidation: function(e, t, a, i, n, s, l) {
                            var u = o.getMaskTemplate.call(this, !0, r.getLastValidPosition.call(this), !0, !0);
                            return /^(?!219-09-9999|078-05-1120)(?!666|000|9.{2}).{3}-(?!00).{2}-(?!0{4}).{4}$/.test(u.join(""));
                        }
                    }
                });
            },
            207: function(e, t, a) {
                var i = s(a(2394)), n = s(a(4528)), r = s(a(7184)), o = a(8711);
                function s(e) {
                    return e && e.__esModule ? e : {
                        default: e
                    };
                }
                var l = i.default.dependencyLib;
                function u(e, t) {
                    for (var a = "", n = 0; n < e.length; n++) i.default.prototype.definitions[e.charAt(n)] || t.definitions[e.charAt(n)] || t.optionalmarker[0] === e.charAt(n) || t.optionalmarker[1] === e.charAt(n) || t.quantifiermarker[0] === e.charAt(n) || t.quantifiermarker[1] === e.charAt(n) || t.groupmarker[0] === e.charAt(n) || t.groupmarker[1] === e.charAt(n) || t.alternatormarker === e.charAt(n) ? a += "\\" + e.charAt(n) : a += e.charAt(n);
                    return a;
                }
                function c(e, t, a, i) {
                    if (e.length > 0 && t > 0 && (!a.digitsOptional || i)) {
                        var n = e.indexOf(a.radixPoint), r = !1;
                        a.negationSymbol.back === e[e.length - 1] && (r = !0, e.length--), -1 === n && (e.push(a.radixPoint), 
                        n = e.length - 1);
                        for (var o = 1; o <= t; o++) isFinite(e[n + o]) || (e[n + o] = "0");
                    }
                    return r && e.push(a.negationSymbol.back), e;
                }
                function f(e, t) {
                    var a = 0;
                    if ("+" === e) {
                        for (a in t.validPositions) ;
                        a = o.seekNext.call(this, parseInt(a));
                    }
                    for (var i in t.tests) if ((i = parseInt(i)) >= a) for (var n = 0, r = t.tests[i].length; n < r; n++) if ((void 0 === t.validPositions[i] || "-" === e) && t.tests[i][n].match.def === e) return i + (void 0 !== t.validPositions[i] && "-" !== e ? 1 : 0);
                    return a;
                }
                function d(e, t) {
                    var a = -1;
                    for (var i in t.validPositions) {
                        var n = t.validPositions[i];
                        if (n && n.match.def === e) {
                            a = parseInt(i);
                            break;
                        }
                    }
                    return a;
                }
                function p(e, t, a, i, n) {
                    var r = t.buffer ? t.buffer.indexOf(n.radixPoint) : -1, o = (-1 !== r || i && n.jitMasking) && new RegExp(n.definitions[9].validator).test(e);
                    return n._radixDance && -1 !== r && o && null == t.validPositions[r] ? {
                        insert: {
                            pos: r === a ? r + 1 : r,
                            c: n.radixPoint
                        },
                        pos: a
                    } : o;
                }
                i.default.extendAliases({
                    numeric: {
                        mask: function(e) {
                            e.repeat = 0, e.groupSeparator === e.radixPoint && e.digits && "0" !== e.digits && ("." === e.radixPoint ? e.groupSeparator = "," : "," === e.radixPoint ? e.groupSeparator = "." : e.groupSeparator = ""), 
                            " " === e.groupSeparator && (e.skipOptionalPartCharacter = void 0), e.placeholder.length > 1 && (e.placeholder = e.placeholder.charAt(0)), 
                            "radixFocus" === e.positionCaretOnClick && "" === e.placeholder && (e.positionCaretOnClick = "lvp");
                            var t = "0", a = e.radixPoint;
                            !0 === e.numericInput && void 0 === e.__financeInput ? (t = "1", e.positionCaretOnClick = "radixFocus" === e.positionCaretOnClick ? "lvp" : e.positionCaretOnClick, 
                            e.digitsOptional = !1, isNaN(e.digits) && (e.digits = 2), e._radixDance = !1, a = "," === e.radixPoint ? "?" : "!", 
                            "" !== e.radixPoint && void 0 === e.definitions[a] && (e.definitions[a] = {}, e.definitions[a].validator = "[" + e.radixPoint + "]", 
                            e.definitions[a].placeholder = e.radixPoint, e.definitions[a].static = !0, e.definitions[a].generated = !0)) : (e.__financeInput = !1, 
                            e.numericInput = !0);
                            var i, n = "[+]";
                            if (n += u(e.prefix, e), "" !== e.groupSeparator ? (void 0 === e.definitions[e.groupSeparator] && (e.definitions[e.groupSeparator] = {}, 
                            e.definitions[e.groupSeparator].validator = "[" + e.groupSeparator + "]", e.definitions[e.groupSeparator].placeholder = e.groupSeparator, 
                            e.definitions[e.groupSeparator].static = !0, e.definitions[e.groupSeparator].generated = !0), 
                            n += e._mask(e)) : n += "9{+}", void 0 !== e.digits && 0 !== e.digits) {
                                var o = e.digits.toString().split(",");
                                isFinite(o[0]) && o[1] && isFinite(o[1]) ? n += a + t + "{" + e.digits + "}" : (isNaN(e.digits) || parseInt(e.digits) > 0) && (e.digitsOptional || e.jitMasking ? (i = n + a + t + "{0," + e.digits + "}", 
                                e.keepStatic = !0) : n += a + t + "{" + e.digits + "}");
                            } else e.inputmode = "numeric";
                            return n += u(e.suffix, e), n += "[-]", i && (n = [ i + u(e.suffix, e) + "[-]", n ]), 
                            e.greedy = !1, function(e) {
                                void 0 === e.parseMinMaxOptions && (null !== e.min && (e.min = e.min.toString().replace(new RegExp((0, r.default)(e.groupSeparator), "g"), ""), "," === e.radixPoint && (e.min = e.min.replace(e.radixPoint, ".")), 
                                e.min = isFinite(e.min) ? parseFloat(e.min) : NaN, isNaN(e.min) && (e.min = Number.MIN_VALUE)), 
                                null !== e.max && (e.max = e.max.toString().replace(new RegExp((0, r.default)(e.groupSeparator), "g"), ""), 
                                "," === e.radixPoint && (e.max = e.max.replace(e.radixPoint, ".")), e.max = isFinite(e.max) ? parseFloat(e.max) : NaN, 
                                isNaN(e.max) && (e.max = Number.MAX_VALUE)), e.parseMinMaxOptions = "done");
                            }(e), n;
                        },
                        _mask: function(e) {
                            return "(" + e.groupSeparator + "999){+|1}";
                        },
                        digits: "*",
                        digitsOptional: !0,
                        enforceDigitsOnBlur: !1,
                        radixPoint: ".",
                        positionCaretOnClick: "radixFocus",
                        _radixDance: !0,
                        groupSeparator: "",
                        allowMinus: !0,
                        negationSymbol: {
                            front: "-",
                            back: ""
                        },
                        prefix: "",
                        suffix: "",
                        min: null,
                        max: null,
                        SetMaxOnOverflow: !1,
                        step: 1,
                        inputType: "text",
                        unmaskAsNumber: !1,
                        roundingFN: Math.round,
                        inputmode: "decimal",
                        shortcuts: {
                            k: "000",
                            m: "000000"
                        },
                        placeholder: "0",
                        greedy: !1,
                        rightAlign: !0,
                        insertMode: !0,
                        autoUnmask: !1,
                        skipOptionalPartCharacter: "",
                        usePrototypeDefinitions: !1,
                        definitions: {
                            0: {
                                validator: p
                            },
                            1: {
                                validator: p,
                                definitionSymbol: "9"
                            },
                            9: {
                                validator: "[0-9\uff10-\uff19\u0660-\u0669\u06f0-\u06f9]",
                                definitionSymbol: "*"
                            },
                            "+": {
                                validator: function(e, t, a, i, n) {
                                    return n.allowMinus && ("-" === e || e === n.negationSymbol.front);
                                }
                            },
                            "-": {
                                validator: function(e, t, a, i, n) {
                                    return n.allowMinus && e === n.negationSymbol.back;
                                }
                            }
                        },
                        preValidation: function(e, t, a, i, n, r, o, s) {
                            var l;
                            if (!1 !== n.__financeInput && a === n.radixPoint) return !1;
                            if (l = n.shortcuts && n.shortcuts[a]) {
                                if (l.length > 1) for (var u = [], c = 0; c < l.length; c++) u.push({
                                    pos: t + c,
                                    c: l[c],
                                    strict: !1
                                });
                                return {
                                    insert: u
                                };
                            }
                            var p = e.indexOf(n.radixPoint), h = t;
                            if (t = function(e, t, a, i, n) {
                                return n._radixDance && n.numericInput && t !== n.negationSymbol.back && e <= a && (a > 0 || t == n.radixPoint) && (void 0 === i.validPositions[e - 1] || i.validPositions[e - 1].input !== n.negationSymbol.back) && (e -= 1), 
                                e;
                            }(t, a, p, r, n), "-" === a || a === n.negationSymbol.front) {
                                if (!0 !== n.allowMinus) return !1;
                                var v = !1, m = d("+", r), g = d("-", r);
                                return -1 !== m && (v = [ m, g ]), !1 !== v ? {
                                    remove: v,
                                    caret: h - n.negationSymbol.back.length
                                } : {
                                    insert: [ {
                                        pos: f.call(this, "+", r),
                                        c: n.negationSymbol.front,
                                        fromIsValid: !0
                                    }, {
                                        pos: f.call(this, "-", r),
                                        c: n.negationSymbol.back,
                                        fromIsValid: void 0
                                    } ],
                                    caret: h + n.negationSymbol.back.length
                                };
                            }
                            if (a === n.groupSeparator) return {
                                caret: h
                            };
                            if (s) return !0;
                            if (-1 !== p && !0 === n._radixDance && !1 === i && a === n.radixPoint && void 0 !== n.digits && (isNaN(n.digits) || parseInt(n.digits) > 0) && p !== t) return {
                                caret: n._radixDance && t === p - 1 ? p + 1 : p
                            };
                            if (!1 === n.__financeInput) if (i) {
                                if (n.digitsOptional) return {
                                    rewritePosition: o.end
                                };
                                if (!n.digitsOptional) {
                                    if (o.begin > p && o.end <= p) return a === n.radixPoint ? {
                                        insert: {
                                            pos: p + 1,
                                            c: "0",
                                            fromIsValid: !0
                                        },
                                        rewritePosition: p
                                    } : {
                                        rewritePosition: p + 1
                                    };
                                    if (o.begin < p) return {
                                        rewritePosition: o.begin - 1
                                    };
                                }
                            } else if (!n.showMaskOnHover && !n.showMaskOnFocus && !n.digitsOptional && n.digits > 0 && "" === this.__valueGet.call(this.el)) return {
                                rewritePosition: p
                            };
                            return {
                                rewritePosition: t
                            };
                        },
                        postValidation: function(e, t, a, i, n, r, o) {
                            if (!1 === i) return i;
                            if (o) return !0;
                            if (null !== n.min || null !== n.max) {
                                var s = n.onUnMask(e.slice().reverse().join(""), void 0, l.extend({}, n, {
                                    unmaskAsNumber: !0
                                }));
                                if (null !== n.min && s < n.min && (s.toString().length > n.min.toString().length || s < 0)) return !1;
                                if (null !== n.max && s > n.max) return !!n.SetMaxOnOverflow && {
                                    refreshFromBuffer: !0,
                                    buffer: c(n.max.toString().replace(".", n.radixPoint).split(""), n.digits, n).reverse()
                                };
                            }
                            return i;
                        },
                        onUnMask: function(e, t, a) {
                            if ("" === t && !0 === a.nullable) return t;
                            var i = e.replace(a.prefix, "");
                            return i = (i = i.replace(a.suffix, "")).replace(new RegExp((0, r.default)(a.groupSeparator), "g"), ""), 
                            "" !== a.placeholder.charAt(0) && (i = i.replace(new RegExp(a.placeholder.charAt(0), "g"), "0")), 
                            a.unmaskAsNumber ? ("" !== a.radixPoint && -1 !== i.indexOf(a.radixPoint) && (i = i.replace(r.default.call(this, a.radixPoint), ".")), 
                            i = (i = i.replace(new RegExp("^" + (0, r.default)(a.negationSymbol.front)), "-")).replace(new RegExp((0, r.default)(a.negationSymbol.back) + "$"), ""), Number(i)) : i;
                        },
                        isComplete: function(e, t) {
                            var a = (t.numericInput ? e.slice().reverse() : e).join("");
                            return a = (a = (a = (a = (a = a.replace(new RegExp("^" + (0, r.default)(t.negationSymbol.front)), "-")).replace(new RegExp((0, r.default)(t.negationSymbol.back) + "$"), "")).replace(t.prefix, "")).replace(t.suffix, "")).replace(new RegExp((0, r.default)(t.groupSeparator) + "([0-9]{3})", "g"), "$1"), "," === t.radixPoint && (a = a.replace((0, r.default)(t.radixPoint), ".")), isFinite(a);
                        },
                        onBeforeMask: function(e, t) {
                            var a = t.radixPoint || ",";
                            isFinite(t.digits) && (t.digits = parseInt(t.digits)), "number" != typeof e && "number" !== t.inputType || "" === a || (e = e.toString().replace(".", a));
                            var i = "-" === e.charAt(0) || e.charAt(0) === t.negationSymbol.front, n = e.split(a), o = n[0].replace(/[^\-0-9]/g, ""), s = n.length > 1 ? n[1].replace(/[^0-9]/g, "") : "", l = n.length > 1;
                            e = o + ("" !== s ? a + s : s);
                            var u = 0;
                            if ("" !== a && (u = t.digitsOptional ? t.digits < s.length ? t.digits : s.length : t.digits, 
                            "" !== s || !t.digitsOptional)) {
                                var f = Math.pow(10, u || 1);
                                e = e.replace((0, r.default)(a), "."), isNaN(parseFloat(e)) || (e = (t.roundingFN(parseFloat(e) * f) / f).toFixed(u)), 
                                e = e.toString().replace(".", a);
                            }
                            if (0 === t.digits && -1 !== e.indexOf(a) && (e = e.substring(0, e.indexOf(a))), 
                            null !== t.min || null !== t.max) {
                                var d = e.toString().replace(a, ".");
                                null !== t.min && d < t.min ? e = t.min.toString().replace(".", a) : null !== t.max && d > t.max && (e = t.max.toString().replace(".", a));
                            }
                            return i && "-" !== e.charAt(0) && (e = "-" + e), c(e.toString().split(""), u, t, l).join("");
                        },
                        onBeforeWrite: function(e, t, a, i) {
                            function n(e, t) {
                                if (!1 !== i.__financeInput || t) {
                                    var a = e.indexOf(i.radixPoint);
                                    -1 !== a && e.splice(a, 1);
                                }
                                if ("" !== i.groupSeparator) for (;-1 !== (a = e.indexOf(i.groupSeparator)); ) e.splice(a, 1);
                                return e;
                            }
                            var o, s = function(e, t) {
                                var a = new RegExp("(^" + ("" !== t.negationSymbol.front ? (0, r.default)(t.negationSymbol.front) + "?" : "") + (0, r.default)(t.prefix) + ")(.*)(" + (0, r.default)(t.suffix) + ("" != t.negationSymbol.back ? (0, r.default)(t.negationSymbol.back) + "?" : "") + "$)").exec(e.slice().reverse().join("")), i = a ? a[2] : "", n = !1;
                                return i && (i = i.split(t.radixPoint.charAt(0))[0], n = new RegExp("^[0" + t.groupSeparator + "]*").exec(i)), 
                                !(!n || !(n[0].length > 1 || n[0].length > 0 && n[0].length < i.length)) && n;
                            }(t, i);
                            if (s) for (var u = t.join("").lastIndexOf(s[0].split("").reverse().join("")) - (s[0] == s.input ? 0 : 1), f = s[0] == s.input ? 1 : 0, d = s[0].length - f; d > 0; d--) delete this.maskset.validPositions[u + d], 
                            delete t[u + d];
                            if (e) switch (e.type) {
                              case "blur":
                              case "checkval":
                                if (null !== i.min) {
                                    var p = i.onUnMask(t.slice().reverse().join(""), void 0, l.extend({}, i, {
                                        unmaskAsNumber: !0
                                    }));
                                    if (null !== i.min && p < i.min) return {
                                        refreshFromBuffer: !0,
                                        buffer: c(i.min.toString().replace(".", i.radixPoint).split(""), i.digits, i).reverse()
                                    };
                                }
                                if (t[t.length - 1] === i.negationSymbol.front) {
                                    var h = new RegExp("(^" + ("" != i.negationSymbol.front ? (0, r.default)(i.negationSymbol.front) + "?" : "") + (0, r.default)(i.prefix) + ")(.*)(" + (0, r.default)(i.suffix) + ("" != i.negationSymbol.back ? (0, r.default)(i.negationSymbol.back) + "?" : "") + "$)").exec(n(t.slice(), !0).reverse().join(""));
                                    0 == (h ? h[2] : "") && (o = {
                                        refreshFromBuffer: !0,
                                        buffer: [ 0 ]
                                    });
                                } else "" !== i.radixPoint && t[0] === i.radixPoint && (o && o.buffer ? o.buffer.shift() : (t.shift(), 
                                o = {
                                    refreshFromBuffer: !0,
                                    buffer: n(t)
                                }));
                                if (i.enforceDigitsOnBlur) {
                                    var v = (o = o || {}) && o.buffer || t.slice().reverse();
                                    o.refreshFromBuffer = !0, o.buffer = c(v, i.digits, i, !0).reverse();
                                }
                            }
                            return o;
                        },
                        onKeyDown: function(e, t, a, i) {
                            var r, o = l(this);
                            if (e.ctrlKey) switch (e.keyCode) {
                              case n.default.UP:
                                return this.inputmask.__valueSet.call(this, parseFloat(this.inputmask.unmaskedvalue()) + parseInt(i.step)), 
                                o.trigger("setvalue"), !1;

                              case n.default.DOWN:
                                return this.inputmask.__valueSet.call(this, parseFloat(this.inputmask.unmaskedvalue()) - parseInt(i.step)), 
                                o.trigger("setvalue"), !1;
                            }
                            if (!e.shiftKey && (e.keyCode === n.default.DELETE || e.keyCode === n.default.BACKSPACE || e.keyCode === n.default.BACKSPACE_SAFARI) && a.begin !== t.length) {
                                if (t[e.keyCode === n.default.DELETE ? a.begin - 1 : a.end] === i.negationSymbol.front) return r = t.slice().reverse(), 
                                "" !== i.negationSymbol.front && r.shift(), "" !== i.negationSymbol.back && r.pop(), 
                                o.trigger("setvalue", [ r.join(""), a.begin ]), !1;
                                if (!0 === i._radixDance) {
                                    var s = t.indexOf(i.radixPoint);
                                    if (i.digitsOptional) {
                                        if (0 === s) return (r = t.slice().reverse()).pop(), o.trigger("setvalue", [ r.join(""), a.begin >= r.length ? r.length : a.begin ]), 
                                        !1;
                                    } else if (-1 !== s && (a.begin < s || a.end < s || e.keyCode === n.default.DELETE && a.begin === s)) return a.begin !== a.end || e.keyCode !== n.default.BACKSPACE && e.keyCode !== n.default.BACKSPACE_SAFARI || a.begin++, 
                                    (r = t.slice().reverse()).splice(r.length - a.begin, a.begin - a.end + 1), r = c(r, i.digits, i).join(""), 
                                    o.trigger("setvalue", [ r, a.begin >= r.length ? s + 1 : a.begin ]), !1;
                                }
                            }
                        }
                    },
                    currency: {
                        prefix: "",
                        groupSeparator: ",",
                        alias: "numeric",
                        digits: 2,
                        digitsOptional: !1
                    },
                    decimal: {
                        alias: "numeric"
                    },
                    integer: {
                        alias: "numeric",
                        inputmode: "numeric",
                        digits: 0
                    },
                    percentage: {
                        alias: "numeric",
                        min: 0,
                        max: 100,
                        suffix: " %",
                        digits: 0,
                        allowMinus: !1
                    },
                    indianns: {
                        alias: "numeric",
                        _mask: function(e) {
                            return "(" + e.groupSeparator + "99){*|1}(" + e.groupSeparator + "999){1|1}";
                        },
                        groupSeparator: ",",
                        radixPoint: ".",
                        placeholder: "0",
                        digits: 2,
                        digitsOptional: !1
                    }
                });
            },
            9380: function(e, t, a) {
                var i;
                Object.defineProperty(t, "__esModule", {
                    value: !0
                }), t.default = void 0;
                var n = ((i = a(8741)) && i.__esModule ? i : {
                    default: i
                }).default ? window : {};
                t.default = n;
            },
            7760: function(e, t, a) {
                Object.defineProperty(t, "__esModule", {
                    value: !0
                }), t.applyInputValue = c, t.clearOptionalTail = f, t.checkVal = d, t.HandleNativePlaceholder = function(e, t) {
                    var a = e ? e.inputmask : this;
                    if (l.ie) {
                        if (e.inputmask._valueGet() !== t && (e.placeholder !== t || "" === e.placeholder)) {
                            var i = o.getBuffer.call(a).slice(), n = e.inputmask._valueGet();
                            if (n !== t) {
                                var r = o.getLastValidPosition.call(a);
                                -1 === r && n === o.getBufferTemplate.call(a).join("") ? i = [] : -1 !== r && f.call(a, i), 
                                p(e, i);
                            }
                        }
                    } else e.placeholder !== t && (e.placeholder = t, "" === e.placeholder && e.removeAttribute("placeholder"));
                }, t.unmaskedvalue = function(e) {
                    var t = e ? e.inputmask : this, a = t.opts, i = t.maskset;
                    if (e) {
                        if (void 0 === e.inputmask) return e.value;
                        e.inputmask && e.inputmask.refreshValue && c(e, e.inputmask._valueGet(!0));
                    }
                    var n = [], r = i.validPositions;
                    for (var s in r) r[s] && r[s].match && (1 != r[s].match.static || Array.isArray(i.metadata) && !0 !== r[s].generatedInput) && n.push(r[s].input);
                    var l = 0 === n.length ? "" : (t.isRTL ? n.reverse() : n).join("");
                    if ("function" == typeof a.onUnMask) {
                        var u = (t.isRTL ? o.getBuffer.call(t).slice().reverse() : o.getBuffer.call(t)).join("");
                        l = a.onUnMask.call(t, u, l, a);
                    }
                    return l;
                }, t.writeBuffer = p;
                var i, n = (i = a(4528)) && i.__esModule ? i : {
                    default: i
                }, r = a(4713), o = a(8711), s = a(7215), l = a(9845), u = a(6030);
                function c(e, t) {
                    var a = e ? e.inputmask : this, i = a.opts;
                    e.inputmask.refreshValue = !1, "function" == typeof i.onBeforeMask && (t = i.onBeforeMask.call(a, t, i) || t), 
                    d(e, !0, !1, t = t.toString().split("")), a.undoValue = a._valueGet(!0), (i.clearMaskOnLostFocus || i.clearIncomplete) && e.inputmask._valueGet() === o.getBufferTemplate.call(a).join("") && -1 === o.getLastValidPosition.call(a) && e.inputmask._valueSet("");
                }
                function f(e) {
                    e.length = 0;
                    for (var t, a = r.getMaskTemplate.call(this, !0, 0, !0, void 0, !0); void 0 !== (t = a.shift()); ) e.push(t);
                    return e;
                }
                function d(e, t, a, i, n) {
                    var l = e ? e.inputmask : this, c = l.maskset, f = l.opts, d = l.dependencyLib, h = i.slice(), v = "", m = -1, g = void 0, k = f.skipOptionalPartCharacter;
                    f.skipOptionalPartCharacter = "", o.resetMaskSet.call(l), c.tests = {}, m = f.radixPoint ? o.determineNewCaretPosition.call(l, {
                        begin: 0,
                        end: 0
                    }, !1, !1 === f.__financeInput ? "radixFocus" : void 0).begin : 0, c.p = m, l.caretPos = {
                        begin: m
                    };
                    var y = [], b = l.caretPos;
                    if (h.forEach((function(e, t) {
                        if (void 0 !== e) {
                            var i = new d.Event("_checkval");
                            i.which = e.toString().charCodeAt(0), v += e;
                            var n = o.getLastValidPosition.call(l, void 0, !0);
                            !function(e, t) {
                                for (var a = r.getMaskTemplate.call(l, !0, 0).slice(e, o.seekNext.call(l, e, !1, !1)).join("").replace(/'/g, ""), i = a.indexOf(t); i > 0 && " " === a[i - 1]; ) i--;
                                var n = 0 === i && !o.isMask.call(l, e) && (r.getTest.call(l, e).match.nativeDef === t.charAt(0) || !0 === r.getTest.call(l, e).match.static && r.getTest.call(l, e).match.nativeDef === "'" + t.charAt(0) || " " === r.getTest.call(l, e).match.nativeDef && (r.getTest.call(l, e + 1).match.nativeDef === t.charAt(0) || !0 === r.getTest.call(l, e + 1).match.static && r.getTest.call(l, e + 1).match.nativeDef === "'" + t.charAt(0)));
                                if (!n && i > 0 && !o.isMask.call(l, e, !1, !0)) {
                                    var s = o.seekNext.call(l, e);
                                    l.caretPos.begin < s && (l.caretPos = {
                                        begin: s
                                    });
                                }
                                return n;
                            }(m, v) ? (g = u.EventHandlers.keypressEvent.call(l, i, !0, !1, a, l.caretPos.begin)) && (m = l.caretPos.begin + 1, 
                            v = "") : g = u.EventHandlers.keypressEvent.call(l, i, !0, !1, a, n + 1), g ? (void 0 !== g.pos && c.validPositions[g.pos] && !0 === c.validPositions[g.pos].match.static && void 0 === c.validPositions[g.pos].alternation && (y.push(g.pos), 
                            l.isRTL || (g.forwardPosition = g.pos + 1)), p.call(l, void 0, o.getBuffer.call(l), g.forwardPosition, i, !1), 
                            l.caretPos = {
                                begin: g.forwardPosition,
                                end: g.forwardPosition
                            }, b = l.caretPos) : void 0 === c.validPositions[t] && h[t] === r.getPlaceholder.call(l, t) && o.isMask.call(l, t, !0) ? l.caretPos.begin++ : l.caretPos = b;
                        }
                    })), y.length > 0) {
                        var x, P, E = o.seekNext.call(l, -1, void 0, !1);
                        if (!s.isComplete.call(l, o.getBuffer.call(l)) && y.length <= E || s.isComplete.call(l, o.getBuffer.call(l)) && y.length > 0 && y.length !== E && 0 === y[0]) for (var S = E; void 0 !== (x = y.shift()); ) {
                            var _ = new d.Event("_checkval");
                            if ((P = c.validPositions[x]).generatedInput = !0, _.which = P.input.charCodeAt(0), 
                            (g = u.EventHandlers.keypressEvent.call(l, _, !0, !1, a, S)) && void 0 !== g.pos && g.pos !== x && c.validPositions[g.pos] && !0 === c.validPositions[g.pos].match.static) y.push(g.pos); else if (!g) break;
                            S++;
                        }
                    }
                    t && p.call(l, e, o.getBuffer.call(l), g ? g.forwardPosition : l.caretPos.begin, n || new d.Event("checkval"), n && "input" === n.type && l.undoValue !== l._valueGet(!0)), 
                    f.skipOptionalPartCharacter = k;
                }
                function p(e, t, a, i, r) {
                    var l = e ? e.inputmask : this, u = l.opts, c = l.dependencyLib;
                    if (i && "function" == typeof u.onBeforeWrite) {
                        var f = u.onBeforeWrite.call(l, i, t, a, u);
                        if (f) {
                            if (f.refreshFromBuffer) {
                                var d = f.refreshFromBuffer;
                                s.refreshFromBuffer.call(l, !0 === d ? d : d.start, d.end, f.buffer || t), t = o.getBuffer.call(l, !0);
                            }
                            void 0 !== a && (a = void 0 !== f.caret ? f.caret : a);
                        }
                    }
                    if (void 0 !== e && (e.inputmask._valueSet(t.join("")), void 0 === a || void 0 !== i && "blur" === i.type || o.caret.call(l, e, a, void 0, void 0, void 0 !== i && "keydown" === i.type && (i.keyCode === n.default.DELETE || i.keyCode === n.default.BACKSPACE)), 
                    !0 === r)) {
                        var p = c(e), h = e.inputmask._valueGet();
                        e.inputmask.skipInputEvent = !0, p.trigger("input"), setTimeout((function() {
                            h === o.getBufferTemplate.call(l).join("") ? p.trigger("cleared") : !0 === s.isComplete.call(l, t) && p.trigger("complete");
                        }), 0);
                    }
                }
            },
            2394: function(e, t, a) {
                Object.defineProperty(t, "__esModule", {
                    value: !0
                }), t.default = void 0, a(7149), a(3194);
                var i = a(157), n = m(a(4963)), r = m(a(9380)), o = a(2391), s = a(4713), l = a(8711), u = a(7215), c = a(7760), f = a(9716), d = m(a(7392)), p = m(a(3976)), h = m(a(8741));
                function v(e) {
                    return (v = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function(e) {
                        return typeof e;
                    } : function(e) {
                        return e && "function" == typeof Symbol && e.constructor === Symbol && e !== Symbol.prototype ? "symbol" : typeof e;
                    })(e);
                }
                function m(e) {
                    return e && e.__esModule ? e : {
                        default: e
                    };
                }
                var g = r.default.document, k = "_inputmask_opts";
                function y(e, t, a) {
                    if (h.default) {
                        if (!(this instanceof y)) return new y(e, t, a);
                        this.dependencyLib = n.default, this.el = void 0, this.events = {}, this.maskset = void 0, 
                        !0 !== a && ("[object Object]" === Object.prototype.toString.call(e) ? t = e : (t = t || {}, 
                        e && (t.alias = e)), this.opts = n.default.extend(!0, {}, this.defaults, t), this.noMasksCache = t && void 0 !== t.definitions, 
                        this.userOptions = t || {}, b(this.opts.alias, t, this.opts)), this.refreshValue = !1, 
                        this.undoValue = void 0, this.$el = void 0, this.skipKeyPressEvent = !1, this.skipInputEvent = !1, 
                        this.validationEvent = !1, this.ignorable = !1, this.mouseEnter = !1, 
                        this.originalPlaceholder = void 0, this.isComposing = !1;
                    }
                }
                function b(e, t, a) {
                    var i = y.prototype.aliases[e];
                    return i ? (i.alias && b(i.alias, void 0, a), n.default.extend(!0, a, i), n.default.extend(!0, a, t), 
                    !0) : (null === a.mask && (a.mask = e), !1);
                }
                y.prototype = {
                    dataAttribute: "data-inputmask",
                    defaults: p.default,
                    definitions: d.default,
                    aliases: {},
                    masksCache: {},
                    get isRTL() {
                        return this.opts.isRTL || this.opts.numericInput;
                    },
                    mask: function(e) {
                        var t = this;
                        return "string" == typeof e && (e = g.getElementById(e) || g.querySelectorAll(e)), 
                        (e = e.nodeName ? [ e ] : Array.isArray(e) ? e : Array.from(e)).forEach((function(e, a) {
                            var s = n.default.extend(!0, {}, t.opts);
                            if (function(e, t, a, i) {
                                function o(t, n) {
                                    var o = "" === i ? t : i + "-" + t;
                                    null !== (n = void 0 !== n ? n : e.getAttribute(o)) && ("string" == typeof n && (0 === t.indexOf("on") ? n = r.default[n] : "false" === n ? n = !1 : "true" === n && (n = !0)), 
                                    a[t] = n);
                                }
                                if (!0 === t.importDataAttributes) {
                                    var s, l, u, c, f = e.getAttribute(i);
                                    if (f && "" !== f && (f = f.replace(/'/g, '"'), l = JSON.parse("{" + f + "}")), 
                                    l) for (c in u = void 0, l) if ("alias" === c.toLowerCase()) {
                                        u = l[c];
                                        break;
                                    }
                                    for (s in o("alias", u), a.alias && b(a.alias, a, t), t) {
                                        if (l) for (c in u = void 0, l) if (c.toLowerCase() === s.toLowerCase()) {
                                            u = l[c];
                                            break;
                                        }
                                        o(s, u);
                                    }
                                }
                                n.default.extend(!0, t, a), ("rtl" === e.dir || t.rightAlign) && (e.style.textAlign = "right");
                                ("rtl" === e.dir || t.numericInput) && (e.dir = "ltr", e.removeAttribute("dir"), 
                                t.isRTL = !0);
                                return Object.keys(a).length;
                            }(e, s, n.default.extend(!0, {}, t.userOptions), t.dataAttribute)) {
                                var l = (0, o.generateMaskSet)(s, t.noMasksCache);
                                void 0 !== l && (void 0 !== e.inputmask && (e.inputmask.opts.autoUnmask = !0, e.inputmask.remove()), 
                                e.inputmask = new y(void 0, void 0, !0), e.inputmask.opts = s, e.inputmask.noMasksCache = t.noMasksCache, 
                                e.inputmask.userOptions = n.default.extend(!0, {}, t.userOptions), e.inputmask.el = e, 
                                e.inputmask.$el = (0, n.default)(e), e.inputmask.maskset = l, n.default.data(e, k, t.userOptions), 
                                i.mask.call(e.inputmask));
                            }
                        })), e && e[0] && e[0].inputmask || this;
                    },
                    option: function(e, t) {
                        return "string" == typeof e ? this.opts[e] : "object" === v(e) ? (n.default.extend(this.userOptions, e), 
                        this.el && !0 !== t && this.mask(this.el), this) : void 0;
                    },
                    unmaskedvalue: function(e) {
                        if (this.maskset = this.maskset || (0, o.generateMaskSet)(this.opts, this.noMasksCache), 
                        void 0 === this.el || void 0 !== e) {
                            var t = ("function" == typeof this.opts.onBeforeMask && this.opts.onBeforeMask.call(this, e, this.opts) || e).split("");
                            c.checkVal.call(this, void 0, !1, !1, t), "function" == typeof this.opts.onBeforeWrite && this.opts.onBeforeWrite.call(this, void 0, l.getBuffer.call(this), 0, this.opts);
                        }
                        return c.unmaskedvalue.call(this, this.el);
                    },
                    remove: function() {
                        if (this.el) {
                            n.default.data(this.el, k, null);
                            var e = this.opts.autoUnmask ? (0, c.unmaskedvalue)(this.el) : this._valueGet(this.opts.autoUnmask);
                            e !== l.getBufferTemplate.call(this).join("") ? this._valueSet(e, this.opts.autoUnmask) : this._valueSet(""), 
                            f.EventRuler.off(this.el), Object.getOwnPropertyDescriptor && Object.getPrototypeOf ? Object.getOwnPropertyDescriptor(Object.getPrototypeOf(this.el), "value") && this.__valueGet && Object.defineProperty(this.el, "value", {
                                get: this.__valueGet,
                                set: this.__valueSet,
                                configurable: !0
                            }) : g.__lookupGetter__ && this.el.__lookupGetter__("value") && this.__valueGet && (this.el.__defineGetter__("value", this.__valueGet), 
                            this.el.__defineSetter__("value", this.__valueSet)), this.el.inputmask = void 0;
                        }
                        return this.el;
                    },
                    getemptymask: function() {
                        return this.maskset = this.maskset || (0, o.generateMaskSet)(this.opts, this.noMasksCache), 
                        l.getBufferTemplate.call(this).join("");
                    },
                    hasMaskedValue: function() {
                        return !this.opts.autoUnmask;
                    },
                    isComplete: function() {
                        return this.maskset = this.maskset || (0, o.generateMaskSet)(this.opts, this.noMasksCache), 
                        u.isComplete.call(this, l.getBuffer.call(this));
                    },
                    getmetadata: function() {
                        if (this.maskset = this.maskset || (0, o.generateMaskSet)(this.opts, this.noMasksCache), 
                        Array.isArray(this.maskset.metadata)) {
                            var e = s.getMaskTemplate.call(this, !0, 0, !1).join("");
                            return this.maskset.metadata.forEach((function(t) {
                                return t.mask !== e || (e = t, !1);
                            })), e;
                        }
                        return this.maskset.metadata;
                    },
                    isValid: function(e) {
                        if (this.maskset = this.maskset || (0, o.generateMaskSet)(this.opts, this.noMasksCache), 
                        e) {
                            var t = ("function" == typeof this.opts.onBeforeMask && this.opts.onBeforeMask.call(this, e, this.opts) || e).split("");
                            c.checkVal.call(this, void 0, !0, !1, t);
                        } else e = this.isRTL ? l.getBuffer.call(this).slice().reverse().join("") : l.getBuffer.call(this).join("");
                        for (var a = l.getBuffer.call(this), i = l.determineLastRequiredPosition.call(this), n = a.length - 1; n > i && !l.isMask.call(this, n); n--) ;
                        return a.splice(i, n + 1 - i), u.isComplete.call(this, a) && e === (this.isRTL ? l.getBuffer.call(this).slice().reverse().join("") : l.getBuffer.call(this).join(""));
                    },
                    format: function(e, t) {
                        this.maskset = this.maskset || (0, o.generateMaskSet)(this.opts, this.noMasksCache);
                        var a = ("function" == typeof this.opts.onBeforeMask && this.opts.onBeforeMask.call(this, e, this.opts) || e).split("");
                        c.checkVal.call(this, void 0, !0, !1, a);
                        var i = this.isRTL ? l.getBuffer.call(this).slice().reverse().join("") : l.getBuffer.call(this).join("");
                        return t ? {
                            value: i,
                            metadata: this.getmetadata()
                        } : i;
                    },
                    setValue: function(e) {
                        this.el && (0, n.default)(this.el).trigger("setvalue", [ e ]);
                    },
                    analyseMask: o.analyseMask
                }, y.extendDefaults = function(e) {
                    n.default.extend(!0, y.prototype.defaults, e);
                }, y.extendDefinitions = function(e) {
                    n.default.extend(!0, y.prototype.definitions, e);
                }, y.extendAliases = function(e) {
                    n.default.extend(!0, y.prototype.aliases, e);
                }, y.format = function(e, t, a) {
                    return y(t).format(e, a);
                }, y.unmask = function(e, t) {
                    return y(t).unmaskedvalue(e);
                }, y.isValid = function(e, t) {
                    return y(t).isValid(e);
                }, y.remove = function(e) {
                    "string" == typeof e && (e = g.getElementById(e) || g.querySelectorAll(e)), (e = e.nodeName ? [ e ] : e).forEach((function(e) {
                        e.inputmask && e.inputmask.remove();
                    }));
                }, y.setValue = function(e, t) {
                    "string" == typeof e && (e = g.getElementById(e) || g.querySelectorAll(e)), (e = e.nodeName ? [ e ] : e).forEach((function(e) {
                        e.inputmask ? e.inputmask.setValue(t) : (0, n.default)(e).trigger("setvalue", [ t ]);
                    }));
                }, y.dependencyLib = n.default, r.default.Inputmask = y;
                var x = y;
                t.default = x;
            },
            5296: function(e, t, a) {
                function i(e) {
                    return (i = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function(e) {
                        return typeof e;
                    } : function(e) {
                        return e && "function" == typeof Symbol && e.constructor === Symbol && e !== Symbol.prototype ? "symbol" : typeof e;
                    })(e);
                }
                var n = p(a(9380)), r = p(a(2394)), o = p(a(8741));
                function s(e, t) {
                    return !t || "object" !== i(t) && "function" != typeof t ? function(e) {
                        if (void 0 === e) throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
                        return e;
                    }(e) : t;
                }
                function l(e) {
                    var t = "function" == typeof Map ? new Map : void 0;
                    return (l = function(e) {
                        if (null === e || (a = e, -1 === Function.toString.call(a).indexOf("[native code]"))) return e;
                        var a;
                        if ("function" != typeof e) throw new TypeError("Super expression must either be null or a function");
                        if (void 0 !== t) {
                            if (t.has(e)) return t.get(e);
                            t.set(e, i);
                        }
                        function i() {
                            return u(e, arguments, d(this).constructor);
                        }
                        return i.prototype = Object.create(e.prototype, {
                            constructor: {
                                value: i,
                                enumerable: !1,
                                writable: !0,
                                configurable: !0
                            }
                        }), f(i, e);
                    })(e);
                }
                function u(e, t, a) {
                    return (u = c() ? Reflect.construct : function(e, t, a) {
                        var i = [ null ];
                        i.push.apply(i, t);
                        var n = new (Function.bind.apply(e, i));
                        return a && f(n, a.prototype), n;
                    }).apply(null, arguments);
                }
                function c() {
                    if ("undefined" == typeof Reflect || !Reflect.construct) return !1;
                    if (Reflect.construct.sham) return !1;
                    if ("function" == typeof Proxy) return !0;
                    try {
                        return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], (function() {}))), 
                        !0;
                    } catch (e) {
                        return !1;
                    }
                }
                function f(e, t) {
                    return (f = Object.setPrototypeOf || function(e, t) {
                        return e.__proto__ = t, e;
                    })(e, t);
                }
                function d(e) {
                    return (d = Object.setPrototypeOf ? Object.getPrototypeOf : function(e) {
                        return e.__proto__ || Object.getPrototypeOf(e);
                    })(e);
                }
                function p(e) {
                    return e && e.__esModule ? e : {
                        default: e
                    };
                }
                var h = n.default.document;
                if (o.default && h && h.head && h.head.attachShadow && n.default.customElements && void 0 === n.default.customElements.get("input-mask")) {
                    var v = function(e) {
                        !function(e, t) {
                            if ("function" != typeof t && null !== t) throw new TypeError("Super expression must either be null or a function");
                            e.prototype = Object.create(t && t.prototype, {
                                constructor: {
                                    value: e,
                                    writable: !0,
                                    configurable: !0
                                }
                            }), t && f(e, t);
                        }(n, e);
                        var t, a, i = (t = n, a = c(), function() {
                            var e, i = d(t);
                            if (a) {
                                var n = d(this).constructor;
                                e = Reflect.construct(i, arguments, n);
                            } else e = i.apply(this, arguments);
                            return s(this, e);
                        });
                        function n() {
                            var e;
                            !function(e, t) {
                                if (!(e instanceof t)) throw new TypeError("Cannot call a class as a function");
                            }(this, n);
                            var t = (e = i.call(this)).getAttributeNames(), a = e.attachShadow({
                                mode: "closed"
                            }), o = h.createElement("input");
                            for (var s in o.type = "text", a.appendChild(o), t) Object.prototype.hasOwnProperty.call(t, s) && o.setAttribute(t[s], e.getAttribute(t[s]));
                            var l = new r.default;
                            return l.dataAttribute = "", l.mask(o), o.inputmask.shadowRoot = a, e;
                        }
                        return n;
                    }(l(HTMLElement));
                    n.default.customElements.define("input-mask", v);
                }
            },
            2391: function(e, t, a) {
                Object.defineProperty(t, "__esModule", {
                    value: !0
                }), t.generateMaskSet = function(e, t) {
                    var a;
                    function n(e, a, n) {
                        var r, o, s = !1;
                        if (null !== e && "" !== e || ((s = null !== n.regex) ? e = (e = n.regex).replace(/^(\^)(.*)(\$)$/, "$2") : (s = !0, 
                        e = ".*")), 1 === e.length && !1 === n.greedy && 0 !== n.repeat && (n.placeholder = ""), 
                        n.repeat > 0 || "*" === n.repeat || "+" === n.repeat) {
                            var l = "*" === n.repeat ? 0 : "+" === n.repeat ? 1 : n.repeat;
                            e = n.groupmarker[0] + e + n.groupmarker[1] + n.quantifiermarker[0] + l + "," + n.repeat + n.quantifiermarker[1];
                        }
                        return o = s ? "regex_" + n.regex : n.numericInput ? e.split("").reverse().join("") : e, 
                        !1 !== n.keepStatic && (o = "ks_" + o), void 0 === Inputmask.prototype.masksCache[o] || !0 === t ? (r = {
                            mask: e,
                            maskToken: Inputmask.prototype.analyseMask(e, s, n),
                            validPositions: {},
                            _buffer: void 0,
                            buffer: void 0,
                            tests: {},
                            excludes: {},
                            metadata: a,
                            maskLength: void 0,
                            jitOffset: {}
                        }, !0 !== t && (Inputmask.prototype.masksCache[o] = r, r = i.default.extend(!0, {}, Inputmask.prototype.masksCache[o]))) : r = i.default.extend(!0, {}, Inputmask.prototype.masksCache[o]), 
                        r;
                    }
                    "function" == typeof e.mask && (e.mask = e.mask(e));
                    if (Array.isArray(e.mask)) {
                        if (e.mask.length > 1) {
                            null === e.keepStatic && (e.keepStatic = !0);
                            var r = e.groupmarker[0];
                            return (e.isRTL ? e.mask.reverse() : e.mask).forEach((function(t) {
                                r.length > 1 && (r += e.groupmarker[1] + e.alternatormarker + e.groupmarker[0]), 
                                void 0 !== t.mask && "function" != typeof t.mask ? r += t.mask : r += t;
                            })), n(r += e.groupmarker[1], e.mask, e);
                        }
                        e.mask = e.mask.pop();
                    }
                    null === e.keepStatic && (e.keepStatic = !1);
                    a = e.mask && void 0 !== e.mask.mask && "function" != typeof e.mask.mask ? n(e.mask.mask, e.mask, e) : n(e.mask, e.mask, e);
                    return a;
                }, t.analyseMask = function(e, t, a) {
                    var i, r, o, s, l, u, c = /(?:[?*+]|\{[0-9+*]+(?:,[0-9+*]*)?(?:\|[0-9+*]*)?\})|[^.?*+^${[]()|\\]+|./g, f = /\[\^?]?(?:[^\\\]]+|\\[\S\s]?)*]?|\\(?:0(?:[0-3][0-7]{0,2}|[4-7][0-7]?)?|[1-9][0-9]*|x[0-9A-Fa-f]{2}|u[0-9A-Fa-f]{4}|c[A-Za-z]|[\S\s]?)|\((?:\?[:=!]?)?|(?:[?*+]|\{[0-9]+(?:,[0-9]*)?\})\??|[^.?*+^${[()|\\]+|./g, d = !1, p = new n.default, h = [], v = [], m = !1;
                    function g(e, i, n) {
                        n = void 0 !== n ? n : e.matches.length;
                        var r = e.matches[n - 1];
                        if (t) 0 === i.indexOf("[") || d && /\\d|\\s|\\w]/i.test(i) || "." === i ? e.matches.splice(n++, 0, {
                            fn: new RegExp(i, a.casing ? "i" : ""),
                            static: !1,
                            optionality: !1,
                            newBlockMarker: void 0 === r ? "master" : r.def !== i,
                            casing: null,
                            def: i,
                            placeholder: void 0,
                            nativeDef: i
                        }) : (d && (i = i[i.length - 1]), i.split("").forEach((function(t, i) {
                            r = e.matches[n - 1], e.matches.splice(n++, 0, {
                                fn: /[a-z]/i.test(a.staticDefinitionSymbol || t) ? new RegExp("[" + (a.staticDefinitionSymbol || t) + "]", a.casing ? "i" : "") : null,
                                static: !0,
                                optionality: !1,
                                newBlockMarker: void 0 === r ? "master" : r.def !== t && !0 !== r.static,
                                casing: null,
                                def: a.staticDefinitionSymbol || t,
                                placeholder: void 0 !== a.staticDefinitionSymbol ? t : void 0,
                                nativeDef: (d ? "'" : "") + t
                            });
                        }))), d = !1; else {
                            var o = a.definitions && a.definitions[i] || a.usePrototypeDefinitions && Inputmask.prototype.definitions[i];
                            o && !d ? e.matches.splice(n++, 0, {
                                fn: o.validator ? "string" == typeof o.validator ? new RegExp(o.validator, a.casing ? "i" : "") : new function() {
                                    this.test = o.validator;
                                } : new RegExp("."),
                                static: o.static || !1,
                                optionality: !1,
                                newBlockMarker: void 0 === r ? "master" : r.def !== (o.definitionSymbol || i),
                                casing: o.casing,
                                def: o.definitionSymbol || i,
                                placeholder: o.placeholder,
                                nativeDef: i,
                                generated: o.generated
                            }) : (e.matches.splice(n++, 0, {
                                fn: /[a-z]/i.test(a.staticDefinitionSymbol || i) ? new RegExp("[" + (a.staticDefinitionSymbol || i) + "]", a.casing ? "i" : "") : null,
                                static: !0,
                                optionality: !1,
                                newBlockMarker: void 0 === r ? "master" : r.def !== i && !0 !== r.static,
                                casing: null,
                                def: a.staticDefinitionSymbol || i,
                                placeholder: void 0 !== a.staticDefinitionSymbol ? i : void 0,
                                nativeDef: (d ? "'" : "") + i
                            }), d = !1);
                        }
                    }
                    function k() {
                        if (h.length > 0) {
                            if (g(s = h[h.length - 1], r), s.isAlternator) {
                                l = h.pop();
                                for (var e = 0; e < l.matches.length; e++) l.matches[e].isGroup && (l.matches[e].isGroup = !1);
                                h.length > 0 ? (s = h[h.length - 1]).matches.push(l) : p.matches.push(l);
                            }
                        } else g(p, r);
                    }
                    function y(e) {
                        var t = new n.default(!0);
                        return t.openGroup = !1, t.matches = e, t;
                    }
                    function b() {
                        if ((o = h.pop()).openGroup = !1, void 0 !== o) if (h.length > 0) {
                            if ((s = h[h.length - 1]).matches.push(o), s.isAlternator) {
                                l = h.pop();
                                for (var e = 0; e < l.matches.length; e++) l.matches[e].isGroup = !1, l.matches[e].alternatorGroup = !1;
                                h.length > 0 ? (s = h[h.length - 1]).matches.push(l) : p.matches.push(l);
                            }
                        } else p.matches.push(o); else k();
                    }
                    function x(e) {
                        var t = e.pop();
                        return t.isQuantifier && (t = y([ e.pop(), t ])), t;
                    }
                    t && (a.optionalmarker[0] = void 0, a.optionalmarker[1] = void 0);
                    for (;i = t ? f.exec(e) : c.exec(e); ) {
                        if (r = i[0], t) switch (r.charAt(0)) {
                          case "?":
                            r = "{0,1}";
                            break;

                          case "+":
                          case "*":
                            r = "{" + r + "}";
                            break;

                          case "|":
                            if (0 === h.length) {
                                var P = y(p.matches);
                                P.openGroup = !0, h.push(P), p.matches = [], m = !0;
                            }
                        }
                        if (d) k(); else switch (r.charAt(0)) {
                          case "$":
                          case "^":
                            t || k();
                            break;

                          case "(?=":
                          case "(?!":
                          case "(?<=":
                          case "(?<!":
                            h.push(new n.default(!0));
                            break;

                          case a.escapeChar:
                            d = !0, t && k();
                            break;

                          case a.optionalmarker[1]:
                          case a.groupmarker[1]:
                            b();
                            break;

                          case a.optionalmarker[0]:
                            h.push(new n.default(!1, !0));
                            break;

                          case a.groupmarker[0]:
                            h.push(new n.default(!0));
                            break;

                          case a.quantifiermarker[0]:
                            var E = new n.default(!1, !1, !0), S = (r = r.replace(/[{}]/g, "")).split("|"), _ = S[0].split(","), M = isNaN(_[0]) ? _[0] : parseInt(_[0]), w = 1 === _.length ? M : isNaN(_[1]) ? _[1] : parseInt(_[1]), O = isNaN(S[1]) ? S[1] : parseInt(S[1]);
                            "*" !== M && "+" !== M || (M = "*" === w ? 0 : 1), E.quantifier = {
                                min: M,
                                max: w,
                                jit: O
                            };
                            var T = h.length > 0 ? h[h.length - 1].matches : p.matches;
                            if ((i = T.pop()).isAlternator) {
                                T.push(i), T = i.matches;
                                var C = new n.default(!0), A = T.pop();
                                T.push(C), T = C.matches, i = A;
                            }
                            i.isGroup || (i = y([ i ])), T.push(i), T.push(E);
                            break;

                          case a.alternatormarker:
                            if (h.length > 0) {
                                var D = (s = h[h.length - 1]).matches[s.matches.length - 1];
                                u = s.openGroup && (void 0 === D.matches || !1 === D.isGroup && !1 === D.isAlternator) ? h.pop() : x(s.matches);
                            } else u = x(p.matches);
                            if (u.isAlternator) h.push(u); else if (u.alternatorGroup ? (l = h.pop(), u.alternatorGroup = !1) : l = new n.default(!1, !1, !1, !0), 
                            l.matches.push(u), h.push(l), u.openGroup) {
                                u.openGroup = !1;
                                var B = new n.default(!0);
                                B.alternatorGroup = !0, h.push(B);
                            }
                            break;

                          default:
                            k();
                        }
                    }
                    m && b();
                    for (;h.length > 0; ) o = h.pop(), p.matches.push(o);
                    p.matches.length > 0 && (!function e(i) {
                        i && i.matches && i.matches.forEach((function(n, r) {
                            var o = i.matches[r + 1];
                            (void 0 === o || void 0 === o.matches || !1 === o.isQuantifier) && n && n.isGroup && (n.isGroup = !1, 
                            t || (g(n, a.groupmarker[0], 0), !0 !== n.openGroup && g(n, a.groupmarker[1]))), 
                            e(n);
                        }));
                    }(p), v.push(p));
                    (a.numericInput || a.isRTL) && function e(t) {
                        for (var i in t.matches = t.matches.reverse(), t.matches) if (Object.prototype.hasOwnProperty.call(t.matches, i)) {
                            var n = parseInt(i);
                            if (t.matches[i].isQuantifier && t.matches[n + 1] && t.matches[n + 1].isGroup) {
                                var r = t.matches[i];
                                t.matches.splice(i, 1), t.matches.splice(n + 1, 0, r);
                            }
                            void 0 !== t.matches[i].matches ? t.matches[i] = e(t.matches[i]) : t.matches[i] = ((o = t.matches[i]) === a.optionalmarker[0] ? o = a.optionalmarker[1] : o === a.optionalmarker[1] ? o = a.optionalmarker[0] : o === a.groupmarker[0] ? o = a.groupmarker[1] : o === a.groupmarker[1] && (o = a.groupmarker[0]), 
                            o);
                        }
                        var o;
                        return t;
                    }(v[0]);
                    return v;
                };
                var i = r(a(4963)), n = r(a(9695));
                function r(e) {
                    return e && e.__esModule ? e : {
                        default: e
                    };
                }
            },
            157: function(e, t, a) {
                Object.defineProperty(t, "__esModule", {
                    value: !0
                }), t.mask = function() {
                    var e = this, t = this.opts, a = this.el, i = this.dependencyLib;
                    s.EventRuler.off(a);
                    var f = function(t, a) {
                        "textarea" !== t.tagName.toLowerCase() && a.ignorables.push(n.default.ENTER);
                        var l = t.getAttribute("type"), u = "input" === t.tagName.toLowerCase() && a.supportsInputType.includes(l) || t.isContentEditable || "textarea" === t.tagName.toLowerCase();
                        if (!u) if ("input" === t.tagName.toLowerCase()) {
                            var c = document.createElement("input");
                            c.setAttribute("type", l), u = "text" === c.type, c = null;
                        } else u = "partial";
                        return !1 !== u ? function(t) {
                            var n, l;
                            function u() {
                                return this.inputmask ? this.inputmask.opts.autoUnmask ? this.inputmask.unmaskedvalue() : -1 !== r.getLastValidPosition.call(e) || !0 !== a.nullable ? (this.inputmask.shadowRoot || this.ownerDocument).activeElement === this && a.clearMaskOnLostFocus ? (e.isRTL ? o.clearOptionalTail.call(e, r.getBuffer.call(e).slice()).reverse() : o.clearOptionalTail.call(e, r.getBuffer.call(e).slice())).join("") : n.call(this) : "" : n.call(this);
                            }
                            function c(e) {
                                l.call(this, e), this.inputmask && (0, o.applyInputValue)(this, e);
                            }
                            if (!t.inputmask.__valueGet) {
                                if (!0 !== a.noValuePatching) {
                                    if (Object.getOwnPropertyDescriptor) {
                                        var f = Object.getPrototypeOf ? Object.getOwnPropertyDescriptor(Object.getPrototypeOf(t), "value") : void 0;
                                        f && f.get && f.set ? (n = f.get, l = f.set, Object.defineProperty(t, "value", {
                                            get: u,
                                            set: c,
                                            configurable: !0
                                        })) : "input" !== t.tagName.toLowerCase() && (n = function() {
                                            return this.textContent;
                                        }, l = function(e) {
                                            this.textContent = e;
                                        }, Object.defineProperty(t, "value", {
                                            get: u,
                                            set: c,
                                            configurable: !0
                                        }));
                                    } else document.__lookupGetter__ && t.__lookupGetter__("value") && (n = t.__lookupGetter__("value"), 
                                    l = t.__lookupSetter__("value"), t.__defineGetter__("value", u), t.__defineSetter__("value", c));
                                    t.inputmask.__valueGet = n, t.inputmask.__valueSet = l;
                                }
                                t.inputmask._valueGet = function(t) {
                                    return e.isRTL && !0 !== t ? n.call(this.el).split("").reverse().join("") : n.call(this.el);
                                }, t.inputmask._valueSet = function(t, a) {
                                    l.call(this.el, null == t ? "" : !0 !== a && e.isRTL ? t.split("").reverse().join("") : t);
                                }, void 0 === n && (n = function() {
                                    return this.value;
                                }, l = function(e) {
                                    this.value = e;
                                }, function(t) {
                                    if (i.valHooks && (void 0 === i.valHooks[t] || !0 !== i.valHooks[t].inputmaskpatch)) {
                                        var n = i.valHooks[t] && i.valHooks[t].get ? i.valHooks[t].get : function(e) {
                                            return e.value;
                                        }, s = i.valHooks[t] && i.valHooks[t].set ? i.valHooks[t].set : function(e, t) {
                                            return e.value = t, e;
                                        };
                                        i.valHooks[t] = {
                                            get: function(t) {
                                                if (t.inputmask) {
                                                    if (t.inputmask.opts.autoUnmask) return t.inputmask.unmaskedvalue();
                                                    var i = n(t);
                                                    return -1 !== r.getLastValidPosition.call(e, void 0, void 0, t.inputmask.maskset.validPositions) || !0 !== a.nullable ? i : "";
                                                }
                                                return n(t);
                                            },
                                            set: function(e, t) {
                                                var a = s(e, t);
                                                return e.inputmask && (0, o.applyInputValue)(e, t), a;
                                            },
                                            inputmaskpatch: !0
                                        };
                                    }
                                }(t.type), function(t) {
                                    s.EventRuler.on(t, "mouseenter", (function() {
                                        var t = this.inputmask._valueGet(!0);
                                        t !== (e.isRTL ? r.getBuffer.call(e).reverse() : r.getBuffer.call(e)).join("") && (0, o.applyInputValue)(this, t);
                                    }));
                                }(t));
                            }
                        }(t) : t.inputmask = void 0, u;
                    }(a, t);
                    if (!1 !== f) {
                        e.originalPlaceholder = a.placeholder, e.maxLength = void 0 !== a ? a.maxLength : void 0, 
                        -1 === e.maxLength && (e.maxLength = void 0), "inputMode" in a && null === a.getAttribute("inputmode") && (a.inputMode = t.inputmode, 
                        a.setAttribute("inputmode", t.inputmode)), !0 === f && (t.showMaskOnFocus = t.showMaskOnFocus && -1 === [ "cc-number", "cc-exp" ].indexOf(a.autocomplete), 
                        l.iphone && (t.insertModeVisual = !1), s.EventRuler.on(a, "submit", c.EventHandlers.submitEvent), 
                        s.EventRuler.on(a, "reset", c.EventHandlers.resetEvent), s.EventRuler.on(a, "blur", c.EventHandlers.blurEvent), 
                        s.EventRuler.on(a, "focus", c.EventHandlers.focusEvent), s.EventRuler.on(a, "invalid", c.EventHandlers.invalidEvent), 
                        s.EventRuler.on(a, "click", c.EventHandlers.clickEvent), s.EventRuler.on(a, "mouseleave", c.EventHandlers.mouseleaveEvent), 
                        s.EventRuler.on(a, "mouseenter", c.EventHandlers.mouseenterEvent), s.EventRuler.on(a, "paste", c.EventHandlers.pasteEvent), 
                        s.EventRuler.on(a, "cut", c.EventHandlers.cutEvent), s.EventRuler.on(a, "complete", t.oncomplete), 
                        s.EventRuler.on(a, "incomplete", t.onincomplete), s.EventRuler.on(a, "cleared", t.oncleared), 
                        !0 !== t.inputEventOnly && (s.EventRuler.on(a, "keydown", c.EventHandlers.keydownEvent), 
                        s.EventRuler.on(a, "keypress", c.EventHandlers.keypressEvent), s.EventRuler.on(a, "keyup", c.EventHandlers.keyupEvent)), 
                        (l.mobile || t.inputEventOnly) && a.removeAttribute("maxLength"), s.EventRuler.on(a, "input", c.EventHandlers.inputFallBackEvent), 
                        s.EventRuler.on(a, "compositionend", c.EventHandlers.compositionendEvent)), s.EventRuler.on(a, "setvalue", c.EventHandlers.setValueEvent), 
                        r.getBufferTemplate.call(e).join(""), e.undoValue = e._valueGet(!0);
                        var d = (a.inputmask.shadowRoot || a.ownerDocument).activeElement;
                        if ("" !== a.inputmask._valueGet(!0) || !1 === t.clearMaskOnLostFocus || d === a) {
                            (0, o.applyInputValue)(a, a.inputmask._valueGet(!0), t);
                            var p = r.getBuffer.call(e).slice();
                            !1 === u.isComplete.call(e, p) && t.clearIncomplete && r.resetMaskSet.call(e), t.clearMaskOnLostFocus && d !== a && (-1 === r.getLastValidPosition.call(e) ? p = [] : o.clearOptionalTail.call(e, p)), 
                            (!1 === t.clearMaskOnLostFocus || t.showMaskOnFocus && d === a || "" !== a.inputmask._valueGet(!0)) && (0, o.writeBuffer)(a, p), d === a && r.caret.call(e, a, r.seekNext.call(e, r.getLastValidPosition.call(e)));
                        }
                    }
                };
                var i, n = (i = a(4528)) && i.__esModule ? i : {
                    default: i
                }, r = a(8711), o = a(7760), s = a(9716), l = a(9845), u = a(7215), c = a(6030);
            },
            9695: function(e, t) {
                Object.defineProperty(t, "__esModule", {
                    value: !0
                }), t.default = function(e, t, a, i) {
                    this.matches = [], this.openGroup = e || !1, this.alternatorGroup = !1, this.isGroup = e || !1, 
                    this.isOptional = t || !1, this.isQuantifier = a || !1, this.isAlternator = i || !1, 
                    this.quantifier = {
                        min: 1,
                        max: 1
                    };
                };
            },
            3194: function() {
                Array.prototype.includes || Object.defineProperty(Array.prototype, "includes", {
                    value: function(e, t) {
                        if (null == this) throw new TypeError('"this" is null or not defined');
                        var a = Object(this), i = a.length >>> 0;
                        if (0 === i) return !1;
                        for (var n = 0 | t, r = Math.max(n >= 0 ? n : i - Math.abs(n), 0); r < i; ) {
                            if (a[r] === e) return !0;
                            r++;
                        }
                        return !1;
                    }
                });
            },
            7149: function() {
                function e(t) {
                    return (e = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function(e) {
                        return typeof e;
                    } : function(e) {
                        return e && "function" == typeof Symbol && e.constructor === Symbol && e !== Symbol.prototype ? "symbol" : typeof e;
                    })(t);
                }
                "function" != typeof Object.getPrototypeOf && (Object.getPrototypeOf = "object" === e("test".__proto__) ? function(e) {
                    return e.__proto__;
                } : function(e) {
                    return e.constructor.prototype;
                });
            },
            8711: function(e, t, a) {
                Object.defineProperty(t, "__esModule", {
                    value: !0
                }), t.caret = function(e, t, a, i, n) {
                    var r, o = this, s = this.opts;
                    if (void 0 === t) return "selectionStart" in e && "selectionEnd" in e ? (t = e.selectionStart, 
                    a = e.selectionEnd) : window.getSelection ? (r = window.getSelection().getRangeAt(0)).commonAncestorContainer.parentNode !== e && r.commonAncestorContainer !== e || (t = r.startOffset, 
                    a = r.endOffset) : document.selection && document.selection.createRange && (r = document.selection.createRange(), 
                    t = 0 - r.duplicate().moveStart("character", -e.inputmask._valueGet().length), a = t + r.text.length), 
                    {
                        begin: i ? t : u.call(o, t),
                        end: i ? a : u.call(o, a)
                    };
                    if (Array.isArray(t) && (a = o.isRTL ? t[0] : t[1], t = o.isRTL ? t[1] : t[0]), 
                    void 0 !== t.begin && (a = o.isRTL ? t.begin : t.end, t = o.isRTL ? t.end : t.begin), 
                    "number" == typeof t) {
                        t = i ? t : u.call(o, t), a = "number" == typeof (a = i ? a : u.call(o, a)) ? a : t;
                        var l = parseInt(((e.ownerDocument.defaultView || window).getComputedStyle ? (e.ownerDocument.defaultView || window).getComputedStyle(e, null) : e.currentStyle).fontSize) * a;
                        if (e.scrollLeft = l > e.scrollWidth ? l : 0, e.inputmask.caretPos = {
                            begin: t,
                            end: a
                        }, s.insertModeVisual && !1 === s.insertMode && t === a && (n || a++), e === (e.inputmask.shadowRoot || e.ownerDocument).activeElement) if ("setSelectionRange" in e) e.setSelectionRange(t, a); else if (window.getSelection) {
                            if (r = document.createRange(), void 0 === e.firstChild || null === e.firstChild) {
                                var c = document.createTextNode("");
                                e.appendChild(c);
                            }
                            r.setStart(e.firstChild, t < e.inputmask._valueGet().length ? t : e.inputmask._valueGet().length), 
                            r.setEnd(e.firstChild, a < e.inputmask._valueGet().length ? a : e.inputmask._valueGet().length), 
                            r.collapse(!0);
                            var f = window.getSelection();
                            f.removeAllRanges(), f.addRange(r);
                        } else e.createTextRange && ((r = e.createTextRange()).collapse(!0), r.moveEnd("character", a), 
                        r.moveStart("character", t), r.select());
                    }
                }, t.determineLastRequiredPosition = function(e) {
                    var t, a, r = this, s = this.maskset, l = this.dependencyLib, u = i.getMaskTemplate.call(r, !0, o.call(r), !0, !0), c = u.length, f = o.call(r), d = {}, p = s.validPositions[f], h = void 0 !== p ? p.locator.slice() : void 0;
                    for (t = f + 1; t < u.length; t++) a = i.getTestTemplate.call(r, t, h, t - 1), h = a.locator.slice(), 
                    d[t] = l.extend(!0, {}, a);
                    var v = p && void 0 !== p.alternation ? p.locator[p.alternation] : void 0;
                    for (t = c - 1; t > f && (((a = d[t]).match.optionality || a.match.optionalQuantifier && a.match.newBlockMarker || v && (v !== d[t].locator[p.alternation] && 1 != a.match.static || !0 === a.match.static && a.locator[p.alternation] && n.checkAlternationMatch.call(r, a.locator[p.alternation].toString().split(","), v.toString().split(",")) && "" !== i.getTests.call(r, t)[0].def)) && u[t] === i.getPlaceholder.call(r, t, a.match)); t--) c--;
                    return e ? {
                        l: c,
                        def: d[c] ? d[c].match : void 0
                    } : c;
                }, t.determineNewCaretPosition = function(e, t, a) {
                    var n = this, u = this.maskset, c = this.opts;
                    t && (n.isRTL ? e.end = e.begin : e.begin = e.end);
                    if (e.begin === e.end) {
                        switch (a = a || c.positionCaretOnClick) {
                          case "none":
                            break;

                          case "select":
                            e = {
                                begin: 0,
                                end: r.call(n).length
                            };
                            break;

                          case "ignore":
                            e.end = e.begin = l.call(n, o.call(n));
                            break;

                          case "radixFocus":
                            if (function(e) {
                                if ("" !== c.radixPoint && 0 !== c.digits) {
                                    var t = u.validPositions;
                                    if (void 0 === t[e] || t[e].input === i.getPlaceholder.call(n, e)) {
                                        if (e < l.call(n, -1)) return !0;
                                        var a = r.call(n).indexOf(c.radixPoint);
                                        if (-1 !== a) {
                                            for (var o in t) if (t[o] && a < o && t[o].input !== i.getPlaceholder.call(n, o)) return !1;
                                            return !0;
                                        }
                                    }
                                }
                                return !1;
                            }(e.begin)) {
                                var f = r.call(n).join("").indexOf(c.radixPoint);
                                e.end = e.begin = c.numericInput ? l.call(n, f) : f;
                                break;
                            }

                          default:
                            var d = e.begin, p = o.call(n, d, !0), h = l.call(n, -1 !== p || s.call(n, 0) ? p : -1);
                            if (d <= h) e.end = e.begin = s.call(n, d, !1, !0) ? d : l.call(n, d); else {
                                var v = u.validPositions[p], m = i.getTestTemplate.call(n, h, v ? v.match.locator : void 0, v), g = i.getPlaceholder.call(n, h, m.match);
                                if ("" !== g && r.call(n)[h] !== g && !0 !== m.match.optionalQuantifier && !0 !== m.match.newBlockMarker || !s.call(n, h, c.keepStatic, !0) && m.match.def === g) {
                                    var k = l.call(n, h);
                                    (d >= k || d === h) && (h = k);
                                }
                                e.end = e.begin = h;
                            }
                        }
                        return e;
                    }
                }, t.getBuffer = r, t.getBufferTemplate = function() {
                    var e = this.maskset;
                    void 0 === e._buffer && (e._buffer = i.getMaskTemplate.call(this, !1, 1), void 0 === e.buffer && (e.buffer = e._buffer.slice()));
                    return e._buffer;
                }, t.getLastValidPosition = o, t.isMask = s, t.resetMaskSet = function(e) {
                    var t = this.maskset;
                    t.buffer = void 0, !0 !== e && (t.validPositions = {}, t.p = 0);
                }, t.seekNext = l, t.seekPrevious = function(e, t) {
                    var a = this, n = e - 1;
                    if (e <= 0) return 0;
                    for (;n > 0 && (!0 === t && (!0 !== i.getTest.call(a, n).match.newBlockMarker || !s.call(a, n, void 0, !0)) || !0 !== t && !s.call(a, n, void 0, !0)); ) n--;
                    return n;
                }, t.translatePosition = u;
                var i = a(4713), n = a(7215);
                function r(e) {
                    var t = this.maskset;
                    return void 0 !== t.buffer && !0 !== e || (t.buffer = i.getMaskTemplate.call(this, !0, o.call(this), !0), 
                    void 0 === t._buffer && (t._buffer = t.buffer.slice())), t.buffer;
                }
                function o(e, t, a) {
                    var i = this.maskset, n = -1, r = -1, o = a || i.validPositions;
                    for (var s in void 0 === e && (e = -1), o) {
                        var l = parseInt(s);
                        o[l] && (t || !0 !== o[l].generatedInput) && (l <= e && (n = l), l >= e && (r = l));
                    }
                    return -1 === n || n == e ? r : -1 == r || e - n < r - e ? n : r;
                }
                function s(e, t, a) {
                    var n = this, r = this.maskset, o = i.getTestTemplate.call(n, e).match;
                    if ("" === o.def && (o = i.getTest.call(n, e).match), !0 !== o.static) return o.fn;
                    if (!0 === a && void 0 !== r.validPositions[e] && !0 !== r.validPositions[e].generatedInput) return !0;
                    if (!0 !== t && e > -1) {
                        if (a) {
                            var s = i.getTests.call(n, e);
                            return s.length > 1 + ("" === s[s.length - 1].match.def ? 1 : 0);
                        }
                        var l = i.determineTestTemplate.call(n, e, i.getTests.call(n, e)), u = i.getPlaceholder.call(n, e, l.match);
                        return l.match.def !== u;
                    }
                    return !1;
                }
                function l(e, t, a) {
                    var n = this;
                    void 0 === a && (a = !0);
                    for (var r = e + 1; "" !== i.getTest.call(n, r).match.def && (!0 === t && (!0 !== i.getTest.call(n, r).match.newBlockMarker || !s.call(n, r, void 0, !0)) || !0 !== t && !s.call(n, r, void 0, a)); ) r++;
                    return r;
                }
                function u(e) {
                    var t = this.opts, a = this.el;
                    return !this.isRTL || "number" != typeof e || t.greedy && "" === t.placeholder || !a || (e = Math.abs(this._valueGet().length - e)), 
                    e;
                }
            },
            4713: function(e, t) {
                function a(e, t) {
                    var a = (null != e.alternation ? e.mloc[i(e)] : e.locator).join("");
                    if ("" !== a) for (;a.length < t; ) a += "0";
                    return a;
                }
                function i(e) {
                    var t = e.locator[e.alternation];
                    return "string" == typeof t && t.length > 0 && (t = t.split(",")[0]), void 0 !== t ? t.toString() : "";
                }
                function n(e, t, a) {
                    var i = this.opts, n = this.maskset;
                    if (void 0 !== (t = t || s.call(this, e).match).placeholder || !0 === a) return "function" == typeof t.placeholder ? t.placeholder(i) : t.placeholder;
                    if (!0 === t.static) {
                        if (e > -1 && void 0 === n.validPositions[e]) {
                            var r, o = u.call(this, e), l = [];
                            if (o.length > 1 + ("" === o[o.length - 1].match.def ? 1 : 0)) for (var c = 0; c < o.length; c++) if ("" !== o[c].match.def && !0 !== o[c].match.optionality && !0 !== o[c].match.optionalQuantifier && (!0 === o[c].match.static || void 0 === r || !1 !== o[c].match.fn.test(r.match.def, n, e, !0, i)) && (l.push(o[c]), 
                            !0 === o[c].match.static && (r = o[c]), l.length > 1 && /[0-9a-bA-Z]/.test(l[0].match.def))) return i.placeholder.charAt(e % i.placeholder.length);
                        }
                        return t.def;
                    }
                    return i.placeholder.charAt(e % i.placeholder.length);
                }
                function r(e, t, a) {
                    return this.maskset.validPositions[e] || o.call(this, e, u.call(this, e, t ? t.slice() : t, a));
                }
                function o(e, t) {
                    var i = this.opts;
                    e = e > 0 ? e - 1 : 0;
                    for (var n, r, o, l = a(s.call(this, e)), u = 0; u < t.length; u++) {
                        var c = t[u];
                        n = a(c, l.length);
                        var f = Math.abs(n - l);
                        (void 0 === r || "" !== n && f < r || o && !i.greedy && o.match.optionality && "master" === o.match.newBlockMarker && (!c.match.optionality || !c.match.newBlockMarker) || o && o.match.optionalQuantifier && !c.match.optionalQuantifier) && (r = f, 
                        o = c);
                    }
                    return o;
                }
                function s(e, t) {
                    var a = this.maskset;
                    return a.validPositions[e] ? a.validPositions[e] : (t || u.call(this, e))[0];
                }
                function l(e, t, a) {
                    function i(e) {
                        for (var t, a = [], i = -1, n = 0, r = e.length; n < r; n++) if ("-" === e.charAt(n)) for (t = e.charCodeAt(n + 1); ++i < t; ) a.push(String.fromCharCode(i)); else i = e.charCodeAt(n), 
                        a.push(e.charAt(n));
                        return a.join("");
                    }
                    return e.match.def === t.match.nativeDef || !(!(a.regex || e.match.fn instanceof RegExp && t.match.fn instanceof RegExp) || !0 === e.match.static || !0 === t.match.static) && -1 !== i(t.match.fn.toString().replace(/[[\]/]/g, "")).indexOf(i(e.match.fn.toString().replace(/[[\]/]/g, "")));
                }
                function u(e, t, a) {
                    var i, n = this, r = this.dependencyLib, s = this.maskset, u = this.opts, c = this.el, f = s.maskToken, d = t ? a : 0, p = t ? t.slice() : [ 0 ], h = [], v = !1, m = t ? t.join("") : "";
                    function g(t, a, n, r) {
                        function o(n, r, f) {
                            function p(e, t) {
                                var a = 0 === t.matches.indexOf(e);
                                return a || t.matches.every((function(i, n) {
                                    return !0 === i.isQuantifier ? a = p(e, t.matches[n - 1]) : Object.prototype.hasOwnProperty.call(i, "matches") && (a = p(e, i)), 
                                    !a;
                                })), a;
                            }
                            function k(e, t, a) {
                                var i, n;
                                if ((s.tests[e] || s.validPositions[e]) && (s.tests[e] || [ s.validPositions[e] ]).every((function(e, r) {
                                    if (e.mloc[t]) return i = e, !1;
                                    var o = void 0 !== a ? a : e.alternation, s = void 0 !== e.locator[o] ? e.locator[o].toString().indexOf(t) : -1;
                                    return (void 0 === n || s < n) && -1 !== s && (i = e, n = s), !0;
                                })), i) {
                                    var r = i.locator[i.alternation];
                                    return (i.mloc[t] || i.mloc[r] || i.locator).slice((void 0 !== a ? a : i.alternation) + 1);
                                }
                                return void 0 !== a ? k(e, t) : void 0;
                            }
                            function y(e, t) {
                                var a = e.alternation, i = void 0 === t || a === t.alternation && -1 === e.locator[a].toString().indexOf(t.locator[a]);
                                if (!i && a > t.alternation) for (var n = t.alternation; n < a; n++) if (e.locator[n] !== t.locator[n]) {
                                    a = n, i = !0;
                                    break;
                                }
                                if (i) {
                                    e.mloc = e.mloc || {};
                                    var r = e.locator[a];
                                    if (void 0 !== r) {
                                        if ("string" == typeof r && (r = r.split(",")[0]), void 0 === e.mloc[r] && (e.mloc[r] = e.locator.slice()), 
                                        void 0 !== t) {
                                            for (var o in t.mloc) "string" == typeof o && (o = o.split(",")[0]), void 0 === e.mloc[o] && (e.mloc[o] = t.mloc[o]);
                                            e.locator[a] = Object.keys(e.mloc).join(",");
                                        }
                                        return !0;
                                    }
                                    e.alternation = void 0;
                                }
                                return !1;
                            }
                            function b(e, t) {
                                if (e.locator.length !== t.locator.length) return !1;
                                for (var a = e.alternation + 1; a < e.locator.length; a++) if (e.locator[a] !== t.locator[a]) return !1;
                                return !0;
                            }
                            if (d > e + u._maxTestPos) throw "Inputmask: There is probably an error in your mask definition or in the code. Create an issue on github with an example of the mask you are using. " + s.mask;
                            if (d === e && void 0 === n.matches) return h.push({
                                match: n,
                                locator: r.reverse(),
                                cd: m,
                                mloc: {}
                            }), !0;
                            if (void 0 !== n.matches) {
                                if (n.isGroup && f !== n) {
                                    if (n = o(t.matches[t.matches.indexOf(n) + 1], r, f)) return !0;
                                } else if (n.isOptional) {
                                    var x = n, P = h.length;
                                    if (n = g(n, a, r, f)) {
                                        if (h.forEach((function(e, t) {
                                            t >= P && (e.match.optionality = !0);
                                        })), i = h[h.length - 1].match, void 0 !== f || !p(i, x)) return !0;
                                        v = !0, d = e;
                                    }
                                } else if (n.isAlternator) {
                                    var E, S = n, _ = [], M = h.slice(), w = r.length, O = !1, T = a.length > 0 ? a.shift() : -1;
                                    if (-1 === T || "string" == typeof T) {
                                        var C, A = d, D = a.slice(), B = [];
                                        if ("string" == typeof T) B = T.split(","); else for (C = 0; C < S.matches.length; C++) B.push(C.toString());
                                        if (void 0 !== s.excludes[e]) {
                                            for (var j = B.slice(), R = 0, L = s.excludes[e].length; R < L; R++) {
                                                var I = s.excludes[e][R].toString().split(":");
                                                r.length == I[1] && B.splice(B.indexOf(I[0]), 1);
                                            }
                                            0 === B.length && (delete s.excludes[e], B = j);
                                        }
                                        (!0 === u.keepStatic || isFinite(parseInt(u.keepStatic)) && A >= u.keepStatic) && (B = B.slice(0, 1));
                                        for (var F = 0; F < B.length; F++) {
                                            C = parseInt(B[F]), h = [], a = "string" == typeof T && k(d, C, w) || D.slice();
                                            var N = S.matches[C];
                                            if (N && o(N, [ C ].concat(r), f)) n = !0; else if (0 === F && (O = !0), N && N.matches && N.matches.length > S.matches[0].matches.length) break;
                                            E = h.slice(), d = A, h = [];
                                            for (var V = 0; V < E.length; V++) {
                                                var G = E[V], H = !1;
                                                G.match.jit = G.match.jit || O, G.alternation = G.alternation || w, y(G);
                                                for (var K = 0; K < _.length; K++) {
                                                    var U = _[K];
                                                    if ("string" != typeof T || void 0 !== G.alternation && B.includes(G.locator[G.alternation].toString())) {
                                                        if (G.match.nativeDef === U.match.nativeDef) {
                                                            H = !0, y(U, G);
                                                            break;
                                                        }
                                                        if (l(G, U, u)) {
                                                            y(G, U) && (H = !0, _.splice(_.indexOf(U), 0, G));
                                                            break;
                                                        }
                                                        if (l(U, G, u)) {
                                                            y(U, G);
                                                            break;
                                                        }
                                                        if (Q = U, !0 === (W = G).match.static && !0 !== Q.match.static && Q.match.fn.test(W.match.def, s, e, !1, u, !1)) {
                                                            b(G, U) || void 0 !== c.inputmask.userOptions.keepStatic ? y(G, U) && (H = !0, _.splice(_.indexOf(U), 0, G)) : u.keepStatic = !0;
                                                            break;
                                                        }
                                                    }
                                                }
                                                H || _.push(G);
                                            }
                                        }
                                        h = M.concat(_), d = e, v = h.length > 0, n = _.length > 0, a = D.slice();
                                    } else n = o(S.matches[T] || t.matches[T], [ T ].concat(r), f);
                                    if (n) return !0;
                                } else if (n.isQuantifier && f !== t.matches[t.matches.indexOf(n) - 1]) for (var $ = n, z = a.length > 0 ? a.shift() : 0; z < (isNaN($.quantifier.max) ? z + 1 : $.quantifier.max) && d <= e; z++) {
                                    var q = t.matches[t.matches.indexOf($) - 1];
                                    if (n = o(q, [ z ].concat(r), q)) {
                                        if ((i = h[h.length - 1].match).optionalQuantifier = z >= $.quantifier.min, i.jit = (z + 1) * (q.matches.indexOf(i) + 1) > $.quantifier.jit, 
                                        i.optionalQuantifier && p(i, q)) {
                                            v = !0, d = e;
                                            break;
                                        }
                                        return i.jit && (s.jitOffset[e] = q.matches.length - q.matches.indexOf(i)), !0;
                                    }
                                } else if (n = g(n, a, r, f)) return !0;
                            } else d++;
                            var W, Q;
                        }
                        for (var f = a.length > 0 ? a.shift() : 0; f < t.matches.length; f++) if (!0 !== t.matches[f].isQuantifier) {
                            var p = o(t.matches[f], [ f ].concat(n), r);
                            if (p && d === e) return p;
                            if (d > e) break;
                        }
                    }
                    if (e > -1) {
                        if (void 0 === t) {
                            for (var k, y = e - 1; void 0 === (k = s.validPositions[y] || s.tests[y]) && y > -1; ) y--;
                            void 0 !== k && y > -1 && (p = function(e, t) {
                                var a, i = [];
                                return Array.isArray(t) || (t = [ t ]), t.length > 0 && (void 0 === t[0].alternation || !0 === u.keepStatic ? 0 === (i = o.call(n, e, t.slice()).locator.slice()).length && (i = t[0].locator.slice()) : t.forEach((function(e) {
                                    "" !== e.def && (0 === i.length ? (a = e.alternation, i = e.locator.slice()) : e.locator[a] && -1 === i[a].toString().indexOf(e.locator[a]) && (i[a] += "," + e.locator[a]));
                                }))), i;
                            }(y, k), m = p.join(""), d = y);
                        }
                        if (s.tests[e] && s.tests[e][0].cd === m) return s.tests[e];
                        for (var b = p.shift(); b < f.length; b++) {
                            if (g(f[b], p, [ b ]) && d === e || d > e) break;
                        }
                    }
                    return (0 === h.length || v) && h.push({
                        match: {
                            fn: null,
                            static: !0,
                            optionality: !1,
                            casing: null,
                            def: "",
                            placeholder: ""
                        },
                        locator: [],
                        mloc: {},
                        cd: m
                    }), void 0 !== t && s.tests[e] ? r.extend(!0, [], h) : (s.tests[e] = r.extend(!0, [], h), 
                    s.tests[e]);
                }
                Object.defineProperty(t, "__esModule", {
                    value: !0
                }), t.determineTestTemplate = o, t.getDecisionTaker = i, t.getMaskTemplate = function(e, t, a, i, s) {
                    var l = this, c = this.opts, f = this.maskset, d = c.greedy;
                    s && (c.greedy = !1);
                    t = t || 0;
                    var p, h, v, m, g = [], k = 0;
                    do {
                        if (!0 === e && f.validPositions[k]) v = s && !0 === f.validPositions[k].match.optionality && void 0 === f.validPositions[k + 1] && (!0 === f.validPositions[k].generatedInput || f.validPositions[k].input == c.skipOptionalPartCharacter && k > 0) ? o.call(l, k, u.call(l, k, p, k - 1)) : f.validPositions[k], 
                        h = v.match, p = v.locator.slice(), g.push(!0 === a ? v.input : !1 === a ? h.nativeDef : n.call(l, k, h)); else {
                            v = r.call(l, k, p, k - 1), h = v.match, p = v.locator.slice();
                            var y = !0 !== i && (!1 !== c.jitMasking ? c.jitMasking : h.jit);
                            (m = (m && h.static && h.def !== c.groupSeparator && null === h.fn || f.validPositions[k - 1] && h.static && h.def !== c.groupSeparator && null === h.fn) && f.tests[k] && 1 === f.tests[k].length) || !1 === y || void 0 === y || "number" == typeof y && isFinite(y) && y > k ? g.push(!1 === a ? h.nativeDef : n.call(l, k, h)) : m = !1;
                        }
                        k++;
                    } while (!0 !== h.static || "" !== h.def || t > k);
                    "" === g[g.length - 1] && g.pop();
                    !1 === a && void 0 !== f.maskLength || (f.maskLength = k - 1);
                    return c.greedy = d, g;
                }, t.getPlaceholder = n, t.getTest = s, t.getTests = u, t.getTestTemplate = r, t.isSubsetOf = l;
            },
            7215: function(e, t, a) {
                Object.defineProperty(t, "__esModule", {
                    value: !0
                }), t.alternate = l, t.checkAlternationMatch = function(e, t, a) {
                    for (var i, n = this.opts.greedy ? t : t.slice(0, 1), r = !1, o = void 0 !== a ? a.split(",") : [], s = 0; s < o.length; s++) -1 !== (i = e.indexOf(o[s])) && e.splice(i, 1);
                    for (var l = 0; l < e.length; l++) if (n.includes(e[l])) {
                        r = !0;
                        break;
                    }
                    return r;
                }, t.isComplete = c, t.isValid = f, t.refreshFromBuffer = p, t.revalidateMask = v, 
                t.handleRemove = function(e, t, a, i, s) {
                    var u = this, c = this.maskset, f = this.opts;
                    if ((f.numericInput || u.isRTL) && (t === r.default.BACKSPACE ? t = r.default.DELETE : t === r.default.DELETE && (t = r.default.BACKSPACE), 
                    u.isRTL)) {
                        var d = a.end;
                        a.end = a.begin, a.begin = d;
                    }
                    var p, h = o.getLastValidPosition.call(u, void 0, !0);
                    a.end >= o.getBuffer.call(u).length && h >= a.end && (a.end = h + 1);
                    t === r.default.BACKSPACE ? a.end - a.begin < 1 && (a.begin = o.seekPrevious.call(u, a.begin)) : t === r.default.DELETE && a.begin === a.end && (a.end = o.isMask.call(u, a.end, !0, !0) ? a.end + 1 : o.seekNext.call(u, a.end) + 1);
                    if (!1 !== (p = v.call(u, a))) {
                        if (!0 !== i && !1 !== f.keepStatic || null !== f.regex && -1 !== n.getTest.call(u, a.begin).match.def.indexOf("|")) {
                            var m = l.call(u, !0);
                            if (m) {
                                void 0 !== m.caret ? m.caret : m.pos ? o.seekNext.call(u, m.pos.begin ? m.pos.begin : m.pos) : o.getLastValidPosition.call(u, -1, !0);
                            }
                        }
                        !0 !== i && (c.p = t === r.default.DELETE ? a.begin + p : a.begin, c.p = o.determineNewCaretPosition.call(u, {
                            begin: c.p,
                            end: c.p
                        }, !1).begin);
                    }
                };
                var i, n = a(4713), r = (i = a(4528)) && i.__esModule ? i : {
                    default: i
                }, o = a(8711), s = a(6030);
                function l(e, t, a, i, r, s) {
                    var u, c, d, p, h, v, m, g, k, y, b, x = this, P = this.dependencyLib, E = this.opts, S = x.maskset, _ = P.extend(!0, {}, S.validPositions), M = P.extend(!0, {}, S.tests), w = !1, O = !1, T = void 0 !== r ? r : o.getLastValidPosition.call(x);
                    if (s && (y = s.begin, b = s.end, s.begin > s.end && (y = s.end, b = s.begin)), 
                    -1 === T && void 0 === r) u = 0, c = (p = n.getTest.call(x, u)).alternation; else for (;T >= 0; T--) if ((d = S.validPositions[T]) && void 0 !== d.alternation) {
                        if (p && p.locator[d.alternation] !== d.locator[d.alternation]) break;
                        u = T, c = S.validPositions[u].alternation, p = d;
                    }
                    if (void 0 !== c) {
                        m = parseInt(u), S.excludes[m] = S.excludes[m] || [], !0 !== e && S.excludes[m].push((0, n.getDecisionTaker)(p) + ":" + p.alternation);
                        var C = [], A = -1;
                        for (h = m; h < o.getLastValidPosition.call(x, void 0, !0) + 1; h++) -1 === A && e <= h && void 0 !== t && (C.push(t), 
                        A = C.length - 1), (v = S.validPositions[h]) && !0 !== v.generatedInput && (void 0 === s || h < y || h >= b) && C.push(v.input), 
                        delete S.validPositions[h];
                        for (-1 === A && void 0 !== t && (C.push(t), A = C.length - 1); void 0 !== S.excludes[m] && S.excludes[m].length < 10; ) {
                            for (S.tests = {}, o.resetMaskSet.call(x, !0), w = !0, h = 0; h < C.length && (g = w.caret || o.getLastValidPosition.call(x, void 0, !0) + 1, 
                            k = C[h], w = f.call(x, g, k, !1, i, !0)); h++) h === A && (O = w), 1 == e && w && (O = {
                                caretPos: h
                            });
                            if (w) break;
                            if (o.resetMaskSet.call(x), p = n.getTest.call(x, m), S.validPositions = P.extend(!0, {}, _), 
                            S.tests = P.extend(!0, {}, M), !S.excludes[m]) {
                                O = l.call(x, e, t, a, i, m - 1, s);
                                break;
                            }
                            var D = (0, n.getDecisionTaker)(p);
                            if (-1 !== S.excludes[m].indexOf(D + ":" + p.alternation)) {
                                O = l.call(x, e, t, a, i, m - 1, s);
                                break;
                            }
                            for (S.excludes[m].push(D + ":" + p.alternation), h = m; h < o.getLastValidPosition.call(x, void 0, !0) + 1; h++) delete S.validPositions[h];
                        }
                    }
                    return O && !1 === E.keepStatic || delete S.excludes[m], O;
                }
                function u(e, t, a) {
                    var i = this.opts, n = this.maskset;
                    switch (i.casing || t.casing) {
                      case "upper":
                        e = e.toUpperCase();
                        break;

                      case "lower":
                        e = e.toLowerCase();
                        break;

                      case "title":
                        var o = n.validPositions[a - 1];
                        e = 0 === a || o && o.input === String.fromCharCode(r.default.SPACE) ? e.toUpperCase() : e.toLowerCase();
                        break;

                      default:
                        if ("function" == typeof i.casing) {
                            var s = Array.prototype.slice.call(arguments);
                            s.push(n.validPositions), e = i.casing.apply(this, s);
                        }
                    }
                    return e;
                }
                function c(e) {
                    var t = this, a = this.opts, i = this.maskset;
                    if ("function" == typeof a.isComplete) return a.isComplete(e, a);
                    if ("*" !== a.repeat) {
                        var r = !1, s = o.determineLastRequiredPosition.call(t, !0), l = o.seekPrevious.call(t, s.l);
                        if (void 0 === s.def || s.def.newBlockMarker || s.def.optionality || s.def.optionalQuantifier) {
                            r = !0;
                            for (var u = 0; u <= l; u++) {
                                var c = n.getTestTemplate.call(t, u).match;
                                if (!0 !== c.static && void 0 === i.validPositions[u] && !0 !== c.optionality && !0 !== c.optionalQuantifier || !0 === c.static && e[u] !== n.getPlaceholder.call(t, u, c)) {
                                    r = !1;
                                    break;
                                }
                            }
                        }
                        return r;
                    }
                }
                function f(e, t, a, i, r, s, d) {
                    var m = this, g = this.dependencyLib, k = this.opts, y = m.maskset;
                    function b(e) {
                        return m.isRTL ? e.begin - e.end > 1 || e.begin - e.end == 1 : e.end - e.begin > 1 || e.end - e.begin == 1;
                    }
                    a = !0 === a;
                    var x = e;
                    function P(e) {
                        if (void 0 !== e) {
                            if (void 0 !== e.remove && (Array.isArray(e.remove) || (e.remove = [ e.remove ]), 
                            e.remove.sort((function(e, t) {
                                return t.pos - e.pos;
                            })).forEach((function(e) {
                                v.call(m, {
                                    begin: e,
                                    end: e + 1
                                });
                            })), e.remove = void 0), void 0 !== e.insert && (Array.isArray(e.insert) || (e.insert = [ e.insert ]), 
                            e.insert.sort((function(e, t) {
                                return e.pos - t.pos;
                            })).forEach((function(e) {
                                "" !== e.c && f.call(m, e.pos, e.c, void 0 === e.strict || e.strict, void 0 !== e.fromIsValid ? e.fromIsValid : i);
                            })), e.insert = void 0), e.refreshFromBuffer && e.buffer) {
                                var t = e.refreshFromBuffer;
                                p.call(m, !0 === t ? t : t.start, t.end, e.buffer), e.refreshFromBuffer = void 0;
                            }
                            void 0 !== e.rewritePosition && (x = e.rewritePosition, e = !0);
                        }
                        return e;
                    }
                    function E(t, a, r) {
                        var s = !1;
                        return n.getTests.call(m, t).every((function(l, c) {
                            var f = l.match;
                            if (o.getBuffer.call(m, !0), !1 !== (s = (!f.jit || void 0 !== y.validPositions[o.seekPrevious.call(m, t)]) && (null != f.fn ? f.fn.test(a, y, t, r, k, b(e)) : (a === f.def || a === k.skipOptionalPartCharacter) && "" !== f.def && {
                                c: n.getPlaceholder.call(m, t, f, !0) || f.def,
                                pos: t
                            }))) {
                                var d = void 0 !== s.c ? s.c : a, p = t;
                                return d = d === k.skipOptionalPartCharacter && !0 === f.static ? n.getPlaceholder.call(m, t, f, !0) || f.def : d, 
                                !0 !== (s = P(s)) && void 0 !== s.pos && s.pos !== t && (p = s.pos), !0 !== s && void 0 === s.pos && void 0 === s.c ? !1 : (!1 === v.call(m, e, g.extend({}, l, {
                                    input: u.call(m, d, f, p)
                                }), i, p) && (s = !1), !1);
                            }
                            return !0;
                        })), s;
                    }
                    void 0 !== e.begin && (x = m.isRTL ? e.end : e.begin);
                    var S = !0, _ = g.extend(!0, {}, y.validPositions);
                    if (!1 === k.keepStatic && void 0 !== y.excludes[x] && !0 !== r && !0 !== i) for (var M = x; M < (m.isRTL ? e.begin : e.end); M++) void 0 !== y.excludes[M] && (y.excludes[M] = void 0, 
                    delete y.tests[M]);
                    if ("function" == typeof k.preValidation && !0 !== i && !0 !== s && (S = P(S = k.preValidation.call(m, o.getBuffer.call(m), x, t, b(e), k, y, e, a || r))), 
                    !0 === S) {
                        if (S = E(x, t, a), (!a || !0 === i) && !1 === S && !0 !== s) {
                            var w = y.validPositions[x];
                            if (!w || !0 !== w.match.static || w.match.def !== t && t !== k.skipOptionalPartCharacter) {
                                if (k.insertMode || void 0 === y.validPositions[o.seekNext.call(m, x)] || e.end > x) {
                                    var O = !1;
                                    if (y.jitOffset[x] && void 0 === y.validPositions[o.seekNext.call(m, x)] && !1 !== (S = f.call(m, x + y.jitOffset[x], t, !0, !0)) && (!0 !== r && (S.caret = x), 
                                    O = !0), e.end > x && (y.validPositions[x] = void 0), !O && !o.isMask.call(m, x, k.keepStatic && 0 === x)) for (var T = x + 1, C = o.seekNext.call(m, x, !1, 0 !== x); T <= C; T++) if (!1 !== (S = E(T, t, a))) {
                                        S = h.call(m, x, void 0 !== S.pos ? S.pos : T) || S, x = T;
                                        break;
                                    }
                                }
                            } else S = {
                                caret: o.seekNext.call(m, x)
                            };
                        }
                        !1 !== S || !k.keepStatic || !c.call(m, o.getBuffer.call(m)) && 0 !== x || a || !0 === r ? b(e) && y.tests[x] && y.tests[x].length > 1 && k.keepStatic && !a && !0 !== r && (S = l.call(m, !0)) : S = l.call(m, x, t, a, i, void 0, e), 
                        !0 === S && (S = {
                            pos: x
                        });
                    }
                    if ("function" == typeof k.postValidation && !0 !== i && !0 !== s) {
                        var A = k.postValidation.call(m, o.getBuffer.call(m, !0), void 0 !== e.begin ? m.isRTL ? e.end : e.begin : e, t, S, k, y, a, d);
                        void 0 !== A && (S = !0 === A ? S : A);
                    }
                    S && void 0 === S.pos && (S.pos = x), !1 === S || !0 === s ? (o.resetMaskSet.call(m, !0), 
                    y.validPositions = g.extend(!0, {}, _)) : h.call(m, void 0, x, !0);
                    var D = P(S);
                    void 0 !== m.maxLength && (o.getBuffer.call(m).length > m.maxLength && !i && (o.resetMaskSet.call(m, !0), 
                    y.validPositions = g.extend(!0, {}, _), D = !1));
                    return D;
                }
                function d(e, t, a) {
                    for (var i = this.maskset, r = !1, o = n.getTests.call(this, e), s = 0; s < o.length; s++) {
                        if (o[s].match && (o[s].match.nativeDef === t.match[a.shiftPositions ? "def" : "nativeDef"] && (!a.shiftPositions || !t.match.static) || o[s].match.nativeDef === t.match.nativeDef || a.regex && !o[s].match.static && o[s].match.fn.test(t.input))) {
                            r = !0;
                            break;
                        }
                        if (o[s].match && o[s].match.def === t.match.nativeDef) {
                            r = void 0;
                            break;
                        }
                    }
                    return !1 === r && void 0 !== i.jitOffset[e] && (r = d.call(this, e + i.jitOffset[e], t, a)), 
                    r;
                }
                function p(e, t, a) {
                    var i, n, r = this, l = this.maskset, u = this.opts, c = this.dependencyLib, f = u.skipOptionalPartCharacter, d = r.isRTL ? a.slice().reverse() : a;
                    if (u.skipOptionalPartCharacter = "", !0 === e) o.resetMaskSet.call(r), l.tests = {}, 
                    e = 0, t = a.length, n = o.determineNewCaretPosition.call(r, {
                        begin: 0,
                        end: 0
                    }, !1).begin; else {
                        for (i = e; i < t; i++) delete l.validPositions[i];
                        n = e;
                    }
                    var p = new c.Event("keypress");
                    for (i = e; i < t; i++) {
                        p.which = d[i].toString().charCodeAt(0), r.ignorable = !1;
                        var h = s.EventHandlers.keypressEvent.call(r, p, !0, !1, !1, n);
                        !1 !== h && void 0 !== h && (n = h.forwardPosition);
                    }
                    u.skipOptionalPartCharacter = f;
                }
                function h(e, t, a) {
                    var i = this, r = this.maskset, s = this.dependencyLib;
                    if (void 0 === e) for (e = t - 1; e > 0 && !r.validPositions[e]; e--) ;
                    for (var l = e; l < t; l++) {
                        if (void 0 === r.validPositions[l] && !o.isMask.call(i, l, !1)) if (0 == l ? n.getTest.call(i, l) : r.validPositions[l - 1]) {
                            var u = n.getTests.call(i, l).slice();
                            "" === u[u.length - 1].match.def && u.pop();
                            var c, d = n.determineTestTemplate.call(i, l, u);
                            if (d && (!0 !== d.match.jit || "master" === d.match.newBlockMarker && (c = r.validPositions[l + 1]) && !0 === c.match.optionalQuantifier) && ((d = s.extend({}, d, {
                                input: n.getPlaceholder.call(i, l, d.match, !0) || d.match.def
                            })).generatedInput = !0, v.call(i, l, d, !0), !0 !== a)) {
                                var p = r.validPositions[t].input;
                                return r.validPositions[t] = void 0, f.call(i, t, p, !0, !0);
                            }
                        }
                    }
                }
                function v(e, t, a, i) {
                    var r = this, s = this.maskset, l = this.opts, u = this.dependencyLib;
                    function c(e, t, a) {
                        var i = t[e];
                        if (void 0 !== i && !0 === i.match.static && !0 !== i.match.optionality && (void 0 === t[0] || void 0 === t[0].alternation)) {
                            var n = a.begin <= e - 1 ? t[e - 1] && !0 === t[e - 1].match.static && t[e - 1] : t[e - 1], r = a.end > e + 1 ? t[e + 1] && !0 === t[e + 1].match.static && t[e + 1] : t[e + 1];
                            return n && r;
                        }
                        return !1;
                    }
                    var p = 0, h = void 0 !== e.begin ? e.begin : e, v = void 0 !== e.end ? e.end : e, m = !0;
                    if (e.begin > e.end && (h = e.end, v = e.begin), i = void 0 !== i ? i : h, h !== v || l.insertMode && void 0 !== s.validPositions[i] && void 0 === a || void 0 === t) {
                        var g, k = u.extend(!0, {}, s.validPositions), y = o.getLastValidPosition.call(r, void 0, !0);
                        for (s.p = h, g = y; g >= h; g--) delete s.validPositions[g], void 0 === t && delete s.tests[g + 1];
                        var b, x, P = i, E = P;
                        for (t && (s.validPositions[i] = u.extend(!0, {}, t), E++, P++), g = t ? v : v - 1; g <= y; g++) {
                            if (void 0 !== (b = k[g]) && !0 !== b.generatedInput && (g >= v || g >= h && c(g, k, {
                                begin: h,
                                end: v
                            }))) {
                                for (;"" !== n.getTest.call(r, E).match.def; ) {
                                    if (!1 !== (x = d.call(r, E, b, l)) || "+" === b.match.def) {
                                        "+" === b.match.def && o.getBuffer.call(r, !0);
                                        var S = f.call(r, E, b.input, "+" !== b.match.def, !0);
                                        if (m = !1 !== S, P = (S.pos || E) + 1, !m && x) break;
                                    } else m = !1;
                                    if (m) {
                                        void 0 === t && b.match.static && g === e.begin && p++;
                                        break;
                                    }
                                    if (!m && E > s.maskLength) break;
                                    E++;
                                }
                                "" == n.getTest.call(r, E).match.def && (m = !1), E = P;
                            }
                            if (!m) break;
                        }
                        if (!m) return s.validPositions = u.extend(!0, {}, k), o.resetMaskSet.call(r, !0), 
                        !1;
                    } else t && n.getTest.call(r, i).match.cd === t.match.cd && (s.validPositions[i] = u.extend(!0, {}, t));
                    return o.resetMaskSet.call(r, !0), p;
                }
            }
        }, t = {};
        function a(i) {
            var n = t[i];
            if (void 0 !== n) return n.exports;
            var r = t[i] = {
                exports: {}
            };
            return e[i](r, r.exports, a), r.exports;
        }
        var i = {};
        return function() {
            var e, t = i;
            Object.defineProperty(t, "__esModule", {
                value: !0
            }), t.default = void 0, a(3851), a(219), a(207), a(5296);
            var n = ((e = a(2394)) && e.__esModule ? e : {
                default: e
            }).default;
            t.default = n;
        }(), i;
    }();
}));
});

const InputMask = /*@__PURE__*/_commonjsHelpers.getDefaultExportFromCjs(inputmask);

// This mask configuration allows most characters. It is used for
// complex mask logic scenarios; essentially when the user has completed
// an answer, we convert the existing mask to this less restrictive version
// so that obfuscated answers from the backend can be displayed as is.
const DEFAULT_MASK_CONFIG = {
  mask: '',
  regex: '.*',
  definitions: {
    '.': {
      validator: "[0-9A-Za-z!#$%&'*+/=?^_`{|}~-]",
      casing: 'lower',
    },
  },
  greedy: true,
  showMaskOnHover: false,
  clearMaskOnLostFocus: false,
};
/**
 * This is a support class for SDK Masked Inputs and will only be relevant to that component.
 * This functionality was extracted for easier testing and to reduce the density of the component code.
 */
class MaskedInputService {
  buildPlaceholderFromMaskConfig(placeholder, mask, options) {
    var _a;
    if (mask === 'datetime') {
      mask = '99/99/9999';
    }
    const prefix = (_a = options === null || options === void 0 ? void 0 : options.prefix) !== null && _a !== void 0 ? _a : '';
    let maskedPlaceholder = placeholder !== null && placeholder !== void 0 ? placeholder : '';
    if ((options === null || options === void 0 ? void 0 : options.placeholder) && mask) {
      maskedPlaceholder = mask.replace(/[9a*]/g, options.placeholder);
    }
    return `${prefix}${maskedPlaceholder}`;
  }
  applyMaskToElement(element, maskInstance) {
    if (element && maskInstance) {
      maskInstance.mask(element);
    }
  }
  removeMaskFromElement(element) {
    if (element === null || element === void 0 ? void 0 : element.inputmask) {
      // Inputmask sets inline styles for some masks (text-align right
      // for integer, currency) and does not scrub them when removed.
      // https://github.com/RobinHerbots/Inputmask/issues/2342
      element.setAttribute('style', '');
      element.inputmask.remove();
    }
  }
  createDefaultMaskInstance() {
    return new InputMask(DEFAULT_MASK_CONFIG);
  }
  createPasswordMaskInstance(maskPattern, maskConfig) {
    var _a, _b, _c;
    const libraryConfig = {
      placeholder: (_a = maskConfig === null || maskConfig === void 0 ? void 0 : maskConfig.placeholder) !== null && _a !== void 0 ? _a : undefined,
      prefix: (_b = maskConfig === null || maskConfig === void 0 ? void 0 : maskConfig.prefix) !== null && _b !== void 0 ? _b : undefined,
      inputFormat: (_c = maskConfig === null || maskConfig === void 0 ? void 0 : maskConfig.inputFormat) !== null && _c !== void 0 ? _c : undefined,
      // Hover masks are disabled to prevent the mask from flickering on and off when
      // the cursor is over the input
      showMaskOnHover: false,
      // Prevents this from showing mask separators until the user has entered characters
      // before it. For example, if the pattern is 99-99, the user will not see a dash
      // until they have typed 2 digits.
      // This will better keep the password value in sync with what the user has actually entered.
      jitMasking: true,
    };
    return new InputMask(maskPattern, libraryConfig);
  }
  createTextMaskInstance(maskPattern, maskConfig) {
    var _a, _b, _c;
    const libraryConfig = {
      placeholder: (_a = maskConfig === null || maskConfig === void 0 ? void 0 : maskConfig.placeholder) !== null && _a !== void 0 ? _a : undefined,
      prefix: (_b = maskConfig === null || maskConfig === void 0 ? void 0 : maskConfig.prefix) !== null && _b !== void 0 ? _b : undefined,
      inputFormat: (_c = maskConfig === null || maskConfig === void 0 ? void 0 : maskConfig.inputFormat) !== null && _c !== void 0 ? _c : undefined,
      // Hover masks are disabled to prevent the mask from flickering on and off when
      // the cursor is over the input
      showMaskOnHover: false,
    };
    return new InputMask(maskPattern, libraryConfig);
  }
  isElementMaskSame(element, alias) {
    if ((element === null || element === void 0 ? void 0 : element.inputmask) && alias) {
      return alias === element.inputmask.opts.alias;
    }
    return false;
  }
}

const bpSdkMaskedInputCss = ".bp-sdk-masked__wrapper{display:flex;height:fit-content;position:relative;flex-direction:row}.bp-sdk-masked__input{padding:1px}.bp-sdk-masked__button{display:flex;align-content:center;justify-content:center;padding:1px}.bp-sdk-masked__button .bp-sdk-icon{width:1.5rem;font-weight:1.2rem}.bp-sdk-hidden{position:fixed;top:-100vh}";

let BpSdkMaskedInput = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.valueUpdate = index.createEvent(this, "valueUpdate", 7);
    /**
     * Error messages
     */
    this.errors = [];
    /**
     * When true, the input can be toggled between text and password modes.
     *
     * In text mode, the input displays the text entered by the user as is.
     * In password mode, the input obfuscates the text value (usually with `*` or `•`).
     */
    this.canHide = false;
    /**
     * When this prop is true, and a valid answer for this question has been synced to the backend,
     * if the user edits the value without providing a valid answer, the original persisted answer
     * will be restored.
     *
     * Additionally, the formatting mask will be temporarily disabled until the user makes edits to
     * the answer field. This allows an obfuscated form of the answer (i.e. 12345 -> ***45) to be
     * provided by the backend without conflicting with the requirements of the mask pattern.
     */
    this.useComplexMaskLogic = false;
    /**
     * Determines if input is required
     */
    this.required = false;
    /**
     * Placeholder to display
     */
    this.placeholder = '';
    /**
     * Is touched
     */
    this.touched = false;
    /**
     * Is pristine
     */
    this.pristine = true;
    /**
     * Is answer in complete state
     */
    this.isCompleted = false;
    /**
     * When true, the field will be readonly. It will display only the label and value as plain text.
     */
    this.isReadOnly = false;
    this._placeholder = '';
    this._touched = false;
    this.isHidden = false;
    this.useExternal = false;
    this.hasFocus = false;
    this.shouldUpdateMask = true;
    this.shouldUpdatePlaceholder = true;
    this.completedValue = '';
    this.inputValue = '';
    this.ariaValue = '';
    // mm/dd/yyyy
    this.dateFormatRegex = /\d\d\/\d\d\/\d\d\d\d/;
    this.inputMaskClassName = {
      text: 'masked-text',
      password: 'masked-password',
    };
    this.onFocus = () => {
      this.hasFocus = true;
      this.shouldUpdateMask = true;
    };
    this.onToggleVisibilityButton = () => {
      this.isHidden = !this.isHidden;
      this.shouldUpdateMask = true;
    };
    this.onInput = (event) => {
      var _a;
      const el = event.target;
      const unmaskedValue = ((_a = el.inputmask) === null || _a === void 0 ? void 0 : _a.unmaskedvalue()) || '';
      this.updateAnswer(unmaskedValue);
    };
    this.onAutocompleteInput = (event) => {
      const el = event.target;
      this.updateAnswer(el.value);
    };
    this.onBlur = () => {
      this.hasFocus = false;
      this.shouldUpdateMask = true;
      if (!this.pristine) {
        this._touched = true;
      }
    };
  }
  onTouchedChange() {
    this._touched = this.touched;
  }
  onIsCompletedChange() {
    if (this.useComplexMaskLogic) {
      this.shouldUpdateMask = true;
    }
  }
  onValueChange(value) {
    this.shouldUpdateMask = true;
    if (this.isCompleted) {
      this.completedValue = value;
      this.inputValue = value;
    }
  }
  onAnswerIdChange() {
    this.completedValue = '';
    this.inputValue = '';
  }
  onCanHideChange(canHide) {
    this.isHidden = canHide;
    this.shouldUpdateMask = true;
  }
  onPlaceholderChange() {
    this.shouldUpdatePlaceholder = true;
  }
  onMaskChange() {
    this.shouldUpdateMask = true;
    this.shouldUpdatePlaceholder = true;
  }
  onOptionsChange(options, oldOptions) {
    if (index_esm_min.Fe(options, oldOptions)) {
      this.shouldUpdateMask = true;
      this.shouldUpdatePlaceholder = true;
    }
  }
  onUseComplexMaskLogicChange() {
    this.shouldUpdateMask = true;
  }
  onLabelIdChange(labelId) {
    this.updateLabelledBy(this.labelledBy, labelId);
  }
  onLabelledByChange(labelledBy) {
    this.updateLabelledBy(labelledBy, this.labelId);
  }
  resetState() {
    this._touched = false;
  }
  connectedCallback() {
    this.resetState();
    if (!this.service) {
      this.service = new MaskedInputService();
    }
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-masked-input');
    customElements.whenDefined('bp-sdk-external-masked-input').then(() => {
      this.useExternal = true;
    });
    this.onLabelIdChange(this.labelId);
    this.onLabelledByChange(this.labelledBy);
    this.onIsCompletedChange();
    this.onCanHideChange(this.canHide);
    this.onValueChange(this.value);
    this.inputValue = this.value;
    this.ariaValue = this.value;
    this._touched = this.touched;
    if (!this.useExternal && !this.isReadOnly) {
      this._placeholder = this.service.buildPlaceholderFromMaskConfig(this.placeholder, this.mask, this.options);
    }
    this.shouldUpdatePlaceholder = false;
  }
  componentWillUpdate() {
    if (!this.useExternal && !this.isReadOnly) {
      if (this.shouldUpdatePlaceholder) {
        this._placeholder = this.service.buildPlaceholderFromMaskConfig(this.placeholder, this.mask, this.options);
      }
    }
    this.shouldUpdatePlaceholder = false;
  }
  componentDidRender() {
    if (!this.useExternal && !this.isReadOnly) {
      // Mask updates need to take place in componentDidRender(). The mask library attaches
      // to a DOM element, so it needs to be rendered first for the element to exist
      if (this.shouldUpdateMask) {
        this.addMaskToInput(this.mask, this.options);
      }
    }
    this.shouldUpdateMask = false;
  }
  disconnectedCallback() {
    this.removeMaskFromInput();
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-masked-input", { answerId: this.answerId, autoComplete: this.autoComplete, canHide: this.canHide, code: this.code, errorText: this.errorText, errors: this.errors, fieldType: this.fieldType, helpText: this.helpText, answeredBySource: this.answeredBySource, isCompleted: this.isCompleted, isReadOnly: this.isReadOnly, labelId: this.labelId, label: this.label, labelledBy: this.labelledBy, mask: this.mask, maxDate: this.maxDate, max: this.max, minDate: this.minDate, min: this.min, options: this.options, pattern: this.pattern, placeholder: this.placeholder, pristine: this.pristine, questionId: this.questionId, required: this.required, shouldHideOnBlur: this.canHide, touched: this.touched, useComplexMaskLogic: this.useComplexMaskLogic, value: this.value }));
  }
  renderInternal() {
    var _a;
    const input = this.isReadOnly ? this.renderReadOnlyElement(this.value) : [this.renderInput(), this.renderButton()];
    const hasErrors = (this.errorText && !this.isCompleted) || !!((_a = this.errors) === null || _a === void 0 ? void 0 : _a.length);
    const isTouched = this.touched && this._touched;
    const isDirty = !this.pristine;
    const shouldDisplayErrors = isTouched && isDirty && hasErrors;
    return (index.h("div", { class: "bp-sdk-masked__container" }, index.h("div", { class: "bp-sdk-masked__content" }, index.h("label", { id: this.labelId, htmlFor: `bp-sdk-masked__${this.answerId}`, class: "bp-sdk__label bp-sdk-masked__label", innerHTML: this.label }), index.h("div", { class: "bp-sdk-masked__wrapper" }, input)), shouldDisplayErrors && (index.h("bp-sdk-errors-container", { answerId: this.answerId, questionId: this.questionId, fieldType: this.fieldType, min: this.min, minDate: this.minDate, max: this.max, maxDate: this.maxDate, pattern: this.pattern, errors: this.errors, errorText: this.errorText }))));
  }
  renderReadOnlyElement(value) {
    return index.h("span", { class: "read-only-value" }, value);
  }
  renderPasswordInput() {
    return (index.h("input", { id: `bp-sdk-masked__${this.answerId}`, "aria-labelledby": this._labelledBy, "aria-valuetext": this.ariaValue, placeholder: this._placeholder, required: this.required, type: "password", class: `bp-sdk-masked__input bp-sdk-masked__input--blurs ${this.inputMaskClassName.password}`, onFocus: this.onFocus, onBlur: this.onBlur, onInput: this.onInput, value: this.inputValue }));
  }
  renderTextInput() {
    return (index.h("input", { "aria-labelledby": this._labelledBy, "aria-valuetext": this.ariaValue, placeholder: this._placeholder, required: this.required, class: `bp-sdk-masked__input ${this.inputMaskClassName.text}`, onFocus: this.onFocus, onBlur: this.onBlur, onInput: this.onInput, value: this.inputValue }));
  }
  /**
   * This input is intended to receive autocomplete data from a browser and forward it to the visible inputs.
   */
  renderAutocompleteInput() {
    return index.h("input", { "aria-hidden": true, tabindex: "-1", autocomplete: this.autoComplete, class: "bp-sdk-hidden", onInput: this.onAutocompleteInput });
  }
  renderInput() {
    const input = this.isHidden ? this.renderPasswordInput() : this.renderTextInput();
    return [this.renderAutocompleteInput(), input];
  }
  renderButton() {
    return (this.canHide && (index.h("bp-sdk-masked-input-button", { class: "bp-sdk-masked__button", "aria-label": this.isHidden ? 'Show Text' : 'Hide Text', onClick: this.onToggleVisibilityButton }, this.isHidden && index.h("bp-sdk-icon-container", { name: "eye" }), !this.isHidden && index.h("bp-sdk-icon-container", { name: "eye-slash" }))));
  }
  updateAnswer(unmaskedValue) {
    let value = unmaskedValue;
    if (this.fieldType === index_esm_min$1.t.Date) {
      value = this.serializeDateValue(unmaskedValue);
    }
    const hasValueChanged = value !== this.inputValue;
    const hasPreviousValue = this.hasValue(this.value);
    const hasCurrentValue = this.hasValue(value);
    const shouldValueChangeTriggerUpdate = hasPreviousValue || hasCurrentValue;
    if (hasValueChanged && shouldValueChangeTriggerUpdate) {
      this.inputValue = unmaskedValue;
      this.valueUpdate.emit(value);
    }
  }
  hasValue(value) {
    return !(value == null || value === '');
  }
  serializeDateValue(value) {
    return this.dateFormatRegex.test(value) ? new Date(value).toISOString() : undefined;
  }
  updateLabelledBy(labelledBy, labelledById) {
    let parts = [];
    if (labelledById) {
      parts.push(`${labelledById}`);
    }
    if (labelledBy) {
      parts.push(`${labelledBy}`);
    }
    const label = parts.join(' ');
    // undefined is used because it will unset the HTML attribute
    this._labelledBy = label || undefined;
  }
  /**
   * Attaches an instance of InputMask to whichever input element is currently rendered.
   * This should be called after the input is rendered as the InputMask library attaches
   * to an element in the DOM.
   */
  addMaskToInput(maskPattern, maskOptions) {
    const elementSelector = this.getInputCssClassSelector();
    const element = this.el.querySelector(elementSelector);
    if (element) {
      let maskInstance = this.service.createDefaultMaskInstance();
      // We need to cache this before applying a mask or the mask will affect it
      const currentElementValue = element.value;
      if (this.useComplexMaskLogic) {
        this.service.removeMaskFromElement(element);
        maskInstance = this.getMaskForComplexLogic(maskPattern, maskOptions);
        this.service.applyMaskToElement(element, maskInstance);
        let valueOverride = this.getValueForComplexLogic(currentElementValue);
        if (valueOverride !== null) {
          element.value = valueOverride;
          this.inputValue = valueOverride;
        }
      }
      else if (!element.inputmask || !this.service.isElementMaskSame(element, this.mask)) {
        // 1. re-applying same inputmask can disrupt the cursor position
        // 2. DOM can reuse elements, remove and apply mask only if different
        this.service.removeMaskFromElement(element);
        maskInstance = this.createCustomMaskInstance(maskPattern, maskOptions);
        this.service.applyMaskToElement(element, maskInstance);
      }
    }
  }
  removeMaskFromInput() {
    const elementSelector = this.getInputCssClassSelector();
    const element = this.el.querySelector(elementSelector);
    this.service.removeMaskFromElement(element);
  }
  getMaskForComplexLogic(maskPattern, maskOptions) {
    let maskInstance = this.service.createDefaultMaskInstance();
    // When the field has focus, we assume the user is trying to edit the value - even a
    // completed value - so the mask needs to reflect the field type.
    // When the field does not have focus, but is incomplete, we assume the user is still
    // filling out the value, so the mask needs to match the field type.
    if (this.hasFocus || !(this.isCompleted && this.completedValue)) {
      maskInstance = this.createCustomMaskInstance(maskPattern, maskOptions);
    }
    return maskInstance;
  }
  getValueForComplexLogic(elementValue) {
    let valueOverride = null;
    if (this.hasFocus) {
      // Allows the user to edit a completed value. The server doesn't send the actual value, so just
      // blank it out rather than give the impression they can make a partial edit.
      const isDisplayingObfuscatedValue = elementValue === this.completedValue && this.completedValue.includes('*');
      if (this.isCompleted && isDisplayingObfuscatedValue) {
        valueOverride = '';
      }
    }
    else if (this.isCompleted && this.completedValue) {
      // If the user attempts to edit a completed value from the server and makes no changes,
      // this restores the server value.
      valueOverride = this.completedValue;
    }
    return valueOverride;
  }
  createCustomMaskInstance(maskPattern, maskOptions) {
    return this.isHidden
      ? this.service.createPasswordMaskInstance(maskPattern, maskOptions)
      : this.service.createTextMaskInstance(maskPattern, maskOptions);
  }
  getInputCssClassSelector() {
    return this.isHidden ? `.${this.inputMaskClassName.password}` : `.${this.inputMaskClassName.text}`;
  }
  get el() { return index.getElement(this); }
  static get watchers() { return {
    "touched": ["onTouchedChange"],
    "isCompleted": ["onIsCompletedChange"],
    "value": ["onValueChange"],
    "answerId": ["onAnswerIdChange"],
    "canHide": ["onCanHideChange"],
    "placeholder": ["onPlaceholderChange"],
    "mask": ["onMaskChange"],
    "options": ["onOptionsChange"],
    "useComplexMaskLogic": ["onUseComplexMaskLogicChange"],
    "labelId": ["onLabelIdChange"],
    "labelledBy": ["onLabelledByChange"]
  }; }
};
BpSdkMaskedInput.style = bpSdkMaskedInputCss;

const bpSdkMaskedInputButtonCss = "";

let BpSdkMaskedInputButton = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.useExternal = false;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-masked-input-button');
    customElements.whenDefined('bp-sdk-external-masked-input-button').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return index.h("bp-sdk-external-masked-input-button", { label: this.label });
  }
  renderInternal() {
    return (index.h("button", { "aria-label": this.label, class: "bp-sdk-masked-input-button__container" }, index.h("slot", null)));
  }
};
BpSdkMaskedInputButton.style = bpSdkMaskedInputButtonCss;

const bpSdkMaskedInputContainerCss = "";

let BpSdkMaskedInputContainer = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    /**
     * Error messages
     */
    this.errors = [];
    /**
     * When true, the field will be readonly. It will display only the label and value as plain text.
     */
    this.isReadOnly = false;
    /**
     * Determines if input is required
     */
    this.required = false;
    /**
     * Placeholder to display
     */
    this.placeholder = '';
    /**
     * Is touched
     */
    this.touched = false;
    /**
     * Is pristine
     */
    this.pristine = true;
    this.canHide = false;
    this.useComplexMaskLogic = false;
    this.useExternal = false;
    this.handleSubscriptions = () => {
      if (store.canGetStore()) {
        this.storeUnsubscribe && this.storeUnsubscribe();
        this.storeUnsubscribe = store.store.mapStateToProps(this, this.mapStateToProps);
      }
    };
    this.mapStateToProps = (state) => {
      return {
        isAutocompleteEnabled: sdkRedux.isAutocompleteEnabled(state),
      };
    };
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
    this.handleSubscriptions();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-masked-input-container');
    customElements.whenDefined('bp-sdk-external-masked-input-container').then(() => {
      this.useExternal = true;
    });
    this.handleSubscriptions();
    this.onFieldTypeChange(this.fieldType);
    this.updateAutocomplete({
      referenceType: this.referenceType,
      code: this.code,
      fieldType: this.fieldType,
      isAutocompleteEnabled: this.isAutocompleteEnabled,
    });
  }
  onReferenceTypeChange(referenceType) {
    this.updateAutocomplete({
      referenceType,
      code: this.code,
      fieldType: this.fieldType,
      isAutocompleteEnabled: this.isAutocompleteEnabled,
    });
  }
  onCodeChange(code) {
    this.updateAutocomplete({
      referenceType: this.referenceType,
      code,
      fieldType: this.fieldType,
      isAutocompleteEnabled: this.isAutocompleteEnabled,
    });
  }
  onIsAutocompleteEnabledChange(isAutocompleteEnabled) {
    this.updateAutocomplete({
      referenceType: this.referenceType,
      code: this.code,
      fieldType: this.fieldType,
      isAutocompleteEnabled,
    });
  }
  onFieldTypeChange(fieldType) {
    let mask;
    let useComplexMaskLogic = false;
    let canHide = false;
    let options;
    switch (fieldType) {
      case index_esm_min$1.t.Phone:
        mask = '(999) 999-9999';
        options = {
          placeholder: '#',
        };
        break;
      case index_esm_min$1.t.Percentage:
        mask = '999%';
        options = {
          placeholder: ' ',
        };
        break;
      case index_esm_min$1.t.Currency:
        mask = 'integer';
        options = {
          // unlike percentage, currency placeholder must be empty
          // otherwise, inputmask will show "$integer" for placeholder
          placeholder: '',
          prefix: '$',
        };
        break;
      case index_esm_min$1.t.Date:
        mask = 'datetime';
        options = {
          placeholder: '#',
          inputFormat: 'mm/dd/yyyy',
        };
        useComplexMaskLogic = true;
        canHide = true;
        break;
      case index_esm_min$1.t.SocialSecurityNumber:
        mask = '999-99-9999';
        options = {
          placeholder: '#',
        };
        useComplexMaskLogic = true;
        canHide = true;
        break;
      case index_esm_min$1.t.FederalEmployeeIdentification:
        mask = '99-9999999';
        options = {
          placeholder: '#',
        };
        useComplexMaskLogic = true;
        canHide = true;
        break;
    }
    this.mask = mask;
    this.options = options;
    this.canHide = canHide;
    this.useComplexMaskLogic = useComplexMaskLogic;
    this.updateAutocomplete({
      referenceType: this.referenceType,
      code: this.code,
      fieldType,
      isAutocompleteEnabled: this.isAutocompleteEnabled,
    });
  }
  updateAutocomplete({ code, fieldType, referenceType, isAutocompleteEnabled, }) {
    this.autoComplete = isAutocompleteEnabled ? index_esm_min.o4({ referenceType, code, fieldType }) : undefined;
  }
  disconnectedCallback() {
    this.storeUnsubscribe && this.storeUnsubscribe();
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-masked-input-container", { answerId: this.answerId, labelId: this.labelId, code: this.code, errorText: this.errorText, errors: this.errors, fieldType: this.fieldType, helpText: this.helpText, answeredBySource: this.answeredBySource, isCompleted: this.isCompleted, isReadOnly: this.isReadOnly, label: this.label, labelledBy: this.labelledBy, mask: this.mask, maxDate: this.maxDate, max: this.max, minDate: this.minDate, min: this.min, options: this.options, pattern: this.pattern, placeholder: this.placeholder, pristine: this.pristine, questionId: this.questionId, referenceType: this.referenceType, required: this.required, shouldHideOnBlur: this.canHide, touched: this.touched, useComplexMaskLogic: this.useComplexMaskLogic, value: this.value }));
  }
  renderInternal() {
    return (index.h("bp-sdk-masked-input", { answerId: this.answerId, autoComplete: this.autoComplete, canHide: this.canHide, code: this.code, errors: this.errors, errorText: this.errorText, fieldType: this.fieldType, helpText: this.helpText, answeredBySource: this.answeredBySource, isCompleted: this.isCompleted, isReadOnly: this.isReadOnly, label: this.label, labelId: this.labelId, labelledBy: this.labelledBy, mask: this.mask, max: this.max, maxDate: this.maxDate, min: this.min, minDate: this.minDate, options: this.options, pattern: this.pattern, placeholder: this.placeholder, pristine: this.pristine, questionId: this.questionId, required: this.required, touched: this.touched, useComplexMaskLogic: this.useComplexMaskLogic, value: this.value }));
  }
  get el() { return index.getElement(this); }
  static get watchers() { return {
    "referenceType": ["onReferenceTypeChange"],
    "code": ["onCodeChange"],
    "isAutocompleteEnabled": ["onIsAutocompleteEnabledChange"],
    "fieldType": ["onFieldTypeChange"]
  }; }
};
BpSdkMaskedInputContainer.style = bpSdkMaskedInputContainerCss;

const bpSdkParentQuestionPoolSelectorCss = "bp-sdk-parent-question-pool-selector .bp-sdk-parent-question-pool-selector__container{position:relative;min-width:10 rem;max-width:100vw}.bp-sdk-hidden{position:fixed;top:-100rem}.bp-sdk-align-right{margin-left:auto}.bp-sdk-select__button-arrow{font-size:20px}.bp-sdk-select__list{background:white;border:1px solid #aaa;left:0;overflow-y:auto;margin:0;max-height:15rem;padding-left:0;position:absolute;width:100%;z-index:1}.bp-sdk-select__button{width:100%;height:2.5rem;background-color:white;display:flex;padding:0.5rem;justify-items:center;align-items:center;cursor:pointer}.bp-sdk-select__list-item{display:block;position:relative;font-size:16px;padding-left:1rem;padding-right:1rem;cursor:pointer}";

let BpSdkParentQuestionPoolSelector = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.selectedAnswerPoolId = index.createEvent(this, "selectedAnswerPoolId", 7);
    this.choices = [];
    this.useExternal = false;
    this.selectedChoiceId = '';
    this.selectValueUpdate = (ev) => {
      ev.stopPropagation();
      this.selectedChoiceId = ev.detail[0];
    };
    this.handleSubmit = () => {
      if (this.selectedChoiceId) {
        this.selectedAnswerPoolId.emit(this.selectedChoiceId);
        this.selectedChoiceId = undefined;
      }
    };
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-parent-question-pool-selector');
    customElements.whenDefined('bp-sdk-external-parent-question-pool-selector').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return index.h("bp-sdk-external-parent-question-pool-selector", { choices: this.choices, label: this.label });
  }
  renderInternal() {
    return (index.h("div", { class: "bp-sdk-parent-question-pool-selector__container" }, index.h("bp-sdk-select-input", { choices: this.choices, label: this.label, onValueUpdate: this.selectValueUpdate, choiceId: this.selectedChoiceId }), this.selectedChoiceId && this.renderSubmitButton()));
  }
  renderSubmitButton() {
    if (!!this.selectedChoiceId) {
      return (index.h("button", { type: "button", class: "bp-sdk-button bp-sdk-parent-pool-selector__submit-button", onClick: this.handleSubmit }, "Next"));
    }
  }
};
BpSdkParentQuestionPoolSelector.style = bpSdkParentQuestionPoolSelectorCss;

const bpSdkProductListCss = ".bp-sdk-no-selection{user-select:none}.bp-sdk-visually-hidden{display:none}.bp-sdk-align-right{margin-left:auto}.bp-sdk-product__list{position:absolute;background:white;border:1px solid #aaa;left:0;overflow-y:auto;margin:0;max-height:15rem;padding-left:0;position:absolute;width:100%;z-index:1}.bp-sdk-product__list-button{width:100%;height:2.5rem;background-color:white;display:flex;padding:0.5rem;justify-items:center;align-items:center}";

let BpSdkProductList = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    /**
     * Selected choice ids
     */
    this.choiceIds = [];
    /**
     * Choices to display
     */
    this.choices = [];
    /**
     * Is multiple
     */
    this.isMultiple = true;
    /**
     * When true, the field will be readonly. It will display only the label and value as plain text.
     */
    this.isReadOnly = false;
    /*
      Label to display
    */
    this.label = 'What kind of coverage are you looking for?';
    /**
     * Is Pristine
     */
    this.pristine = true;
    /**
     * Is required?
     */
    this.required = false;
    /**
     * Is touched
     */
    this.touched = false;
    this.useExternal = false;
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-product-list');
    customElements.whenDefined('bp-sdk-external-product-list').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-product-list", { answeredBySource: this.answeredBySource, answerId: this.answerId, choiceId: this.choiceId, choiceIds: this.choiceIds, choices: this.choices, code: this.code, errorText: this.errorText, fieldType: this.fieldType, helpText: this.helpText, isMultiple: this.isMultiple, isReadOnly: this.isReadOnly, label: this.label, labelledBy: this.labelledBy, pristine: this.pristine, questionId: this.questionId, touched: this.touched, required: this.required }));
  }
  renderInternal() {
    return (index.h("div", { class: "bp-sdk-product__container" }, index.h("bp-sdk-select-input", { answerId: this.answerId, choiceId: this.choiceId, choiceIds: this.choiceIds, choices: this.choices, code: this.code, errorText: this.errorText, helpText: this.helpText, answeredBySource: this.answeredBySource, fieldType: this.fieldType, isReadOnly: this.isReadOnly, label: this.label, labelId: this.labelledBy, labelledBy: this.labelledBy, multiple: this.isMultiple, pristine: this.pristine, questionId: this.questionId, required: this.required, touched: this.touched })));
  }
};
BpSdkProductList.style = bpSdkProductListCss;

const bpSdkProductListContainerCss = "";

let BpSdkProductListContainer = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    /**
     * Is touched
     */
    this.touched = false;
    /**
     * Is Pristine
     */
    this.pristine = true;
    /*
      Label to display
    */
    this.label = 'What kind of coverage are you looking for?';
    /**
     * Choices to display
     */
    this.choices = [];
    /**
     * Selected choice ids
     */
    this.choiceIds = [];
    /**
     * Is multiple
     */
    this.isMultiple = true;
    /**
     * When true, the field will be readonly. It will display only the label and value as plain text.
     */
    this.isReadOnly = false;
    this.useExternal = false;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-product-list-container');
    customElements.whenDefined('bp-sdk-external-product-list-container').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-product-list-container", { answeredBySource: this.answeredBySource, answerId: this.answerId, choiceId: this.choiceId, choiceIds: this.choiceIds, choices: this.choices, code: this.code, errorText: this.errorText, fieldType: this.fieldType, helpText: this.helpText, isMultiple: this.isMultiple, isReadOnly: this.isReadOnly, label: this.label, labelledBy: this.labelledBy, pristine: this.pristine, questionId: this.questionId, touched: this.touched, required: this.required }));
  }
  renderInternal() {
    return (index.h("bp-sdk-product-list", { answeredBySource: this.answeredBySource, answerId: this.answerId, choiceId: this.choiceId, choiceIds: this.choiceIds, choices: this.choices, code: this.code, errorText: this.errorText, fieldType: this.fieldType, helpText: this.helpText, isMultiple: this.isMultiple, isReadOnly: this.isReadOnly, label: this.label, labelledBy: this.labelledBy, pristine: this.pristine, questionId: this.questionId, touched: this.touched, required: this.required }));
  }
};
BpSdkProductListContainer.style = bpSdkProductListContainerCss;

const bpSdkQuestionPoolContainerCss = "";

let BpSdkQuestionPoolContainer = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.useExternal = false;
    this.selectParentPoolQuestion = false;
    this.handleSubscriptions = () => {
      if (!!store.canGetStore()) {
        this.storeUnsubscribe && this.storeUnsubscribe();
        store.store.mapDispatchToProps(this, { addQuestionPool: sdkRedux.addQuestionPool });
        this.storeUnsubscribe = store.store.mapStateToProps(this, this.mapStateToProps);
      }
    };
    this.mapStateToProps = (state) => {
      return {
        applicationId: sdkRedux.getFormId(state),
        config: sdkRedux.getPartnerEngineConfig(state),
        currentQuestionSet: sdkRedux.getCurrentActiveQuestionSet(state),
      };
    };
    this.handleAddItem = () => {
      if (!!this.parentQuestionPoolId && !this.selectParentPoolQuestion) {
        this.selectParentPoolQuestion = true;
      }
      else {
        this.addQuestionPool({
          config: this.config,
          application_id: this.applicationId,
          question_pool_id: this.guid,
          parent_question_pool_id: this.parentQuestionPoolId,
        });
      }
    };
  }
  onParentQuestionPoolSelected(event) {
    this.addQuestionPool({
      config: this.config,
      application_id: this.applicationId,
      question_pool_id: this.guid,
      parent_question_pool_id: this.parentQuestionPoolId,
      selected_answer_pool_id: event.detail,
    });
  }
  resetState() { }
  connectedCallback() {
    this.handleSubscriptions();
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-question-pool-container');
    customElements.whenDefined('bp-sdk-external-question-pool-container').then(() => {
      this.useExternal = true;
    });
    this.handleSubscriptions();
  }
  disconnectedCallback() {
    this.storeUnsubscribe && this.storeUnsubscribe();
  }
  getParentAnswers() {
    return this.currentQuestionSet.answers.filter((answer) => answer.question.id === this.parentQuestionPoolReferenceId);
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-question-pool-container", { addText: this.addText, code: this.code, description: this.description, displayText: this.displayText, guid: this.guid, ownerId: this.ownerId, parentQuestionId: this.parentQuestionId, parentQuestionPoolId: this.parentQuestionPoolId, parentQuestionPoolReferenceId: this.parentQuestionPoolReferenceId, removeText: this.removeText, tenantId: this.tenantId, config: this.config, applicationId: this.applicationId, currentQuestionSet: this.currentQuestionSet }));
  }
  renderAnswer() {
    const choices = this.getParentAnswers().map((a, i) => ({
      alias: a.question.text,
      created_at: '',
      updated_at: '',
      id: a.answer_pool_id,
      order: i,
      question_id: a.question.id,
      value: a.value,
    }));
    return index.h("bp-sdk-parent-question-pool-selector", { choices: choices, label: choices[0].alias });
  }
  renderInternal() {
    return (index.h("div", { class: "bp-sdk-question-pool-container__container" }, index.h("bp-sdk-add-item-container", { text: this.addText, helpText: this.displayText, onAddItem: this.handleAddItem }, index.h("slot", null)), this.selectParentPoolQuestion && this.renderAnswer()));
  }
  get el() { return index.getElement(this); }
};
BpSdkQuestionPoolContainer.style = bpSdkQuestionPoolContainerCss;

const bpSdkRadioDialogCss = "";

let BpSdkRadioDialog = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    /**
     * Choices to display
     */
    this.choices = [];
    /**
     * Is touched
     */
    this.touched = false;
    /**
     * Is pristine
     */
    this.pristine = true;
    /**
     * When true, the field will be readonly. It will display only the label and value as plain text.
     */
    this.isReadOnly = false;
    /**
     * Is answer in complete state
     */
    this.isCompleted = false;
    this.useExternal = false;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-radio-dialog');
    customElements.whenDefined('bp-sdk-external-radio-dialog').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-radio-dialog", { answeredBySource: this.answeredBySource, answerId: this.answerId, choiceId: this.choiceId, choices: this.choices, code: this.code, errorText: this.errorText, errors: this.errors, fieldType: this.fieldType, helpText: this.helpText, isCompleted: this.isCompleted, isReadOnly: this.isReadOnly, isRequired: this.isRequired, label: this.label, labelledBy: this.labelledBy, pristine: this.pristine, questionId: this.questionId, touched: this.touched }));
  }
  renderInternal() {
    return (index.h("bp-sdk-dialog", { class: "bp-sdk-radio-dialog__container", code: this.code, isRequired: this.isRequired, questionId: this.questionId }, index.h("div", { class: "bp-sdk-radio-dialog__radio" }, index.h("bp-sdk-radio-input", { answeredBySource: this.answeredBySource, answerId: this.answerId, choiceId: this.choiceId, choices: this.choices, code: this.code, errors: this.errors, errorText: this.errorText, fieldType: this.fieldType, isCompleted: this.isCompleted, isReadOnly: this.isReadOnly, label: this.label, labelledBy: this.labelledBy, pristine: this.pristine, questionId: this.questionId, required: this.isRequired, touched: this.touched }))));
  }
};
BpSdkRadioDialog.style = bpSdkRadioDialogCss;

const bpSdkRadioInputCss = ".bp-sdk-radio__choice{cursor:pointer}.bp-sdk-radio__choice+label{cursor:pointer}";

let BpSdkRadioInput = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.valueUpdate = index.createEvent(this, "valueUpdate", 7);
    this.removeActiveAnswer = index.createEvent(this, "removeActiveAnswer", 7);
    /**
     * Choices to display
     */
    this.choices = [];
    /**
     * Is touched
     */
    this.touched = false;
    /**
     * Is pristine
     */
    this.pristine = true;
    /**
     * Is answer in complete state
     */
    this.isCompleted = false;
    /**
     * When true, the field will be readonly. It will display only the label and value as plain text.
     */
    this.isReadOnly = false;
    this.controlClasses = '';
    this.useExternal = false;
  }
  onControlChange() {
    const touched = this.touched ? ' bp-sdk-touched' : '';
    this.controlClasses = `bp-sdk-radio__label${touched}`;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-radio-input');
    customElements.whenDefined('bp-sdk-external-radio-input').then(() => {
      this.useExternal = true;
    });
    this.onChoiceIdChange(this.choiceId);
    this.onControlChange();
  }
  onChoiceIdChange(newValue) {
    this._choiceId = newValue;
  }
  onChange(new_value) {
    if (new_value !== this.choiceId) {
      this.removeActiveAnswer.emit();
      this.valueUpdate.emit(new_value);
    }
  }
  renderChoice(choice) {
    // The addition of labelled by ensures this row will be unique within question pools
    const id = `bp-sdk-radio__choice-${this.labelledBy}-${this.code}-${choice.id}`;
    return (index.h("span", null, index.h("input", { name: this.code, id: id, "aria-labelledby": this.labelledBy, class: "bp-sdk-radio__choice", type: "radio", value: choice.id, checked: this._choiceId === choice.id, onChange: () => {
        this._choiceId = choice.id;
      } }), index.h("label", { htmlFor: id, class: this.controlClasses }, index.h("span", null, choice.value))));
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-radio-input", { answeredBySource: this.answeredBySource, answerId: this.answerId, choiceId: this.choiceId, choices: this.choices, code: this.code, errorText: this.errorText, errors: this.errors, fieldType: this.fieldType, helpText: this.helpText, isCompleted: this.isCompleted, isReadOnly: this.isReadOnly, label: this.label, labelledBy: this.labelledBy, pristine: this.pristine, questionId: this.questionId, required: this.required, touched: this.touched }));
  }
  renderInternal() {
    var _a;
    let input;
    if (this.isReadOnly) {
      const selectedChoice = (this.choices || []).find((choice) => this.choiceId === choice.id);
      input = this.renderReadOnlyElement(selectedChoice === null || selectedChoice === void 0 ? void 0 : selectedChoice.value);
    }
    else {
      input = index.h("div", { class: "bp-sdk-radio__choice-list" }, this.choices.map((choice) => this.renderChoice(choice)));
    }
    return (index.h("div", { class: "bp-sdk-radio__container" }, index.h("div", { role: "group", class: "bp-sdk-radio__wrapper" }, index.h("fieldset", null, index.h("legend", { class: "bp-sdk-radio__text" }, index.h("div", { innerHTML: this.label })), input, this.touched && !this.pristine && ((this.errorText && !this.isCompleted) || !!((_a = this.errors) === null || _a === void 0 ? void 0 : _a.length)) && (index.h("bp-sdk-errors-container", { answerId: this.answerId, questionId: this.questionId, fieldType: this.fieldType, errors: this.errors, errorText: this.errorText }))))));
  }
  renderReadOnlyElement(value) {
    return index.h("span", { class: "read-only-value" }, value);
  }
  get el() { return index.getElement(this); }
  static get watchers() { return {
    "touched": ["onControlChange"],
    "choiceId": ["onChoiceIdChange"],
    "_choiceId": ["onChange"]
  }; }
};
BpSdkRadioInput.style = bpSdkRadioInputCss;

const bpSdkSelectInputCss = "bp-sdk-select-input .bp-sdk-select__container{position:relative;min-width:10rem;max-width:100vw}.bp-sdk-hidden{position:fixed;top:-100rem}.bp-sdk-no-selection{user-select:none}.bp-sdk-visually-hidden{display:none}.bp-sdk-align-right{margin-left:auto}.bp-sdk-select__button-arrow{font-size:20px}.bp-sdk-select__list{background:white;border:1px solid #aaa;left:0;overflow-y:auto;margin:0;max-height:15rem;padding-left:0;position:absolute;width:100%;z-index:1}.bp-sdk-select__button{width:100%;height:2.5rem;background-color:white;display:flex;padding:0.5rem;justify-items:center;align-items:center;cursor:pointer}.bp-sdk-select__list-item{display:block;position:relative;font-size:16px;padding-left:1rem;padding-right:1rem;cursor:pointer}";

const selectButtonIdPrefix = 'select-btn-';
const keyboardNavigation = {
  next: ['ArrowRight', 'ArrowDown'],
  previous: ['ArrowLeft', 'ArrowUp'],
  select: ['Enter', ' '],
};
let BpSdkSelectInput = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.valueUpdate = index.createEvent(this, "valueUpdate", 7);
    this.removeActiveAnswer = index.createEvent(this, "removeActiveAnswer", 7);
    this.updateActiveAnswer = index.createEvent(this, "updateActiveAnswer", 7);
    /**
     * Placeholder to display
     */
    this.placeholder = '';
    /**
     * Use alias for choices
     */
    this.useAlias = false;
    /**
     * Choice ids selected. Used for multiple selection.
     */
    this.choiceIds = [];
    /**
     * Whether to allow multi-select.
     */
    this.multiple = false;
    /**
     * Choices to display
     */
    this.choices = [];
    /**
     * Is Touched
     */
    this.touched = false;
    /**
     * Is Pristine
     */
    this.pristine = true;
    /**
     * Is answer in complete state
     */
    this.isCompleted = false;
    /**
     * When true, the field will be readonly. It will display only the label and value as plain text.
     */
    this.isReadOnly = false;
    this.choice = [];
    this._value = [];
    this.showSelectList = false;
    this.selectText = '';
    this.focusedIndex = 0;
    this.selectButtonId = `${selectButtonIdPrefix}${index_esm_min.fx(8)}`;
    this.accumulateFilter = true;
    this.currentFilterText = '';
    this.useExternal = false;
    this.onKeydown = (event) => {
      const key = event.key;
      const isTab = key === 'Tab';
      if ((key !== 'Shift' && key !== 'Meta' && key !== 'Alt' && key !== 'Control' && !isTab) || (isTab && this.showSelectList)) {
        event.preventDefault();
        this.handleKeyEvent(key);
      }
    };
    this.onChange = (event) => {
      event.preventDefault();
      this.updateTextDisplayed(event.target.value);
    };
    this.clickSelectItem = (choiceId) => {
      let ctrlValue = choiceId || this.choice;
      if (this.multiple) {
        ctrlValue = this.getControlValue(choiceId);
      }
      else {
        this.clickSelectButton();
      }
      this.removeActiveAnswer.emit();
      this.choice = this._value = Array.isArray(ctrlValue) ? ctrlValue : [ctrlValue];
      this.updateTextDisplayed(ctrlValue);
    };
    this.delayedClickSelectItem = debounce.debounce_1(this.clickSelectItem, 8);
    this.updateTextDisplayed = debounce.debounce_1((choiceValue) => {
      if (this.multiple && Array.isArray(choiceValue) && choiceValue.length > 0) {
        this.updateMultiSelectText(choiceValue);
      }
      else if (choiceValue && typeof choiceValue === 'string') {
        this.updateSingleSelectText(choiceValue);
      }
      else {
        this.selectText = this.placeholder || '';
      }
    }, 20);
    this.listenToTextFilter = debounce.debounce_1((newValue) => this.handleTextEntry(newValue), 500);
    this.onSubmitButtonClick = ($event) => this.selectFocus($event);
    this.onAutocomplete = (e) => {
      const value = e.target.value;
      const choice = this.choices.find((choice) => choice.value === value);
      this.delayedClickSelectItem(choice.id);
    };
    this.onListBlur = () => {
      this.showSelectList = false;
    };
    this.onChoiceClick = (choice) => (e) => {
      e.stopPropagation();
      e.preventDefault();
      this.delayedClickSelectItem(choice.id);
    };
  }
  onAriaLabelledByChange(labelId) {
    this.updateLabelledBy(labelId, this.labelledBy);
  }
  onLabelledByChange(labelledBy) {
    this.updateLabelledBy(this.labelId, labelledBy);
  }
  updateLabelledBy(aria, ids) {
    const prefix = ids ? `${ids} ` : '';
    this._labelledBy = `${prefix}${aria !== null && aria !== void 0 ? aria : ''}` || undefined;
  }
  onCodeChange(newValue) {
    this.selectButtonId = `${selectButtonIdPrefix}${newValue}`;
  }
  onChoiceIdChange(choice) {
    this.choice = [choice];
    this.updateTextDisplayed(choice);
  }
  onChoiceIdsChange(choiceIds, oldIds) {
    if (isEqual.isEqual_1(choiceIds, oldIds)) {
      return;
    }
    this.choice = choiceIds;
    this.updateTextDisplayed(choiceIds);
  }
  onShowSelectListChange(showList) {
    if (showList) {
      this.el.dispatchEvent(new FocusEvent('focusin', { bubbles: true }));
      this.updateActiveAnswer.emit(this.answerId);
    }
    else {
      this.removeActiveAnswer.emit();
    }
  }
  resetState() {
    this.showSelectList = false;
    this.accumulateFilter = true;
    this.currentFilterText = '';
  }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-select-input');
    customElements.whenDefined('bp-sdk-external-select-input').then(() => {
      this.useExternal = true;
    });
    this.onChoiceIdChange(this.choiceId);
    this.onChoiceIdsChange(this.choiceIds, []);
    this.onAriaLabelledByChange(this.labelId);
    this.onLabelledByChange(this.labelledBy);
  }
  focusOption(index) {
    this.showSelectList = true;
    this.focusedIndex = this.getSelectableIndex(index);
    setTimeout(() => {
      const optionList = this.el.querySelector('.bp-sdk-select__list');
      const element = optionList.children[this.focusedIndex];
      element.focus();
    }, 0);
  }
  selectFocus(e) {
    e.stopPropagation();
    e.preventDefault();
    if (!this.showSelectList) {
      this.focusElement();
    }
    else {
      this.showSelectList = false;
    }
  }
  focusElement() {
    this.showSelectList = true;
    this.el.dispatchEvent(new FocusEvent('focusin'));
    let focusIndex = 0;
    if (!this.multiple && this.choice.length) {
      const choiceId = this.choice[0];
      focusIndex = this.choices.findIndex((choice) => choice.id === choiceId);
    }
    this.focusOption(focusIndex);
  }
  choiceText(choice) {
    return this.useAlias && choice.alias ? choice.alias : choice.value;
  }
  getControlValue(choiceId) {
    if (this.isChosen(choiceId)) {
      return this.choice.filter((id) => id !== choiceId);
    }
    else {
      return [...this.choice, choiceId];
    }
  }
  clickSelectButton() {
    this.showSelectList = false;
    const selectButton = this.el.querySelector('.bp-sdk-select__button');
    selectButton === null || selectButton === void 0 ? void 0 : selectButton.focus();
  }
  isChosen(choiceId) {
    return (this.choice || []).includes(choiceId);
  }
  handleKeyEvent(keyName) {
    const options = this.getKeyEventOptions(keyName);
    const indexToSelect = this.getIndexToSelect(keyName, options);
    this.mapKeyEventToAction(keyName, indexToSelect, options);
  }
  getKeyEventOptions(keyName) {
    const goToNext = keyboardNavigation.next.includes(keyName);
    const goToPrevious = keyboardNavigation.previous.includes(keyName);
    const addToFilter = !goToNext && !goToPrevious && !!keyName && keyName !== ' ';
    const isOpenOrSelectKey = keyboardNavigation.select.includes(keyName) || (keyName === 'Tab' && this.showSelectList);
    const openSelectList = isOpenOrSelectKey && !this.showSelectList;
    return {
      goToNext,
      goToPrevious,
      shouldMoveIndex: goToPrevious || goToNext,
      addToFilter,
      isOpenOrSelectKey,
      openSelectList,
    };
  }
  getIndexToSelect(keyName, { goToPrevious, shouldMoveIndex, isOpenOrSelectKey }) {
    let indexToSelect;
    if (isOpenOrSelectKey && this.showSelectList) {
      indexToSelect = this.focusedIndex;
    }
    else if (keyName === 'Escape') {
      this.showSelectList = false;
    }
    else if (shouldMoveIndex && !this.showSelectList) {
      indexToSelect = !this.choice ? 0 : this.focusedIndex + (goToPrevious ? -1 : 1);
    }
    return indexToSelect;
  }
  mapKeyEventToAction(keyName, indexToSelect, { openSelectList, shouldMoveIndex, goToPrevious, addToFilter, }) {
    if (openSelectList) {
      this.focusOption(this.focusedIndex);
    }
    else if (typeof indexToSelect === 'number') {
      this.selectOptionByIndex(indexToSelect);
    }
    else if (shouldMoveIndex && this.showSelectList) {
      this.focusOption(this.focusedIndex + (goToPrevious ? -1 : 1));
    }
    else if (addToFilter) {
      this.filterText(keyName);
    }
  }
  selectOptionByIndex(index) {
    const selectableIndex = this.getSelectableIndex(index);
    this.focusedIndex = selectableIndex;
    const choice = this.choices[this.focusedIndex];
    this.delayedClickSelectItem(choice.id);
  }
  updateMultiSelectText(choiceIds) {
    const selectedChoices = this.choices.filter((c) => choiceIds.findIndex((id) => id === c.id) > -1);
    if (selectedChoices.length > 0) {
      this.selectText = selectedChoices.map((c) => (this.useAlias ? c.alias : c.value)).join(', ');
    }
  }
  updateSingleSelectText(choiceValue) {
    const choice = this.choices.find((c) => c.id === choiceValue);
    if (choice) {
      this.selectText = this.useAlias ? choice.alias : choice.value;
    }
  }
  onValueChange(newValue, oldValue) {
    if (index_esm_min.Fe(newValue, oldValue)) {
      this.valueUpdate.emit(newValue);
    }
  }
  filterText(newValue) {
    let result = newValue;
    if (!this.accumulateFilter) {
      this.accumulateFilter = true;
    }
    else {
      result = this.currentFilterText + newValue;
    }
    this.currentFilterText = result;
    this.listenToTextFilter(result);
  }
  handleTextEntry(text) {
    var _a;
    this.accumulateFilter = false;
    const indexToFocus = (_a = (text && this.choices.findIndex((choice) => this.choiceText(choice).toLowerCase().startsWith(text.toLowerCase())))) !== null && _a !== void 0 ? _a : -1;
    const choice = this.choices[indexToFocus];
    if (this.showSelectList) {
      this.focusOption(indexToFocus);
    }
    else if (choice) {
      this.delayedClickSelectItem(choice.id);
    }
  }
  getSelectableIndex(index) {
    const lastIndex = this.choices.length - 1;
    const selectableIndex = index <= 0 ? 0 : index > lastIndex ? lastIndex : index;
    return selectableIndex;
  }
  handleOutsideClick() {
    this.showSelectList = false;
  }
  renderSubmitButton() {
    return (index.h("button", { type: "button", class: index_esm_min.ix('bp-sdk-select__button', {
        'bp-sdk-touched': this.touched,
        'bp-sdk-pristine': this.pristine,
      }), "aria-haspopup": "listbox", disabled: !this.choices.length, "aria-labelledby": this._labelledBy || '' + ' ' + this.selectButtonId, onClick: this.onSubmitButtonClick, id: this.selectButtonId, "aria-label": this.selectText || this.placeholder, "aria-describedby": index_esm_min.ax(index_esm_min.dx(this.errors)) || undefined }, this.selectText || this.placeholder, index.h("span", { class: "bp-sdk-align-right bp-sdk-select__button-arrow" }, "\u25BE")));
  }
  renderHiddenOptions() {
    return (index.h("select", { "aria-hidden": true, tabindex: "-1", class: "bp-sdk-hidden", autocomplete: this.autoComplete, multiple: this.multiple, onInput: this.onAutocomplete }, this.choices.map((choice) => (index.h("option", { onClick: this.onChoiceClick(choice), selected: this.isChosen(choice.id), value: choice.value }, choice.alias)))));
  }
  renderMultiSelectChoices(choice) {
    return (index.h("label", { htmlFor: `bp-sdk-select__list-${this.answerId}-item__input-${choice.id}`, id: `bp-sdk-select__list-${this.answerId}-item__label-${choice.id}`, class: "bp-sdk-select-list-item-label" }, index.h("span", { class: "bp-sdk-no-selection" }, this.choiceText(choice)), index.h("input", { id: `bp-sdk-select__list-${this.answerId}-item__input-${choice.id}`, class: `bp-sdk-select__list-item-content bp-sdk-select__list-item-input bp-sdk-select__list-item-content-${this.code} bp-sdk-select__list-item-input-${this.code}`, type: "checkbox", checked: this.isChosen(choice.id), placeholder: this.choiceText(choice) })));
  }
  renderSingleSelectChoices(choice) {
    return (index.h("span", { class: `bp-sdk-select__list-item-content bp-sdk-select__list-item-text bp-sdk-select__list-item-content-${this.code} bp-sdk-select__list-item-text-${choice.id}` }, this.choiceText(choice)));
  }
  renderChoice(choice) {
    return [this.multiple && this.renderMultiSelectChoices(choice), !this.multiple && this.renderSingleSelectChoices(choice)];
  }
  renderChoices() {
    return this.choices.map((choice, i) => (index.h("li", { onClick: this.onChoiceClick(choice), "aria-labelledby": this.labelId, class: index_esm_min.ix(`bp-sdk-select__list-item bp-sdk-select__list-item-${choice.id}`, {
        'bp-sdk-select__list-item-selected': this.isChosen(choice.id),
      }), role: "option", "aria-selected": (this.focusedIndex === i).toString(), tabindex: "1" }, this.renderChoice(choice))));
  }
  renderVisibleOptions() {
    return (index.h("ul", { class: index_esm_min.ix('bp-sdk-select__list', {
        'bp-sdk-visually-hidden': !this.showSelectList,
      }), "aria-expanded": this.showSelectList, role: "listbox", "aria-labelledby": this.labelId, tabindex: "-1", onBlur: this.onListBlur }, this.renderChoices()));
  }
  renderOptions() {
    return [this.renderHiddenOptions(), this.renderVisibleOptions()];
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-select-input", { answerId: this.answerId, autoComplete: this.autoComplete, choiceId: this.choiceId, choiceIds: this.choiceIds, choices: this.choices, code: this.code, errorText: this.errorText, errors: this.errors, fieldType: this.fieldType, helpText: this.helpText, answeredBySource: this.answeredBySource, isCompleted: this.isCompleted, isReadOnly: this.isReadOnly, labelId: this.labelId, label: this.label, labelledBy: this.labelledBy, multiple: this.multiple, placeholder: this.placeholder, pristine: this.pristine, questionId: this.questionId, required: this.required, touched: this.touched, useAlias: this.useAlias, value: this.value }));
  }
  renderInternal() {
    var _a;
    let input;
    if (this.isReadOnly) {
      const selectedIds = [this.choiceId, ...(this.choiceIds || [])];
      const selectedChoices = (this.choices || [])
        .filter((choice) => selectedIds.includes(choice.id))
        .map((choice) => this.choiceText(choice))
        .join(', ');
      input = this.renderReadOnlyElement(selectedChoices);
    }
    else {
      input = [this.renderSubmitButton(), this.renderOptions()];
    }
    return (index.h("div", { class: "bp-sdk-select__container", onKeyDown: this.onKeydown }, index.h("label", { id: this.labelId, htmlFor: this.selectButtonId, class: "bp-sdk-label bp-sdk-select__label", innerHTML: this.label }), input, this.touched && !this.pristine && ((this.errorText && !this.isCompleted) || !!((_a = this.errors) === null || _a === void 0 ? void 0 : _a.length)) && (index.h("bp-sdk-errors-container", { answerId: this.answerId, questionId: this.questionId, fieldType: this.fieldType, errors: this.errors, errorText: this.errorText }))));
  }
  renderReadOnlyElement(value) {
    return index.h("span", { class: "read-only-value" }, value);
  }
  get el() { return index.getElement(this); }
  static get watchers() { return {
    "labelId": ["onAriaLabelledByChange"],
    "labelledBy": ["onLabelledByChange"],
    "code": ["onCodeChange"],
    "choiceId": ["onChoiceIdChange"],
    "choiceIds": ["onChoiceIdsChange"],
    "showSelectList": ["onShowSelectListChange"],
    "_value": ["onValueChange"]
  }; }
};
BpSdkSelectInput.style = bpSdkSelectInputCss;

const bpSdkSelectInputContainerCss = "";

let BpSdkSelectInputContainer = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    /**
     * Placeholder to display
     */
    this.placeholder = '';
    /**
     * Use alias for choices
     */
    this.useAlias = false;
    /**
     * Choice ids selected. Used for multiple selection.
     */
    this.choiceIds = [];
    /**
     * Whether to allow multi-select.
     */
    this.multiple = false;
    /**
     * Choices to display
     */
    this.choices = [];
    /**
     * Is Touched
     */
    this.touched = false;
    /**
     * Is Pristine
     */
    this.pristine = true;
    /**
     * Is answer in complete state
     */
    this.isCompleted = false;
    /**
     * When true, the field will be readonly. It will display only the label and value as plain text.
     */
    this.isReadOnly = false;
    this.useExternal = false;
    this.handleSubscriptions = () => {
      if (store.canGetStore()) {
        this.storeUnsubscribe && this.storeUnsubscribe();
        this.storeUnsubscribe = store.store.mapStateToProps(this, this.mapStateToProps);
      }
    };
    this.mapStateToProps = (state) => {
      return {
        isAutocompleteEnabled: sdkRedux.isAutocompleteEnabled(state),
      };
    };
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
    this.handleSubscriptions();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-select-input-container');
    customElements.whenDefined('bp-sdk-external-select-input-container').then(() => {
      this.useExternal = true;
    });
    this.handleSubscriptions();
    this.updateAutocomplete({
      referenceType: this.referenceType,
      code: this.code,
      fieldType: this.fieldType,
      isAutocompleteEnabled: this.isAutocompleteEnabled,
    });
  }
  onReferenceTypeChange(referenceType) {
    this.updateAutocomplete({
      referenceType,
      code: this.code,
      fieldType: this.fieldType,
      isAutocompleteEnabled: this.isAutocompleteEnabled,
    });
  }
  onCodeChange(code) {
    this.updateAutocomplete({
      referenceType: this.referenceType,
      code,
      fieldType: this.fieldType,
      isAutocompleteEnabled: this.isAutocompleteEnabled,
    });
  }
  onFieldTypeChange(fieldType) {
    this.updateAutocomplete({
      referenceType: this.referenceType,
      code: this.code,
      fieldType,
      isAutocompleteEnabled: this.isAutocompleteEnabled,
    });
  }
  onIsAutocompleteEnabledChange(isAutocompleteEnabled) {
    this.updateAutocomplete({
      referenceType: this.referenceType,
      code: this.code,
      fieldType: this.fieldType,
      isAutocompleteEnabled,
    });
  }
  updateAutocomplete({ code, fieldType, referenceType, isAutocompleteEnabled, }) {
    this.autoComplete = isAutocompleteEnabled ? index_esm_min.o4({ referenceType, code, fieldType }) : undefined;
  }
  disconnectedCallback() {
    this.storeUnsubscribe && this.storeUnsubscribe();
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-select-input-container", { answerId: this.answerId, choiceId: this.choiceId, choiceIds: this.choiceIds, choices: this.choices, code: this.code, errors: this.errors, errorText: this.errorText, fieldType: this.fieldType, helpText: this.helpText, answeredBySource: this.answeredBySource, isCompleted: this.isCompleted, isReadOnly: this.isReadOnly, label: this.label, labelId: this.labelId, labelledBy: this.labelledBy, multiple: this.multiple, placeholder: this.placeholder, pristine: this.pristine, questionId: this.questionId, referenceType: this.referenceType, required: this.required, touched: this.touched, useAlias: this.useAlias, value: this.value }));
  }
  renderInternal() {
    return (index.h("bp-sdk-select-input", { answerId: this.answerId, autoComplete: this.autoComplete, choiceId: this.choiceId, choiceIds: this.choiceIds, choices: this.choices, code: this.code, errors: this.errors, errorText: this.errorText, helpText: this.helpText, answeredBySource: this.answeredBySource, fieldType: this.fieldType, isCompleted: this.isCompleted, isReadOnly: this.isReadOnly, label: this.label, labelId: this.labelId, labelledBy: this.labelledBy, multiple: this.multiple, placeholder: this.placeholder, pristine: this.pristine, questionId: this.questionId, required: this.required, touched: this.touched, useAlias: this.useAlias }));
  }
  get el() { return index.getElement(this); }
  static get watchers() { return {
    "referenceType": ["onReferenceTypeChange"],
    "code": ["onCodeChange"],
    "fieldType": ["onFieldTypeChange"],
    "isAutocompleteEnabled": ["onIsAutocompleteEnabledChange"]
  }; }
};
BpSdkSelectInputContainer.style = bpSdkSelectInputContainerCss;

const bpSdkTextInputCss = "";

let BpSdkTextInput = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.valueUpdate = index.createEvent(this, "valueUpdate", 7);
    /**
     * Field type
     */
    this.fieldType = 'text';
    /**
     * Placeholder to display
     */
    this.placeholder = '';
    /**
     * Is question required
     */
    this.required = false;
    /**
     * minimum length of input
     */
    this.min = -1;
    /**
     * maximum length of input
     */
    this.max = -1;
    /**
     * Error messages
     */
    this.errors = [];
    /**
     * is touched
     */
    this.touched = false;
    /**
     * is pristine
     */
    this.pristine = true;
    /**
     * Is answer in complete state
     */
    this.isCompleted = false;
    /**
     * When true, the field will be readonly. It will display only the label and value as plain text.
     */
    this.isReadOnly = false;
    /**
     * Is enabled
     */
    this.isEnabled = true;
    this._pattern = '';
    this._fieldType = 'text';
    this.useExternal = false;
    this.onChange = () => {
      const input = this.el.querySelector('.bp-sdk-text__input');
      this.valueUpdate.emit(input.value);
    };
  }
  updatePattern(fieldType, pattern) {
    if (fieldType === index_esm_min$1.t.Number && !pattern) {
      pattern = '^\\d*';
    }
    else if (!pattern) {
      pattern = undefined;
    }
    this._pattern = pattern;
  }
  onAriaLabelledByChange(labelId) {
    this.updateLabelledBy(labelId, this.labelledBy);
  }
  onLabelledByChange(labelledBy) {
    this.updateLabelledBy(this.labelId, labelledBy);
  }
  updateLabelledBy(aria, ids) {
    const prefix = ids ? `${ids} ` : '';
    this._labelledBy = `${prefix}${aria !== null && aria !== void 0 ? aria : ''}` || undefined;
  }
  onFieldTypeChange(fieldType) {
    let type;
    if (fieldType === index_esm_min$1.t.Number) {
      type = 'tel';
    }
    else {
      type = fieldType !== null && fieldType !== void 0 ? fieldType : 'text';
    }
    this._fieldType = type;
    this.updatePattern(fieldType, this.pattern);
  }
  onPatternChange(pattern) {
    this.updatePattern(this.fieldType, pattern);
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
  }
  handleExternalComponents() {
    this.useExternal = !!customElements.get('bp-sdk-external-text-input');
    customElements.whenDefined('bp-sdk-external-text-input').then(() => {
      this.useExternal = true;
    });
  }
  componentWillLoad() {
    this.handleExternalComponents();
    this.onFieldTypeChange(this.fieldType);
    this.onPatternChange(this.pattern);
    this.onAriaLabelledByChange(this.labelId);
    this.onLabelledByChange(this.labelledBy);
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderTextInput() {
    var _a, _b;
    return (index.h("input", { "aria-describedby": index_esm_min.ax(index_esm_min.dx(this.errors)) || undefined, "aria-label": this.placeholder && !this.label ? this.placeholder : null, "aria-labelledby": this._labelledBy, autocomplete: this.autoComplete, class: "bp-sdk-text__input", disabled: !this.isEnabled, id: `bp-sdk-text-${this.labelId}__input-${this.answerId}`, maxLength: (_a = this.max) !== null && _a !== void 0 ? _a : -1, minLength: (_b = this.min) !== null && _b !== void 0 ? _b : -1, name: this.code, onChange: this.onChange, onInput: this.onChange, onPaste: this.onChange, pattern: this._pattern, placeholder: this.placeholder || '', required: this.required, type: this._fieldType, value: this.text }));
  }
  renderNumberInput() {
    var _a, _b;
    return (index.h("input", { "aria-describedby": index_esm_min.ax(index_esm_min.dx(this.errors)) || undefined, "aria-label": this.placeholder && !this.label ? this.placeholder : null, "aria-labelledby": this._labelledBy, autocomplete: this.autoComplete, class: "bp-sdk-text__input", disabled: !this.isEnabled, id: `bp-sdk-text-${this.labelId}__input-${this.answerId}`, max: (_a = this.max) !== null && _a !== void 0 ? _a : Number.MAX_VALUE, min: (_b = this.min) !== null && _b !== void 0 ? _b : Number.MIN_VALUE, name: this.code, onChange: this.onChange, onInput: this.onChange, onPaste: this.onChange, pattern: this._pattern, placeholder: this.placeholder || '', required: this.required, type: this._fieldType, value: this.text }));
  }
  renderInputElement() {
    return this.fieldType === index_esm_min$1.t.Number ? this.renderNumberInput() : this.renderTextInput();
  }
  renderExternal() {
    return (index.h("bp-sdk-external-text-input", { answerId: this.answerId, autoComplete: this.autoComplete, code: this.code, errorText: this.errorText, errors: this.errors, fieldType: this.fieldType, helpText: this.helpText, answeredBySource: this.answeredBySource, isCompleted: this.isCompleted, isEnabled: this.isEnabled, isReadOnly: this.isReadOnly, labelId: this.labelId, label: this.label, labelledBy: this.labelledBy, max: this.max, min: this.min, pattern: this.pattern, placeholder: this.placeholder, pristine: this.pristine, questionId: this.questionId, readonly: this.isReadOnly, required: this.required, text: this.text, touched: this.touched }));
  }
  renderLabel() {
    return (this.label && (index.h("label", { id: this.labelId, htmlFor: `bp-sdk-text__${this.labelId}__input}-${this.answerId}`, class: "bp-sdk-label bp-sdk-text__label", innerHTML: this.label })));
  }
  renderErrors() {
    var _a;
    return (this.touched &&
      !this.pristine &&
      ((this.errorText && !this.isCompleted) || !!((_a = this.errors) === null || _a === void 0 ? void 0 : _a.length)) && (index.h("bp-sdk-errors-container", { questionId: this.questionId, fieldType: this.fieldType, pattern: this.pattern, min: this.min, max: this.max, errors: this.errors, errorText: this.errorText })));
  }
  renderInternal() {
    const element = this.isReadOnly ? this.renderReadOnlyElement(this.text) : this.renderInputElement();
    return (index.h("span", { class: "bp-sdk-text__container" }, this.renderLabel(), element, this.renderErrors()));
  }
  renderReadOnlyElement(value) {
    return index.h("span", { class: "read-only-value" }, value);
  }
  get el() { return index.getElement(this); }
  static get watchers() { return {
    "labelId": ["onAriaLabelledByChange"],
    "labelledBy": ["onLabelledByChange"],
    "fieldType": ["onFieldTypeChange"],
    "pattern": ["onPatternChange"]
  }; }
};
BpSdkTextInput.style = bpSdkTextInputCss;

const bpSdkTextInputContainerCss = "";

let BpSdkTextInputContainer = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    /**
     * Field type
     */
    this.fieldType = 'text';
    /**
     * Placeholder to display
     */
    this.placeholder = '';
    /**
     * Is question required
     */
    this.required = false;
    /**
     * minimum length of input
     */
    this.min = -1;
    /**
     * maximum length of input
     */
    this.max = -1;
    /**
     * Error messages
     */
    this.errors = [];
    /**
     * is touched
     */
    this.touched = false;
    /**
     * is pristine
     */
    this.pristine = true;
    /**
     * Is answer in complete state
     */
    this.isCompleted = false;
    /**
     * When true, the field will be readonly. It will display only the label and value as plain text.
     */
    this.isReadOnly = false;
    /**
     * Is enabled
     */
    this.isEnabled = true;
    this.useExternal = false;
    this._vinErrors = [];
    this.handleSubscriptions = () => {
      if (store.canGetStore()) {
        this.storeUnsubscribe && this.storeUnsubscribe();
        this.storeUnsubscribe = store.store.mapStateToProps(this, this.mapStateToProps);
      }
    };
    this.mapStateToProps = (state) => {
      return {
        isAutocompleteEnabled: sdkRedux.isAutocompleteEnabled(state),
      };
    };
  }
  resetState() {
    this._vinErrors = [];
  }
  connectedCallback() {
    this.resetState();
    this.handleSubscriptions();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-text-input-container');
    customElements.whenDefined('bp-sdk-external-text-input-container').then(() => {
      this.useExternal = true;
    });
    this.handleSubscriptions();
    this.updateAutocomplete({
      referenceType: this.referenceType,
      code: this.code,
      fieldType: this.fieldType,
      isAutocompleteEnabled: this.isAutocompleteEnabled,
    });
    this.onValueUpdate({
      detail: this.text,
    });
  }
  onValueUpdate(evt) {
    if (this.referenceType === index_esm_min$1.u.CommercialAutoVIN) {
      if (vehicleVin_service.VehicleVinService.isValidVin(evt.detail)) {
        this._vinErrors = [];
        this.errorText = undefined;
      }
      else {
        this.touched = true;
        this.pristine = false;
        this._vinErrors = [vehicleVin_service.VehicleVinService.getValidationErrorMessage(evt.detail)];
        this.errorText = vehicleVin_service.VehicleVinService.getValidationErrorMessage(evt.detail);
      }
    }
  }
  onReferenceTypeChange(referenceType) {
    this.updateAutocomplete({
      referenceType,
      code: this.code,
      fieldType: this.fieldType,
      isAutocompleteEnabled: this.isAutocompleteEnabled,
    });
  }
  onCodeChange(code) {
    this.updateAutocomplete({
      referenceType: this.referenceType,
      code,
      fieldType: this.fieldType,
      isAutocompleteEnabled: this.isAutocompleteEnabled,
    });
  }
  onFieldTypeChange(fieldType) {
    this.updateAutocomplete({
      referenceType: this.referenceType,
      code: this.code,
      fieldType,
      isAutocompleteEnabled: this.isAutocompleteEnabled,
    });
  }
  onIsAutocompleteEnabledChange(isAutocompleteEnabled) {
    this.updateAutocomplete({
      referenceType: this.referenceType,
      code: this.code,
      fieldType: this.fieldType,
      isAutocompleteEnabled,
    });
  }
  updateAutocomplete({ code, fieldType, referenceType, isAutocompleteEnabled, }) {
    this.autoComplete = isAutocompleteEnabled ? index_esm_min.o4({ referenceType, code, fieldType }) : undefined;
  }
  disconnectedCallback() {
    this.storeUnsubscribe && this.storeUnsubscribe();
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-text-input-container", { answerId: this.answerId, code: this.code, errorText: this.errorText, errors: [...this._vinErrors, ...this.errors], fieldType: this.fieldType, helpText: this.helpText, answeredBySource: this.answeredBySource, isAutocompleteEnabled: this.isAutocompleteEnabled, isCompleted: this.isCompleted, isEnabled: this.isEnabled, isReadOnly: this.isReadOnly, labelId: this.labelId, label: this.label, labelledBy: this.labelledBy, max: this.max, min: this.min, pattern: this.pattern, placeholder: this.placeholder, pristine: this.pristine, questionId: this.questionId, referenceType: this.referenceType, required: this.required, text: this.text, touched: this.touched }));
  }
  renderInternal() {
    return [
      index.h("bp-sdk-text-input", { answerId: this.answerId, autoComplete: this.autoComplete, code: this.code, errorText: this.errorText, errors: [...this._vinErrors, ...this.errors], fieldType: this.fieldType, helpText: this.helpText, answeredBySource: this.answeredBySource, isCompleted: this.isCompleted, isEnabled: this.isEnabled, isReadOnly: this.isReadOnly, labelId: this.labelId, label: this.label, labelledBy: this.labelledBy, max: this.max, min: this.min, pattern: this.pattern, placeholder: this.placeholder, pristine: this.pristine, questionId: this.questionId, required: this.required, text: this.text, touched: this.touched }),
    ];
  }
  get el() { return index.getElement(this); }
  static get watchers() { return {
    "referenceType": ["onReferenceTypeChange"],
    "code": ["onCodeChange"],
    "fieldType": ["onFieldTypeChange"],
    "isAutocompleteEnabled": ["onIsAutocompleteEnabledChange"]
  }; }
};
BpSdkTextInputContainer.style = bpSdkTextInputContainerCss;

exports.bp_sdk_add_item_container = BpSdkAddItemContainer;
exports.bp_sdk_add_question_pool_item_container = BpSdkAddQuestionPoolItemContainer;
exports.bp_sdk_autocomplete_input = BpSdkAutocompleteInput;
exports.bp_sdk_autocomplete_naics_container = BpSdkAutocompleteNaicsContainer;
exports.bp_sdk_business_classification_selector = BpSdkBusinessClassificationSelector;
exports.bp_sdk_business_classification_selector_card_body = BpSdkBusinessClassificationSelectorCardBody;
exports.bp_sdk_business_classification_selector_card_content = BpSdkBusinessClassificationSelectorCardContent;
exports.bp_sdk_business_classification_selector_card_header = BpSdkBusinessClassificationSelectorCardHeader;
exports.bp_sdk_business_classification_selector_container = BpSdkBusinessClassificationSelectorContainer;
exports.bp_sdk_business_classification_selector_list = BpSdkBusinessClassificationSelectorList;
exports.bp_sdk_business_classification_selector_list_container = BpSdkBusinessClassificationSelectorListContainer;
exports.bp_sdk_business_classification_selector_list_item = BpSdkBusinessClassificationSelectorListItem;
exports.bp_sdk_business_classification_selector_list_item_container = BpSdkBusinessClassificationSelectorListItemContainer;
exports.bp_sdk_business_classification_selector_naics_group = BpSdkBusinessClassificationSelectorNaicsGroup;
exports.bp_sdk_business_classification_selector_naics_group_header = BpSdkBusinessClassificationSelectorNaicsGroupHeader;
exports.bp_sdk_business_classification_selector_nudge = BpSdkBusinessClassificationSelectorNudge;
exports.bp_sdk_business_classification_selector_nudge_container = BpSdkBusinessClassificationSelectorNudgeContainer;
exports.bp_sdk_business_classification_selector_relevance_chip = BpSdkBusinessClassificationSelectorRelevanceChip;
exports.bp_sdk_checkbox_input = BpSdkCheckboxInput;
exports.bp_sdk_date_input = BpSdkDateInput;
exports.bp_sdk_date_input_container = BpSdkDateInputContainer;
exports.bp_sdk_delete_button = BpSdkDeleteButton;
exports.bp_sdk_delete_question_pool_item = BpSdkDeleteQuestionPoolItem;
exports.bp_sdk_delete_question_pool_item_container = BpSdkDeleteQuestionPoolItemContainer;
exports.bp_sdk_dialog = BpSdkDialog;
exports.bp_sdk_dialog_close_button = BpSdkDialogCloseButton;
exports.bp_sdk_driver_input_container = BpSdkDriverInputContainer;
exports.bp_sdk_google_places_autocomplete = BpSdkGooglePlacesAutocomplete;
exports.bp_sdk_google_places_autocomplete_container = BpSdkGooglePlacesAutocompleteContainer;
exports.bp_sdk_icon_container = BpSdkIconContainer;
exports.bp_sdk_increment_input = BpSdkIncrementInput;
exports.bp_sdk_label = BpSdkLabel;
exports.bp_sdk_masked_input = BpSdkMaskedInput;
exports.bp_sdk_masked_input_button = BpSdkMaskedInputButton;
exports.bp_sdk_masked_input_container = BpSdkMaskedInputContainer;
exports.bp_sdk_parent_question_pool_selector = BpSdkParentQuestionPoolSelector;
exports.bp_sdk_product_list = BpSdkProductList;
exports.bp_sdk_product_list_container = BpSdkProductListContainer;
exports.bp_sdk_question_pool_container = BpSdkQuestionPoolContainer;
exports.bp_sdk_radio_dialog = BpSdkRadioDialog;
exports.bp_sdk_radio_input = BpSdkRadioInput;
exports.bp_sdk_select_input = BpSdkSelectInput;
exports.bp_sdk_select_input_container = BpSdkSelectInputContainer;
exports.bp_sdk_text_input = BpSdkTextInput;
exports.bp_sdk_text_input_container = BpSdkTextInputContainer;
